VERSION 4.00
Begin VB.Form FakeTestForm 
   Caption         =   "Pointer Faking Test"
   ClientHeight    =   2805
   ClientLeft      =   2550
   ClientTop       =   1545
   ClientWidth     =   4110
   Height          =   3210
   Left            =   2490
   LinkTopic       =   "Form1"
   ScaleHeight     =   2805
   ScaleWidth      =   4110
   Top             =   1200
   Width           =   4230
   Begin VB.CommandButton CmdSearchList 
      Caption         =   "Search List"
      Enabled         =   0   'False
      Height          =   495
      Left            =   1440
      TabIndex        =   11
      Top             =   600
      Width           =   1215
   End
   Begin VB.Frame Frame1 
      Caption         =   "Times"
      Height          =   1455
      Left            =   120
      TabIndex        =   4
      Top             =   1200
      Width           =   3855
      Begin VB.TextBox CollectionTimeText 
         BackColor       =   &H8000000F&
         Height          =   285
         Left            =   2280
         Locked          =   -1  'True
         TabIndex        =   9
         Top             =   240
         Width           =   615
      End
      Begin VB.TextBox ReferenceTimeText 
         BackColor       =   &H8000000F&
         Height          =   285
         Left            =   2280
         Locked          =   -1  'True
         TabIndex        =   6
         Top             =   600
         Width           =   615
      End
      Begin VB.TextBox FakeTimeText 
         BackColor       =   &H8000000F&
         Height          =   285
         Left            =   2280
         Locked          =   -1  'True
         TabIndex        =   5
         Top             =   960
         Width           =   615
      End
      Begin VB.Label Label1 
         Caption         =   "Collection of references"
         Height          =   255
         Index           =   3
         Left            =   360
         TabIndex        =   10
         Top             =   240
         Width           =   1695
      End
      Begin VB.Label Label1 
         Caption         =   "Linked list of references"
         Height          =   255
         Index           =   1
         Left            =   360
         TabIndex        =   8
         Top             =   600
         Width           =   1695
      End
      Begin VB.Label Label1 
         Caption         =   "Pointer faking"
         Height          =   255
         Index           =   2
         Left            =   360
         TabIndex        =   7
         Top             =   960
         Width           =   1575
      End
   End
   Begin VB.CommandButton CmdDestroyList 
      Caption         =   "Destroy List"
      Enabled         =   0   'False
      Height          =   495
      Left            =   2760
      TabIndex        =   3
      Top             =   600
      Width           =   1215
   End
   Begin VB.CommandButton CmdCreateList 
      Caption         =   "Create List"
      Height          =   495
      Left            =   120
      TabIndex        =   2
      Top             =   600
      Width           =   1215
   End
   Begin VB.TextBox NumLinksText 
      Height          =   285
      Left            =   1440
      TabIndex        =   0
      Text            =   "1000"
      Top             =   120
      Width           =   735
   End
   Begin VB.Label Label1 
      Caption         =   "Number of items"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "FakeTestForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' FakeTest.FRM
'
' Main form for pointer faking example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

' For the list using a collection of references.
Dim ReferenceCollection As Collection

' For the list using a linked list of references.
Dim TopReferenceType As ReferenceType

' For the list using pointer faking.
Dim FakerList() As FakerType
Dim TopFaker As Integer

' ************************************************
' Create a list using the three methods.
' ************************************************
Private Sub CmdCreateList_Click()
Dim num As Long
Dim i As Long
Dim start_time As Single
Dim obj As ReferenceType

    On Error Resume Next
    num = CLng(NumLinksText.Text)
    If num < 1 Then
        Beep
        MsgBox "Please enter an integer greater than zero."
        NumLinksText.SetFocus
        Exit Sub
    End If
    On Error GoTo 0
    
    CollectionTimeText.Text = ""
    ReferenceTimeText.Text = ""
    FakeTimeText.Text = ""
    MousePointer = vbHourglass
    DoEvents
    
    start_time = Timer
    
    ' Fill the collection of references.
    Set ReferenceCollection = New Collection
    For i = 1 To num
        Set obj = New ReferenceType
        obj.Value = i
        ReferenceCollection.Add obj, Format$(i)
    Next i
    CollectionTimeText.Text = _
        Format$(Timer - start_time, "0.00")
    DoEvents
    start_time = Timer
    
    ' Create the list using references.
    Set TopReferenceType = New ReferenceType
    Set TopReferenceType.NextReference = Nothing
    For i = 1 To num
        Set obj = New ReferenceType
        With obj
            .Value = i
            Set .NextReference = TopReferenceType
        End With
        Set TopReferenceType = obj
    Next i
    ReferenceTimeText.Text = _
        Format$(Timer - start_time, "0.00")
    DoEvents
    start_time = Timer
    
    ' Create the list using pointer faking.
    ReDim FakerList(1 To num)
    TopFaker = 1
    For i = 1 To num
        With FakerList(i)
            .Value = i
            .NextFaker = i + 1
        End With
    Next i
    FakerList(num).NextFaker = 0
    
    FakeTimeText.Text = _
        Format$(Timer - start_time, "0.00")
    
    CmdCreateList.Enabled = False
    CmdSearchList.Enabled = True
    CmdDestroyList.Enabled = True

    MousePointer = vbDefault
End Sub

' ************************************************
' Destroy the lists using the three methods.
' ************************************************
Private Sub CmdDestroyList_Click()
Dim i As Long
Dim start_time As Single
Dim obj As ReferenceType

    CollectionTimeText.Text = ""
    ReferenceTimeText.Text = ""
    FakeTimeText.Text = ""
    MousePointer = vbHourglass
    DoEvents
    
    start_time = Timer
    
    ' Destroy the list using a collection.
    ' It is fastest to remove the items from the
    ' collection first in reverse order.
    For i = ReferenceCollection.Count To 1 Step -1
        ReferenceCollection.Remove i
    Next i
    Set ReferenceCollection = Nothing
    CollectionTimeText.Text = _
        Format$(Timer - start_time, "0.00")
    DoEvents
    start_time = Timer
    
    ' Destroy the list using references.
    Set TopReferenceType = Nothing
    ReferenceTimeText.Text = _
        Format$(Timer - start_time, "0.00")
    DoEvents
    start_time = Timer
    
    ' Destroy the list using pointer faking.
    Erase FakerList
    TopFaker = 0
    
    FakeTimeText.Text = _
        Format$(Timer - start_time, "0.00")
    
    CmdCreateList.Enabled = True
    CmdSearchList.Enabled = False
    CmdDestroyList.Enabled = False

    MousePointer = vbDefault
End Sub

' ************************************************
' Search the lists using the three methods.
' ************************************************
Private Sub CmdSearchList_Click()
Dim num As Long
Dim i As Long
Dim txti As String
Dim start_time As Single
Dim obj As ReferenceType
Dim fake_obj As Long

    CollectionTimeText.Text = ""
    ReferenceTimeText.Text = ""
    FakeTimeText.Text = ""
    MousePointer = vbHourglass
    DoEvents
    
    start_time = Timer
    
    ' Find items using the collection.
    num = ReferenceCollection.Count
    For i = 1 To num
        txti = Format$(i)
        Set obj = ReferenceCollection.Item(txti)
    Next i
    CollectionTimeText.Text = _
        Format$(Timer - start_time, "0.00")
    DoEvents
    start_time = Timer
    
    ' Find the items using the list of references.
    For i = 1 To num
        Set obj = TopReferenceType
        Do While obj.Value <> i
            Set obj = obj.NextReference
        Loop
    Next i
    ReferenceTimeText.Text = _
        Format$(Timer - start_time, "0.00")
    DoEvents
    start_time = Timer
    
    ' Find the items using pointer faking.
    For i = 1 To num
        fake_obj = TopFaker
        Do While FakerList(fake_obj).Value <> i
            fake_obj = FakerList(fake_obj).NextFaker
        Loop
    Next i
    
    FakeTimeText.Text = _
        Format$(Timer - start_time, "0.00")
    
    MousePointer = vbDefault
End Sub


