VERSION 4.00
Begin VB.Form PagerForm 
   Appearance      =   0  'Flat
   Caption         =   "Pager"
   ClientHeight    =   1845
   ClientLeft      =   3495
   ClientTop       =   2085
   ClientWidth     =   2295
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   2535
   Icon            =   "Pager.frx":0000
   Left            =   3435
   LinkTopic       =   "Form1"
   ScaleHeight     =   1845
   ScaleWidth      =   2295
   Top             =   1455
   Width           =   2415
   Begin VB.TextBox TimeText 
      BackColor       =   &H8000000F&
      Height          =   285
      Left            =   1440
      Locked          =   -1  'True
      TabIndex        =   5
      Top             =   1440
      Width           =   735
   End
   Begin VB.CommandButton CmdThrash 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Thrash"
      Height          =   495
      Left            =   1320
      TabIndex        =   4
      Top             =   720
      Width           =   855
   End
   Begin VB.CommandButton CmdPage 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Page"
      Default         =   -1  'True
      Height          =   495
      Left            =   120
      TabIndex        =   2
      Top             =   720
      Width           =   855
   End
   Begin VB.TextBox MemText 
      Height          =   285
      Left            =   1440
      TabIndex        =   0
      Top             =   240
      Width           =   735
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      BackStyle       =   0  'Transparent
      Caption         =   "Time (sec)"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   3
      Top             =   1440
      Width           =   1215
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      BackStyle       =   0  'Transparent
      Caption         =   "Memory (MB)"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   1
      Top             =   240
      Width           =   1215
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "PagerForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' PAGER.BAS
'
' Example program that allocates lots of memory
' to cause paging and thrashing.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************

Option Explicit

Dim Memory() As Long

Private Sub CmdPage_Click()
    RunTest False
    MemText.SetFocus
End Sub

Private Sub CmdThrash_Click()
    RunTest True
    MemText.SetFocus
End Sub

Private Sub MemText_GotFocus()
    MemText.SelStart = 0
    MemText.SelLength = Len(MemText.Text)
End Sub


Private Sub mnuFileExit_Click()
    End
End Sub

Private Sub mnuHelpAbout_Click()
Dim txt As String

    txt = "       This program allows you to allocate bigger and bigger arrays until paging occurs." & vbCrLf
    txt = txt & "        Page: The program allocates the indicated amount of memory and traverses it in an orderly fashion. This will cause paging if the array is larger than the amount of real memory your computer has." & vbCrLf
    txt = txt & "        Thrash: The program allocates the indicated amount of memory and accesses it randomly. This will cause LOTS of paging if the array is larger than the amount of real memory your computer has." & vbCrLf
    txt = txt & "        Note that the times shown will probably be less than the actual time you wait for the program. This is because the time shown does not include time to allocate the array."

    MsgBox txt, vbOKOnly, "Help About... Pager"
End Sub
' ************************************************
' Run the test.
' ************************************************
Private Sub RunTest(thrash As Boolean)
Const LONGS_PER_MEG = 1048576 / 4

Static megs As Integer

Dim new_megs As Integer
Dim max_index As Long
Dim start_time As Double
Dim i As Long
Dim index As Long

    On Error Resume Next
    new_megs = CInt(MemText.Text)
    If new_megs < 1 Then
        Beep
        MsgBox "Please enter an integer greater than 0."
        MemText.SetFocus
        Exit Sub
    End If
    On Error GoTo 0
    
    TimeText.Text = ""
    MousePointer = vbHourglass
    DoEvents

    ' Allocate the memory
    max_index = new_megs * LONGS_PER_MEG
    If new_megs <> megs Then
        ReDim Memory(1 To max_index)
        megs = new_megs
    End If
    
    ' Traverse the memory to cause paging
    start_time = Timer
    If thrash Then
        ' Jump all over to causing thrashing.
        For i = 1 To max_index
            index = Int(max_index * Rnd) + 1
            Memory(index) = i
        Next i
    Else
        ' Walk through memory to page without
        ' thrashing. Notice the random assignment
        ' of index so this version does about as
        ' much work as the thrashing version.
        For i = 1 To max_index
            index = Int(max_index * Rnd) + 1
            Memory(i) = i
        Next i
    End If

    TimeText.Text = _
        Format$(Timer - start_time, "0.00")
    MousePointer = vbDefault
    Beep
End Sub

