VERSION 4.00
Begin VB.Form FlowForm 
   AutoRedraw      =   -1  'True
   Caption         =   "Flow []"
   ClientHeight    =   4140
   ClientLeft      =   1275
   ClientTop       =   1755
   ClientWidth     =   6690
   FillColor       =   &H00FFFFFF&
   FillStyle       =   0  'Solid
   Height          =   4830
   Left            =   1215
   LinkTopic       =   "Form1"
   ScaleHeight     =   276
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   446
   Top             =   1125
   Width           =   6810
   Begin VB.Label FlowLabel 
      BorderStyle     =   1  'Fixed Single
      Caption         =   "0"
      Height          =   255
      Left            =   840
      TabIndex        =   1
      Top             =   0
      Width           =   495
   End
   Begin VB.Label Label1 
      Caption         =   "Total Flow"
      Height          =   255
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   855
   End
   Begin MSComDlg.CommonDialog FileDialog 
      Left            =   120
      Top             =   480
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   327681
      CancelError     =   -1  'True
      DefaultExt      =   ".net"
      FileName        =   "*.net"
      Filter          =   "Network Files (*.net)|*.net|All Files (*.*)|*.*"
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileNew 
         Caption         =   "&New"
         Shortcut        =   ^N
      End
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open..."
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileSave 
         Caption         =   "&Save"
         Shortcut        =   ^S
      End
      Begin VB.Menu mnuFileSaveAs 
         Caption         =   "Save &As..."
         Shortcut        =   ^A
      End
      Begin VB.Menu mnuFileSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "&Edit"
      Begin VB.Menu mnuEditMode 
         Caption         =   "New &Node"
         Index           =   1
      End
      Begin VB.Menu mnuEditMode 
         Caption         =   "New &Link"
         Index           =   2
      End
      Begin VB.Menu mnuEditMode 
         Caption         =   "Delete Node"
         Index           =   3
      End
      Begin VB.Menu mnuEditMode 
         Caption         =   "Delete Link"
         Index           =   4
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "FlowForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Flow.FRM
'
' Main form for maximum flow example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Dim Nodes As Collection
Dim Links As Collection
Dim MaxId As Integer    ' The Maximum node ID used.

Dim FileName As String  ' Name of loaded data file.
Dim FileTitle As String ' FileName without path.
Dim Modified As Boolean ' True if data is modified.

Dim EditMode As Integer ' The editing mode.

Const EDIT_MODE_NONE = 0
Const EDIT_MODE_NEW_NODE = 1
Const EDIT_MODE_NEW_LINK = 2
Const EDIT_MODE_NEW_LINK2 = 22
Const EDIT_MODE_DELETE_NODE = 3
Const EDIT_MODE_DELETE_LINK = 4
Const EDIT_MODE_DELETE_LINK2 = 42

' Nodes for manipulating links.
Dim node_1 As FlowNode
Dim node_2 As FlowNode

' Used for drawing and node selection.
Const RADIUS = 10

' Node path tree status values.
Const NOT_IN_LIST = 0
Const NOW_IN_LIST = 1
Const WAS_IN_LIST = 2

Const INFINITY = 32767

' Source and sink nodes.
Dim SourceNode As FlowNode
Dim SinkNode As FlowNode

Dim TotalFlow As Integer
' ************************************************
' Create a new node.
' ************************************************
Private Sub CreateNode(X As Single, Y As Single)
Dim node As New FlowNode

    MaxId = MaxId + 1
    node.Id = MaxId
    node.X = X
    node.Y = Y
    Nodes.Add node, Str$(node.Id)

    ' Clear the shortest path tree.
    ResetFlows
    
    ' Redraw the network.
    DrawNetwork

    ' The data has been modified.
    Modified = True
    Caption = "Flow*[" & FileTitle & "]"
End Sub
' ************************************************
' Return true if the data is safely saved.
' ************************************************
Private Function DataSafe() As Boolean
    If Not Modified Then
        DataSafe = True
        Exit Function
    End If
    
    Select Case _
        MsgBox("Save changes to the network?", _
            vbYesNoCancel, "Save Changes?")
        Case vbYes  ' mnuFileSave will set Modifed.
            mnuFileSave_Click
            DataSafe = (Not Modified)
        Case vbNo   ' It's OK to lose the changes.
            DataSafe = True
        Case vbCancel   ' Stop the exit.
            DataSafe = False
    End Select
End Function

' ************************************************
' Delete the node from the network.
' ************************************************
Private Sub DeleteNode(node As FlowNode)
Dim link As FlowLink

    If node Is Nothing Then Exit Sub

    ' Remove links to this node.
    Do While node.Links.Count > 0
        Set link = node.Links(1)
        DeleteLink link.Node1, link.Node2
    Loop
    
    ' Remove the node from the Nodes list.
    Nodes.Remove Str$(node.Id)

    ' Clear the shortest path tree.
    ResetFlows
    
    ' Redraw the network.
    DrawNetwork

    ' The data has been modified.
    Modified = True
    Caption = "Flow*[" & FileTitle & "]"
End Sub
' ************************************************
' Display the network.
' ************************************************
Private Sub DrawNetwork()
Dim node As FlowNode
Dim link As FlowLink
Dim node_id As Integer
Dim dx As Single
Dim dy As Single
Dim Dist As Single
Dim x1 As Single
Dim y1 As Single
Dim x2 As Single
Dim y2 As Single
Dim i As Integer
Dim txt As String

    Cls
    
    ' Draw the links.
    FillColor = BackColor
    For Each link In Links
        If link.Flow <> 0 Then
            ' The following two lines seeme to be
            ' needed to make VB5 draw all of these
            ' lines with width 3.
            ForeColor = vbRed
            DrawWidth = 4
            ForeColor = vbBlue
            DrawWidth = 3
            Font.Bold = True
        Else
            ForeColor = vbBlack
            DrawWidth = 1
            Font.Bold = False
        End If
        
        x1 = link.Node1.X
        y1 = link.Node1.Y
        x2 = link.Node2.X
        y2 = link.Node2.Y
        dx = x2 - x1
        dy = y2 - y1
        Dist = Sqr(dx * dx + dy * dy)
        If Dist > 0 Then
            dx = dx * RADIUS / Dist
            dy = dy * RADIUS / Dist
            
            ' Draw the link.
            x1 = x1 + dx
            y1 = y1 + dy
            x2 = x2 - dx
            y2 = y2 - dy
            Line (x1, y1)-(x2, y2)
            
            ' Draw an arrow head.
            If link.Flow > 0 Then
                Line (x2, y2)-Step(dy - dx, -dx - dy)
                Line (x2, y2)-Step(-dy - dx, dx - dy)
            ElseIf link.Flow < 0 Then
                Line (x1, y1)-Step(dy + dx, -dx + dy)
                Line (x1, y1)-Step(-dy + dx, dx + dy)
            End If
            
            ' Draw the link flow and capacity.
            x1 = (x1 + x2) / 2
            y1 = (y1 + y2) / 2
            
            DrawStyle = vbInvisible
            Circle (x1, y1), RADIUS * 1.5
            DrawStyle = vbSolid
            
            txt = Abs(Format$(link.Flow)) & _
                "/" & Format$(link.Capacity)
            CurrentX = x1 - TextWidth(txt) / 2
            CurrentY = y1 - TextHeight(txt) / 2
            Print txt
        End If
    Next link
    DrawWidth = 1
    Font.Bold = False
    
    ' Draw the nodes.
    For Each node In Nodes
        ' Draw the node and its links.
        If node Is node_1 Or node Is node_2 Then
            ' Highlight the node.
            FillColor = vbBlack
            ForeColor = vbWhite
        Else
            ' Do not highlight the node.
            FillColor = vbWhite
            ForeColor = vbBlack
        End If

        ' Use a thick circle if it's the source or sink.
        If node Is SourceNode Or node Is SinkNode Then
            DrawWidth = 3
        Else
            DrawWidth = 1
        End If

        ' Draw the node.
        Circle (node.X, node.Y), RADIUS
        txt = Format$(node.Id)
        CurrentX = node.X - TextWidth(txt) / 2
        CurrentY = node.Y - TextHeight(txt) / 2
        Print txt
    Next node
    ForeColor = vbBlack
    
    FlowLabel.Caption = Format$(TotalFlow)
End Sub

' ************************************************
' Load the network data from a file with format:
'   # Nodes, # Links
'   For each node: Id, X, Y
'   For each link: Node1, Node2, Capacity
' ************************************************
Private Sub LoadNetwork(ByVal fname As String, ByVal ftitle As String)
Dim Id As Integer
Dim X As Single
Dim Y As Single
Dim fnum As Integer
Dim i As Integer
Dim num_nodes As Integer
Dim num_links As Integer
Dim node1_num As Integer
Dim node2_num As Integer
Dim link_capacity As Integer
Dim id1 As String
Dim id2 As String
Dim node_1 As FlowNode
Dim node_2 As FlowNode
Dim node As FlowNode
Dim link As FlowLink

    ' Open the file.
    On Error GoTo OpenError
    fnum = FreeFile
    Open fname For Input As fnum

    ' Start a new network.
    NewNetwork
    
    ' Read the number of nodes and links.
    Input #fnum, num_nodes, num_links
    
    ' Read the node identifiers and coordinates.
    MaxId = 0
    For i = 1 To num_nodes
        Set node = New FlowNode
        Input #fnum, Id, X, Y
        node.Id = Id
        node.X = X
        node.Y = Y
        Nodes.Add node, Str$(node.Id)
        If node.Id > MaxId Then MaxId = node.Id
    Next i
    
    ' Read the links.
    For i = 1 To num_links
        Input #fnum, node1_num, node2_num, link_capacity
        id1 = Str$(node1_num)
        id2 = Str$(node2_num)
        Set link = New FlowLink
        Links.Add link, id1 & "-" & id2
        Set node_1 = Nodes(id1)
        Set node_2 = Nodes(id2)
        Set link.Node1 = node_1
        Set link.Node2 = node_2
        link.Capacity = link_capacity
        node_1.Links.Add link, id2
        node_2.Links.Add link, id1
    Next i
    
    ' Close the file.
    On Error GoTo CloseError
    Close #fnum
    
    ' The network has not yet been modified.
    Modified = False
    FileName = fname
    FileTitle = ftitle
    Caption = "Flow [" & FileTitle & "]"
    Exit Sub

OpenError:
    Beep
    MsgBox "Error" & Str$(Err.Number) & _
        " opening network file """ & FileName & _
        """." & vbCrLf & Err.Description
    Exit Sub

ReadError:
    Beep
    MsgBox "Error" & Str$(Err.Number) & _
        " reading network file """ & FileName & _
        """." & vbCrLf & Err.Description
    Nodes.Clear
    Exit Sub

CloseError:
    Beep
    MsgBox "Error closing file """ & FileName & _
        """." & vbCrLf & Err.Description
    Exit Sub
End Sub

' ************************************************
' Make a new link.
' ************************************************
Private Sub CreateLink(node_1 As FlowNode, node_2 As FlowNode)
Dim link_capacity As Integer
Dim link As FlowLink
Dim id1 As String
Dim id2 As String

    If node_1 Is Nothing Or node_2 Is Nothing Then _
        Exit Sub
    
    ' Do not allow links from a node to itself.
    If node_1 Is node_2 Then
        Beep
        MsgBox "You cannot make a link between a node and itself.", _
            vbOKOnly, "Invalid Link"
        Exit Sub
    End If
    
    id1 = Str$(node_1.Id)
    id2 = Str$(node_2.Id)
    
    ' Do not allow duplicate links.
    On Error Resume Next
    Set link = node_1.Links(id2)
    If Err.Number = 0 Then
        On Error GoTo 0
        Beep
        MsgBox "There is already a link between these nodes.", _
            vbOKOnly, "Link Exists"
        Exit Sub
    End If
    On Error GoTo 0

    ' Create the link.
    link_capacity = InputBox("Link Capacity")

    Set link = New FlowLink
    Links.Add link, id1 & "-" & id2
    Set link.Node1 = node_1
    Set link.Node2 = node_2
    link.Capacity = link_capacity
    node_1.Links.Add link, id2
    node_2.Links.Add link, id1
    
    ' Clear the shortest path tree.
    ResetFlows
    
    ' Redraw the network.
    DrawNetwork

    ' The data has been modified.
    Modified = True
    Caption = "Flow*[" & FileTitle & "]"
End Sub
' ************************************************
' Delete a link.
' ************************************************
Private Sub DeleteLink(node_1 As FlowNode, node_2 As FlowNode)
Dim id1 As String
Dim id2 As String

    If node_1 Is Nothing Or node_2 Is Nothing Then _
        Exit Sub

    id1 = Str$(node_1.Id)
    id2 = Str$(node_2.Id)
    
    On Error Resume Next
    ' Delete from the nodes' Links collections.
    node_1.Links.Remove id2
    node_2.Links.Remove id1
    
    ' Delete from the global Links collections.
    Links.Remove id1 & "-" & id2
    Links.Remove id2 & "-" & id1
    On Error GoTo 0
    
    ' Clear the shortest path tree.
    ResetFlows
    
    ' Redraw the network.
    DrawNetwork

    ' The data has been modified.
    Modified = True
    Caption = "Flow*[" & FileTitle & "]"
End Sub
' ************************************************
' Reset the edit mode.
' ************************************************
Private Sub ResetEditMode()
    EditMode = EDIT_MODE_NONE
    MousePointer = vbDefault
    Set node_1 = Nothing
    Set node_2 = Nothing
End Sub

' ************************************************
' Save the network data into a file with format:
'   # Nodes, # Links
'   For each node: Id, X, Y
'   For each link: Node1, Node2, Capacity
' ************************************************
Private Sub SaveNetwork(ByVal fname As String, ByVal ftitle As String)
Dim fnum As Integer
Dim node As FlowNode
Dim link As FlowLink

    ' Open the file.
    On Error GoTo OpenError
    fnum = FreeFile
    Open fname For Output As fnum
    
    ' Save the number of nodes and links.
    Write #fnum, Nodes.Count, Links.Count
    
    ' Save the node identifiers and coordinates.
    For Each node In Nodes
        Write #fnum, node.Id, node.X, node.Y
    Next node
    
    ' Save the link information.
    For Each link In Links
        Write #fnum, link.Node1.Id, link.Node2.Id, link.Capacity
    Next link
    
    ' Close the file.
    On Error GoTo CloseError
    Close #fnum
    
    Modified = False
    FileName = fname
    FileTitle = ftitle
    Caption = "Flow [" & FileTitle & "]"
    Exit Sub

OpenError:
    Beep
    MsgBox "Error" & Str$(Err.Number) & _
        " opening file """ & FileName & _
        """." & vbCrLf & Err.Description
    Exit Sub

ReadError:
    Beep
    MsgBox "Error" & Str$(Err.Number) & _
        " saving network file """ & FileName & _
        """." & vbCrLf & Err.Description
    Nodes.Clear
    Exit Sub

CloseError:
    Beep
    MsgBox "Error closing file """ & FileName & _
        """." & vbCrLf & Err.Description
    Exit Sub
End Sub
' ************************************************
' Start a new network.
' ************************************************
Private Sub NewNetwork()
Dim node As FlowNode
    
    ' Destroy all links.
    For Each node In Nodes
        Set node.Links = Nothing
    Next node

    ' Create new Nodes and Links collections.
    Set Links = New Collection
    Set Nodes = New Collection
    
    Set SourceNode = Nothing
    Set SinkNode = Nothing
    Set node_1 = Nothing
    Set node_2 = Nothing
    
    ' The new network has not yet been modified.
    TotalFlow = 0
    ResetEditMode
    Modified = False
    FileName = ""
    FileTitle = ""
    Caption = "Flow []"
End Sub
' ************************************************
' Find the node clicked.
' ************************************************
Private Function SelectNode(X As Single, Y As Single) As FlowNode
Dim node As FlowNode
Dim dx As Single
Dim dy As Single
Dim radius2 As Single

    radius2 = RADIUS * RADIUS
    For Each node In Nodes
        dx = node.X - X
        dy = node.Y - Y
        If dx * dx + dy * dy <= radius2 Then
            Set SelectNode = node
            Exit Function
        End If
    Next node
End Function

' ************************************************
' Initialize.
' ************************************************
Private Sub Form_Load()
    ' Make the file dialog start in the working
    ' directory.
    FileDialog.InitDir = App.Path
    
    ' Create an empty network.
    Set Nodes = New Collection
    Set Links = New Collection
End Sub
' ************************************************
' Present help about the program.
' ************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String

    txt = "This program uses an augmenting path algorithm to compute maximum flows through a network." & vbCrLf & vbCrLf
    txt = txt & "Click on a node with the left mouse button to select that node as the source node. Click with the right button to select the sink node." & vbCrLf & vbCrLf
    txt = txt & "Once you have selected a source and a sink, the program will compute and display the maximum flows from the source to the sink."
    
    MsgBox txt, vbOKOnly, "Help About ... Flow"
End Sub
' ************************************************
' Perform an edit mode appropriate task.
' ************************************************
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim node As FlowNode

    Select Case EditMode
        Case EDIT_MODE_NONE     ' Find the shorest path tree.
            If Button And vbLeftButton Then
                ' Left button. Select the source.
                Set SourceNode = SelectNode(X, Y)
                FindMaxFlows
            Else
                ' Right button. Select the sink.
                Set SinkNode = SelectNode(X, Y)
                FindMaxFlows
            End If
        Case EDIT_MODE_NEW_NODE ' Put a node here.
            CreateNode X, Y
            EditMode = EDIT_MODE_NONE
        Case EDIT_MODE_NEW_LINK ' Select node 1.
            Set node_1 = SelectNode(X, Y)
            If node_1 Is Nothing Then
                EditMode = EDIT_MODE_NONE
            Else
                EditMode = EDIT_MODE_NEW_LINK2
            End If
        Case EDIT_MODE_NEW_LINK2 ' Make a link.
            Set node_2 = SelectNode(X, Y)
            CreateLink node_1, node_2
            EditMode = EDIT_MODE_NONE
        Case EDIT_MODE_DELETE_NODE ' Delete node 1.
            DeleteNode SelectNode(X, Y)
            EditMode = EDIT_MODE_NONE
        Case EDIT_MODE_DELETE_LINK ' Select node 1.
            Set node_1 = SelectNode(X, Y)
            If node_1 Is Nothing Then
                EditMode = EDIT_MODE_NONE
            Else
                EditMode = EDIT_MODE_DELETE_LINK2
            End If
        Case EDIT_MODE_DELETE_LINK2 ' Delete a link.
            Set node_2 = SelectNode(X, Y)
            DeleteLink node_1, node_2
            EditMode = EDIT_MODE_NONE
    End Select

    If EditMode = EDIT_MODE_NONE Then
        MousePointer = vbDefault
        Set node_1 = Nothing
        Set node_2 = Nothing
    End If
    
    DrawNetwork
End Sub
' ************************************************
' Find the maximum flows.
' ************************************************
Private Sub FindMaxFlows()
Dim candidates As Collection

Dim Residual() As Integer
Dim num_nodes As Integer
Dim id1 As Integer
Dim id2 As Integer
Dim node As FlowNode
Dim to_node As FlowNode
Dim from_node As FlowNode
Dim link As FlowLink
Dim min_residual As Integer

    If SourceNode Is Nothing Or SinkNode Is Nothing _
        Then Exit Sub
    
    ' Dimension the Residual array.
    num_nodes = Nodes.Count
    ReDim Residual(1 To num_nodes, 1 To num_nodes)

    ' Initially the residual values are the same
    ' as the capacities.
    For Each node In Nodes
        id1 = node.Id
        For Each link In node.Links
            If link.Node1 Is node Then
                Set to_node = link.Node2
            Else
                Set to_node = link.Node1
            End If
            id2 = to_node.Id
            Residual(id1, id2) = link.Capacity
        Next link
    Next node

    ' Repeat until we can find no more
    ' augmenting paths.
    Do
        ' Find an augmenting path in the residual
        ' network.

        ' Reset the nodes' NodeStatus and InLink values.
        For Each node In Nodes
            node.NodeStatus = NOT_IN_LIST
            Set node.InLink = Nothing
        Next node

        ' Start with an empty candidate list.
        Set candidates = New Collection
        
        ' Put the source on the candidate list.
        candidates.Add SourceNode
        SourceNode.NodeStatus = NOW_IN_LIST
        
        ' Repeat until the candidate list is empty.
        Do While candidates.Count > 0
            Set node = candidates(1)
            candidates.Remove 1
            node.NodeStatus = WAS_IN_LIST
            id1 = node.Id
            
            ' Examine the links out of this node.
            For Each link In node.Links
                If link.Node1 Is node Then
                    Set to_node = link.Node2
                Else
                    Set to_node = link.Node1
                End If
                id2 = to_node.Id

                ' See if the residual > 0 and this
                ' node has never been on the list.
                If Residual(id1, id2) > 0 And _
                    to_node.NodeStatus = NOT_IN_LIST _
                Then
                    ' Add it to the list.
                    candidates.Add to_node
                    to_node.NodeStatus = NOW_IN_LIST
                    Set to_node.InLink = link
                End If
            Next link

            ' Stop if the sink has been labeled.
            If Not (SinkNode.InLink Is Nothing) Then _
                Exit Do
        Loop

        ' Stop if we found no augmenting path.
        If SinkNode.InLink Is Nothing Then Exit Do

        ' Find the smallest residual along the
        ' augmenting path.
        min_residual = INFINITY
        Set node = SinkNode
        Do
            If node Is SourceNode Then Exit Do
            id2 = node.Id
            
            Set link = node.InLink
            If link.Node1 Is node Then
                Set from_node = link.Node2
            Else
                Set from_node = link.Node1
            End If
            id1 = from_node.Id

            If min_residual > Residual(id1, id2) Then _
                min_residual = Residual(id1, id2)
            
            Set node = from_node
        Loop

        ' Update the residuals using the
        ' augmenting path.
        Set node = SinkNode
        Do
            If node Is SourceNode Then Exit Do
            id2 = node.Id

            Set link = node.InLink
            If link.Node1 Is node Then
                Set from_node = link.Node2
            Else
                Set from_node = link.Node1
            End If
            id1 = from_node.Id

            Residual(id1, id2) = Residual(id1, id2) _
                - min_residual
            Residual(id2, id1) = Residual(id2, id1) _
                + min_residual
            Set node = from_node
        Loop
    Loop ' Repeat until there are no more augmenting paths.

    ' Calculate the flows from the residuals.
    For Each link In Links
        id1 = link.Node1.Id
        id2 = link.Node2.Id
        If link.Capacity > Residual(id1, id2) Then
            link.Flow = link.Capacity - Residual(id1, id2)
        Else
            ' Negative to indicate backwards.
            link.Flow = Residual(id2, id1) - link.Capacity
        End If
    Next link
    
    ' Find the total flow.
    TotalFlow = 0
    For Each link In SourceNode.Links
        TotalFlow = TotalFlow + Abs(link.Flow)
    Next link
End Sub
' ************************************************
' Rerset the flows.
' ************************************************
Private Sub ResetFlows()
Dim link As FlowLink
    
    For Each link In Links
        link.Flow = 0
    Next link
    Set SourceNode = Nothing
    Set SinkNode = Nothing
End Sub
' ************************************************
' Make sure the data is safe before exiting.
' ************************************************
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Cancel = (Not DataSafe())
End Sub

' ************************************************
' Enter the new editing mode.
' ************************************************
Private Sub mnuEditMode_Click(Index As Integer)
    EditMode = Index
    
    Select Case EditMode
        Case EDIT_MODE_NEW_NODE, _
             EDIT_MODE_DELETE_NODE
                MousePointer = vbCrosshair
        Case EDIT_MODE_NEW_LINK, _
             EDIT_MODE_DELETE_LINK
                MousePointer = vbSizeNESW
    End Select
End Sub

' ************************************************
' End the application. Note that Form_QueryUnload
' ensures that the data is safe.
' ************************************************
Private Sub mnuFileExit_Click()
    Unload Me
End Sub


' ************************************************
' Start a new network.
' ************************************************
Private Sub mnuFileNew_Click()
    ' Make sure the current data is safe.
    If Not DataSafe() Then Exit Sub

    ' Start the new network.
    NewNetwork
    
    ' Display the empty network.
    DrawNetwork
End Sub
' ************************************************
' Load a network file.
' ************************************************
Private Sub mnuFileOpen_Click()
Dim status As Long

    ' Make sure the current data is safe.
    If Not DataSafe() Then Exit Sub
    
    ' Prepare the file selection dialog
    FileDialog.Flags = cdlOFNFileMustExist
    FileDialog.FileName = ""
    
    On Error Resume Next
    FileDialog.ShowOpen
    status = Err
    On Error GoTo 0

    If status = cdlCancel Then Exit Sub
    If status <> 0 Then
        Beep
        MsgBox "Error" & Str$(status) & _
            " selecting file." & vbCrLf & _
            Error(status)
        Exit Sub
    End If

    FileDialog.InitDir = _
        Left$(FileDialog.FileName, _
            Len(FileDialog.FileName) - _
            Len(FileDialog.FileTitle))
    LoadNetwork FileDialog.FileName, FileDialog.FileTitle
    
    ' Display the network.
    DrawNetwork
End Sub

' ************************************************
' Save the file using the current FileName.
' ************************************************
Private Sub mnuFileSave_Click()
    ' Make sure we have a file name.
    If FileName = "" Then
        mnuFileSaveAs_Click
        Exit Sub
    End If
    
    ' Save the network.
    SaveNetwork FileName, FileTitle
End Sub


' ************************************************
' Save the network in a file selected by the user.
' ************************************************
Private Sub mnuFileSaveAs_Click()
Dim status As Long

    ' Prepare the file selection dialog
    FileDialog.Flags = cdlOFNOverwritePrompt
    FileDialog.FileName = FileTitle

    On Error Resume Next
    FileDialog.ShowSave
    status = Err
    On Error GoTo 0

    If status = cdlCancel Then Exit Sub
    If status <> 0 Then
        Beep
        MsgBox "Error" & Str$(status) & _
            " selecting file." & vbCrLf & _
            Error(status)
        Exit Sub
    End If

    FileDialog.InitDir = _
        Left$(FileDialog.FileName, _
            Len(FileDialog.FileName) - _
            Len(FileDialog.FileTitle))
    
    ' Save the network.
    SaveNetwork FileDialog.FileName, FileDialog.FileTitle
End Sub

