VERSION 4.00
Begin VB.Form WorkForm 
   AutoRedraw      =   -1  'True
   Caption         =   "Work"
   ClientHeight    =   2940
   ClientLeft      =   1275
   ClientTop       =   1755
   ClientWidth     =   7110
   FillColor       =   &H00FFFFFF&
   FillStyle       =   0  'Solid
   Height          =   3630
   Left            =   1215
   LinkTopic       =   "Form1"
   ScaleHeight     =   196
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   474
   Top             =   1125
   Width           =   7230
   Begin VB.CommandButton CmdGo 
      Caption         =   "Go"
      Height          =   375
      Left            =   1680
      TabIndex        =   8
      Top             =   0
      Width           =   615
   End
   Begin VB.TextBox AssignmentText 
      BackColor       =   &H8000000F&
      Height          =   2175
      Left            =   4800
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   4
      Top             =   720
      Width           =   2295
   End
   Begin VB.TextBox JobText 
      Height          =   2175
      Left            =   2400
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   3
      Text            =   "Work.frx":0000
      Top             =   720
      Width           =   2295
   End
   Begin VB.TextBox EmployeeText 
      Height          =   2175
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   2
      Text            =   "Work.frx":0094
      Top             =   720
      Width           =   2295
   End
   Begin VB.Label label1 
      Alignment       =   2  'Center
      Caption         =   "Assignments"
      Height          =   255
      Index           =   3
      Left            =   4800
      TabIndex        =   7
      Top             =   480
      Width           =   2295
   End
   Begin VB.Label label1 
      Alignment       =   2  'Center
      Caption         =   "Jobs"
      Height          =   255
      Index           =   2
      Left            =   2400
      TabIndex        =   6
      Top             =   480
      Width           =   2295
   End
   Begin VB.Label label1 
      Alignment       =   2  'Center
      Caption         =   "Employees"
      Height          =   255
      Index           =   1
      Left            =   0
      TabIndex        =   5
      Top             =   480
      Width           =   2295
   End
   Begin VB.Label TotalWorkLabel 
      BorderStyle     =   1  'Fixed Single
      Caption         =   "0"
      Height          =   255
      Left            =   1080
      TabIndex        =   1
      Top             =   60
      Width           =   495
   End
   Begin VB.Label label1 
      Caption         =   "Jobs assigned"
      Height          =   255
      Index           =   0
      Left            =   0
      TabIndex        =   0
      Top             =   75
      Width           =   1095
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "WorkForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Work.FRM
'
' Main form for work assignment example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Dim Nodes As Collection
Dim Links As Collection

' Used for drawing and node selection.
Const RADIUS = 10

' Node path tree status values.
Const NOT_IN_LIST = 0
Const NOW_IN_LIST = 1
Const WAS_IN_LIST = 2

Const INFINITY = 32767

' Source and sink nodes.
Dim SourceNode As WorkNode
Dim SinkNode As WorkNode

Dim EmpNodes As Collection
Dim JobNodes As Collection

' ************************************************
' Build the network.
' ************************************************
Private Sub BuildNetwork()
Dim link As WorkLink
Dim emp As WorkNode
Dim job As WorkNode
Dim i As Integer
Dim txt As String

    For Each emp In EmpNodes
        ' See which jobs this employee can do.
        For Each job In JobNodes
            ' See if emp can do this job.
            For i = 1 To job.Skills.Count
                ' See if emp has this skill.
                On Error Resume Next
                txt = emp.Skills(job.Skills(i))
                ' If emp does not have this skill,
                ' make no link between these two.
                If Err.Number <> 0 Then Exit For
                On Error GoTo 0
            Next i
            
            ' If has the necessary skills, link
            ' the employee and job.
            If i > job.Skills.Count Then
                Set link = New WorkLink
                emp.Links.Add link
                Links.Add link
                link.Capacity = 1
                link.Flow = 0
                Set link.ToNode = job
            End If
        Next job
    Next emp
    
    ' Create dummy nodes and links.
    Set SourceNode = New WorkNode
    Nodes.Add SourceNode
    SourceNode.Id = Nodes.Count
    
    For Each emp In EmpNodes
        Set link = New WorkLink
        SourceNode.Links.Add link
        Links.Add link
        link.Capacity = 1
        link.Flow = 0
        Set link.ToNode = emp
    Next emp
    
    Set SinkNode = New WorkNode
    Nodes.Add SinkNode
    SinkNode.Id = Nodes.Count
    
    For Each job In JobNodes
        Set link = New WorkLink
        job.Links.Add link
        Links.Add link
        link.Capacity = 1
        link.Flow = 0
        Set link.ToNode = SinkNode
    Next job
End Sub
' ************************************************
' Destroy the network.
' ************************************************
Private Sub DestroyNetwork()
Dim node As WorkNode

    For Each node In Nodes
        Set node.Links = Nothing
        Set node.FromNode = Nothing
    Next node

    Set EmpNodes = Nothing
    Set JobNodes = Nothing
    Set Nodes = Nothing
    Set Links = Nothing
End Sub

' ************************************************
' Display the results.
' ************************************************
Private Sub DisplayResult()
Dim txt As String
Dim emp As WorkNode
Dim link As WorkLink
Dim total_work As Integer

    total_work = 0
    For Each emp In EmpNodes
        For Each link In emp.Links
            If link.Flow > 0 Then Exit For
        Next link
        If link Is Nothing Then
            txt = txt & emp.Name & " --> " & _
                " ---" & vbCrLf
        Else
            txt = txt & emp.Name & " --> " _
                & link.ToNode.Name & vbCrLf
            total_work = total_work + 1
        End If
    Next emp
    
    AssignmentText.Text = txt
    TotalWorkLabel.Caption = Format$(total_work) & _
        " / " & Format$(JobNodes.Count)
End Sub

' ************************************************
' Read a string and build an array of nodes.
' Update the Skills list as needed.
' ************************************************
Private Sub ReadInfo(ByVal txt As String, col As Collection)
Dim pos As Integer
Dim new_line As String
Dim new_txt As String
Dim node As WorkNode

    Do While txt <> ""
        ' Read a line.
        pos = InStr(txt, vbCrLf)
        If pos = 0 Then pos = Len(txt) + 1
        new_line = Trim$(Left$(txt, pos - 1))
        If pos > Len(txt) Then
            txt = ""
        Else
            txt = Trim$(Mid$(txt, pos + Len(vbCrLf)))
        End If
        
        If new_line <> "" Then
            Set node = New WorkNode
            col.Add node
            Nodes.Add node
            node.Id = Nodes.Count
            
            ' Get the name.
            pos = InStr(new_line, " ")
            If pos = 0 Then pos = Len(new_line) + 1
            new_txt = Trim$(Left$(new_line, pos - 1))
            node.Name = new_txt
            If pos > Len(new_line) Then
                Exit Do
            Else
                new_line = Trim$(Mid$(new_line, pos + 1))
            End If
            
            ' Get the skills.
            Do While new_line <> ""
                pos = InStr(new_line, " ")
                If pos = 0 Then pos = Len(new_line) + 1
                new_txt = Trim$(Left$(new_line, pos - 1))
                node.Skills.Add new_txt, new_txt
                If pos > Len(new_line) Then
                    Exit Do
                Else
                    new_line = Trim$(Mid$(new_line, pos + 1))
                End If
            Loop
        End If  ' End if the line isn't blank.
    Loop
End Sub

' ************************************************
' Assign jobs.
' ************************************************
Private Sub CmdGo_Click()
    Set Nodes = New Collection
    Set Links = New Collection
    Set EmpNodes = New Collection
    Set JobNodes = New Collection

    ' Create employee and job nodes.
    ReadInfo EmployeeText.Text, EmpNodes
    ReadInfo JobText.Text, JobNodes
    
    ' Build the network.
    BuildNetwork
    
    ' Calculate the maximum flows.
    FindMaxFlows

    ' Show the results.
    DisplayResult

    ' Destroy the network.
    DestroyNetwork
End Sub
Private Sub Form_Resize()
Dim hgt As Single

    hgt = ScaleHeight - label1(1).Top - label1(1).Height
    If hgt < 10 Then hgt = 10
    EmployeeText.Height = hgt
    JobText.Height = hgt
    AssignmentText.Height = hgt
End Sub


' ************************************************
' Present help about the program.
' ************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String

    txt = "This program uses a maximum flow algorithm to assign jobs to employees." & vbCrLf & vbCrLf
    txt = txt & "Enter employee IDs followed by lists of skills in the left text box. Enter job IDs followed by required skills in the middle text box. Then click the Go button to make the program assign the jobs."

    MsgBox txt, vbOKOnly, "Help About ... Work"
End Sub

' ************************************************
' Find the maximum flows.
' ************************************************
Private Sub FindMaxFlows()
Dim candidates As Collection

Dim Residual() As Integer
Dim num_nodes As Integer
Dim id1 As Integer
Dim id2 As Integer
Dim node As WorkNode
Dim to_node As WorkNode
Dim from_node As WorkNode
Dim link As WorkLink
Dim min_residual As Integer

    If SourceNode Is Nothing Or SinkNode Is Nothing _
        Then Exit Sub

    ' Dimension the Residual array.
    num_nodes = Nodes.Count
    ReDim Residual(1 To num_nodes, 1 To num_nodes)

    ' Initially the residual values are the same
    ' as the capacities.
    For Each node In Nodes
        id1 = node.Id
        For Each link In node.Links
            id2 = link.ToNode.Id
            Residual(id1, id2) = link.Capacity
        Next link
    Next node

    ' Repeat until we can find no more
    ' augmenting paths.
    Do
        ' Find an augmenting path in the residual
        ' network.

        ' Reset the nodes' NodeStatus and
        ' FromNode values.
        For Each node In Nodes
            node.NodeStatus = NOT_IN_LIST
            Set node.FromNode = Nothing
        Next node

        ' Start with an empty candidate list.
        Set candidates = New Collection
        
        ' Put the source on the candidate list.
        candidates.Add SourceNode
        SourceNode.NodeStatus = NOW_IN_LIST
        
        ' Repeat until the candidate list is empty.
        Do While candidates.Count > 0
            Set node = candidates(1)
            candidates.Remove 1
            node.NodeStatus = WAS_IN_LIST
            id1 = node.Id
            
            ' Examine the links out of this node.
            For Each link In node.Links
                Set to_node = link.ToNode
                id2 = to_node.Id

                ' See if the residual > 0 and this
                ' node has never been on the list.
                If Residual(id1, id2) > 0 And _
                    to_node.NodeStatus = NOT_IN_LIST _
                Then
                    ' Add it to the list.
                    candidates.Add to_node
                    to_node.NodeStatus = NOW_IN_LIST
                    Set to_node.FromNode = node
                End If
            Next link

            ' Stop if the sink has been labeled.
            If Not (SinkNode.FromNode Is Nothing) Then _
                Exit Do
        Loop

        ' Stop if we found no augmenting path.
        If SinkNode.FromNode Is Nothing Then Exit Do

        ' Find the smallest residual along the
        ' augmenting path.
        min_residual = INFINITY
        Set node = SinkNode
        Do
            If node Is SourceNode Then Exit Do
            id2 = node.Id
            Set from_node = node.FromNode
            id1 = from_node.Id
            If min_residual > Residual(id1, id2) Then _
                min_residual = Residual(id1, id2)
            Set node = from_node
        Loop

        ' Update the flows using the augmenting
        ' path.
        Set node = SinkNode
        Do
            If node Is SourceNode Then Exit Do
            id2 = node.Id
            Set from_node = node.FromNode
            id1 = from_node.Id

            Residual(id1, id2) = Residual(id1, id2) _
                - min_residual
            Residual(id2, id1) = Residual(id2, id1) _
                + min_residual
            Set node = from_node
        Loop
    Loop ' Repeat until there are no more augmenting paths.

    ' Calculate the flows from the residuals.
    For Each node In Nodes
        id1 = node.Id
        For Each link In node.Links
            Set to_node = link.ToNode
            id2 = to_node.Id
            If link.Capacity > Residual(id1, id2) Then
                link.Flow = link.Capacity - Residual(id1, id2)
            Else
                link.Flow = 0
            End If
        Next link
    Next node
End Sub

' ************************************************
' End the application. Note that Form_QueryUnload
' ensures that the data is safe.
' ************************************************
Private Sub mnuFileExit_Click()
    Unload Me
End Sub

