VERSION 4.00
Begin VB.MDIForm ExpMDIForm 
   BackColor       =   &H8000000C&
   Caption         =   "ExpMVC"
   ClientHeight    =   4140
   ClientLeft      =   1140
   ClientTop       =   1800
   ClientWidth     =   6690
   Height          =   4830
   Left            =   1080
   LinkTopic       =   "MDIForm1"
   Top             =   1170
   Width           =   6810
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuWin 
      Caption         =   "&Windows"
      WindowList      =   -1  'True
      Begin VB.Menu mnuWinGraph 
         Caption         =   "New &Graph"
         Shortcut        =   ^G
      End
      Begin VB.Menu mnuWinTable 
         Caption         =   "New &Table"
         Shortcut        =   ^T
      End
      Begin VB.Menu mnuWinPie 
         Caption         =   "New &Pie Chart"
         Shortcut        =   ^P
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "ExpMDIForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' ExpMDI.FRM
'
' MDI form for expense MVC example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Private TheModel As New ExpenseModel

' ************************************************
' Create some random expense data.
' ************************************************
Private Sub MDIForm_Load()
Dim i As Integer

    TheModel.SetNumValues Nothing, 10
    
    Randomize
    For i = 0 To 9
        TheModel.SetExpenseValue _
            Nothing, i, 4000 * Rnd() + 3000
    Next i
    TheModel.SetExpenseName Nothing, 0, "Advertising"
    TheModel.SetExpenseName Nothing, 1, "Binary Transmission Lab"
    TheModel.SetExpenseName Nothing, 2, "Computer Center"
    TheModel.SetExpenseName Nothing, 3, "Destructive Evaluation Lab"
    TheModel.SetExpenseName Nothing, 4, "Executive Offices"
    TheModel.SetExpenseName Nothing, 5, "Finance"
    TheModel.SetExpenseName Nothing, 6, "Geographic Systems"
    TheModel.SetExpenseName Nothing, 7, "Human Resources"
    TheModel.SetExpenseName Nothing, 8, "Interactive Technology Lab"
    TheModel.SetExpenseName Nothing, 9, "JASPER"
End Sub

' ************************************************
' Present help about this program.
' ************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String

    txt = txt & "This program demonstrates the MVC paradigm. Use the Windows menu to create multiple views of the expense data." & vbCrLf & vbCrLf
    txt = txt & "Table View - Modify expense item names or values by typing in the text boxes." & vbCrLf & vbCrLf
    txt = txt & "Graph View - Click and drag on the right edge of a bar to change the value." & vbCrLf & vbCrLf
    txt = txt & "Pie View - This is an view only, not a controller, so it does not allow you to modify the data."

    MsgBox txt, vbOKOnly, "Help About ... ExpMVC"
End Sub

Private Sub mnuFileExit_Click()
    Unload Me
End Sub


' ************************************************
' Create a new table view.
' ************************************************
Private Sub mnuWinTable_Click()
Dim view As New TableView

    Set view.Model = TheModel
End Sub
' ************************************************
' Create a new graph view.
' ************************************************
Private Sub mnuWinGraph_Click()
Dim view As New GraphView

    Set view.Model = TheModel
End Sub
' ************************************************
' Create a new pie chart view.
' ************************************************
Private Sub mnuWinPie_Click()
Dim view As New PieView

    Set view.Model = TheModel
End Sub
