VERSION 4.00
Begin VB.Form PieView 
   Caption         =   "PieView"
   ClientHeight    =   2730
   ClientLeft      =   2715
   ClientTop       =   1650
   ClientWidth     =   3870
   FillStyle       =   0  'Solid
   Height          =   3135
   KeyPreview      =   -1  'True
   Left            =   2655
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   182
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   258
   Top             =   1305
   Width           =   3990
End
Attribute VB_Name = "PieView"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' ExpGraph.FRM
'
' Graph view for expense MVC example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Public TheModel As ExpenseModel

Private ViewID As Integer

' Index of the value we're moving.
Private MovingValue As Integer

Private Xmin As Single
Private Xmax As Single
Private RowHgt As Single

Private CurX As Single
Private GapX As Single
Private GapY As Single

Private Const PI = 3.14159265

' ************************************************
' The data has been modified.
' ************************************************
Public Sub DataModified()
    Refresh
End Sub

' ************************************************
' Save the model and register with it as a view.
' ************************************************
Property Set Model(New_Model As ExpenseModel)
    Set TheModel = New_Model
    ViewID = TheModel.AddView(Me)
    DataModified
    Show
End Property

' ************************************************
' Display text for a pie chart entry.
' ************************************************
Private Sub ShowText(X As Single, Y As Single, angle1 As Single, angle2 As Single, r1 As Single, r2 As Single, txt As String)
Dim x1 As Single
Dim y1 As Single
Dim x2 As Single
Dim y2 As Single
Dim theta As Single

    theta = (angle1 + angle2) / 2
    x1 = X + r1 * Cos(theta)
    y1 = Y - r1 * Sin(theta)
    x2 = X + r2 * Cos(theta)
    y2 = Y - r2 * Sin(theta)
    Line (x1, y1)-(x2, y2)
    
    If theta > PI / 2 And theta < 3 * PI / 2 Then
        ' It's in the left half.
        CurrentX = x2 - TextWidth(txt)
    End If
    If theta < PI Then
        ' It's in the top half.
        CurrentY = y2 - ScaleY(Font.Size, vbPoints, ScaleMode)
    End If
    Print txt
End Sub

Private Sub Form_Load()
    MovingValue = -1
End Sub
' ************************************************
' Unload if the user presses the escape key.
' ************************************************
Private Sub Form_KeyPress(KeyAscii As Integer)
    If KeyAscii = vbKeyEscape Then Unload Me
End Sub
' ************************************************
' Display the pie chart.
' ************************************************
Private Sub Form_Paint()
Dim margin As Single
Dim i As Integer
Dim angle1 As Single
Dim angle2 As Single
Dim total As Single
Dim percent As Single
Dim X As Single
Dim Y As Single
Dim r1 As Single
Dim r2 As Single

    Cls
    If TheModel.NumValues < 1 Then Exit Sub
    
    margin = 2 * ScaleX(Font.Size, vbPoints, ScaleMode)
    X = ScaleWidth / 2
    Y = ScaleHeight / 2
    If X > Y Then
        r1 = Y - margin
    Else
        r1 = X - margin
    End If
    If r1 <= 0 Then Exit Sub
    r2 = r1 + margin / 2
    total = TheModel.TotalExpenses

    ' Display the first value.
    FillStyle = vbFSSolid
    FillColor = QBColor(0)
    Circle (X, Y), r1
    percent = TheModel.ExpenseValue(0) / total
    angle1 = 2 * PI * percent
    ShowText X, Y, 0, angle1, r1, r2, _
        TheModel.ExpenseName(0)

    ' Display the other values.
    For i = 1 To TheModel.NumValues - 1
        percent = TheModel.ExpenseValue(i) / total
        angle2 = angle1 + 2 * PI * percent
        If angle2 > 2 * PI Then angle2 = 2 * PI
        FillColor = QBColor(i Mod 16)
        Circle (X, Y), r1, , -angle1, -2 * PI
        ShowText X, Y, angle1, angle2, r1, r2, _
            TheModel.ExpenseName(i)
        angle1 = angle2
    Next i
    FillStyle = vbFSTransparent
    Circle (X, Y), r1
End Sub
Private Sub Form_Resize()
    Form_Paint
End Sub


' ************************************************
' Unregister as a view.
' ************************************************
Private Sub Form_Unload(Cancel As Integer)
    TheModel.RemoveView ViewID
End Sub

