VERSION 4.00
Begin VB.Form TableView 
   Caption         =   "TableView"
   ClientHeight    =   2730
   ClientLeft      =   2715
   ClientTop       =   1650
   ClientWidth     =   3870
   Height          =   3135
   KeyPreview      =   -1  'True
   Left            =   2655
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   2730
   ScaleWidth      =   3870
   Top             =   1305
   Width           =   3990
   Begin VB.HScrollBar HBar 
      Height          =   255
      Left            =   0
      TabIndex        =   7
      Top             =   1800
      Width           =   3375
   End
   Begin VB.VScrollBar VBar 
      Height          =   1695
      Left            =   3480
      TabIndex        =   6
      Top             =   0
      Width           =   255
   End
   Begin VB.PictureBox OuterPict 
      Height          =   1695
      Left            =   0
      ScaleHeight     =   1635
      ScaleWidth      =   3315
      TabIndex        =   0
      Top             =   0
      Width           =   3375
      Begin VB.PictureBox InnerPict 
         BorderStyle     =   0  'None
         Height          =   1575
         Left            =   0
         ScaleHeight     =   1575
         ScaleWidth      =   3255
         TabIndex        =   1
         Top             =   0
         Width           =   3255
         Begin VB.TextBox ItemName 
            Height          =   285
            Index           =   0
            Left            =   0
            TabIndex        =   3
            Top             =   240
            Width           =   2175
         End
         Begin VB.TextBox ItemValue 
            Height          =   285
            Index           =   0
            Left            =   2280
            TabIndex        =   2
            Top             =   240
            Width           =   975
         End
         Begin VB.Label Label1 
            Alignment       =   2  'Center
            Caption         =   "Item"
            Height          =   255
            Index           =   0
            Left            =   0
            TabIndex        =   5
            Top             =   0
            Width           =   2295
         End
         Begin VB.Label Label1 
            Alignment       =   2  'Center
            Caption         =   "Value"
            Height          =   255
            Index           =   1
            Left            =   2400
            TabIndex        =   4
            Top             =   0
            Width           =   855
         End
      End
   End
End
Attribute VB_Name = "TableView"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' ExpTable.FRM
'
' Table view for expense MVC example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Public TheModel As ExpenseModel

Private IgnoreChanges As Boolean
Private ViewID As Integer
' ************************************************
' The data has been modified.
' ************************************************
Public Sub DataModified()
Dim i As Integer
Dim resize_needed As Boolean

    resize_needed = _
        (TheModel.NumValues - 1 <> ItemName.UBound)

    ' Load any needed controls.
    For i = ItemName.UBound + 1 To TheModel.NumValues - 1
        Load ItemName(i)
        Load ItemValue(i)
        ItemName(i).Top = ItemName(i - 1).Top + ItemName(i - 1).Height
        ItemValue(i).Top = ItemValue(i - 1).Top + ItemValue(i - 1).Height
        ItemName(i).Visible = True
        ItemValue(i).Visible = True
    Next i

    ' Unload any controls no longer needed.
    If ItemName.UBound > 0 Then
        For i = TheModel.NumValues To ItemName.UBound
            Unload ItemName(i)
            Unload ItemValue(i)
        Next i
    End If
    
    ' Load the data values.
    ' Do not trigger a bunch of notifications.
    IgnoreChanges = True
    For i = 0 To TheModel.NumValues - 1
        ItemName(i).Text = TheModel.ExpenseName(i)
        ItemValue(i).Text = Format$(TheModel.ExpenseValue(i), "Currency")
    Next i
    IgnoreChanges = False
    
    ' If we added or removed controls, resize to
    ' rearrange the scroll bars.
    If resize_needed Then Form_Resize
End Sub

' ************************************************
' Save the model and register with it as a view.
' ************************************************
Property Set Model(New_Model As ExpenseModel)
    Set TheModel = New_Model
    ViewID = TheModel.AddView(Me)
    DataModified
    Show
End Property

' ************************************************
' Make OuterPict as large as possible.
' ************************************************
Private Sub Form_Resize()
Dim got_wid As Single
Dim got_hgt As Single
Dim need_wid As Single
Dim need_hgt As Single
Dim need_hbar As Boolean
Dim need_vbar As Boolean

    ' See how much room we need.
    got_wid = ScaleWidth
    got_hgt = ScaleHeight
    need_wid = ItemValue(0).Left + ItemValue(0).Width
    need_hgt = ItemValue(ItemValue.UBound).Top + _
        ItemValue(ItemValue.UBound).Height
    InnerPict.Width = need_wid
    InnerPict.Height = need_hgt
    
    ' See which scroll bars we need.
    If need_wid > got_wid Then
        need_hbar = True
        got_hgt = got_hgt - HBar.Height
    End If
    If need_hgt > got_hgt Then
        need_vbar = True
        got_wid = got_wid - VBar.Width
        If Not need_hbar Then
            If need_wid > got_wid Then
                need_hbar = True
                got_hgt = got_hgt - HBar.Height
            End If
        End If
    End If
    
    ' Position the controls.
    OuterPict.Move 0, 0, got_wid, got_hgt
    If need_hbar Then
        HBar.Move 0, got_hgt, got_wid
        HBar.Min = 0
        HBar.Max = need_wid - got_wid
        HBar.SmallChange = got_wid / 10
        HBar.LargeChange = got_wid
        HBar.Visible = True
    Else
        HBar.Visible = False
        InnerPict.Left = 0
    End If
    If need_vbar Then
        VBar.Move got_wid, 0, VBar.Width, got_hgt
        VBar.Min = 0
        VBar.Max = need_hgt - got_hgt
        VBar.SmallChange = got_hgt / 10
        VBar.LargeChange = got_hgt
        VBar.Visible = True
    Else
        VBar.Visible = False
        InnerPict.Top = 0
    End If
End Sub
' ************************************************
' Unload if the user presses the escape key.
' ************************************************
Private Sub Form_KeyPress(KeyAscii As Integer)
    If KeyAscii = vbKeyEscape Then Unload Me
End Sub
' ************************************************
' Unregister as a view.
' ************************************************
Private Sub Form_Unload(Cancel As Integer)
    TheModel.RemoveView ViewID
End Sub
' ************************************************
' Scroll horizontally.
' ************************************************
Private Sub HBar_Change()
    InnerPict.Left = -HBar.Value
End Sub


' ************************************************
' Scroll horizontally.
' ************************************************
Private Sub HBar_Scroll()
    InnerPict.Left = -HBar.Value
End Sub

' ************************************************
' Notify the model that this name has changed.
' ************************************************
Private Sub ItemName_Change(Index As Integer)
    If IgnoreChanges Then Exit Sub
    TheModel.SetExpenseName Me, Index, ItemName(Index).Text
End Sub

' ************************************************
' Notify the model that this value has changed.
' ************************************************
Private Sub ItemValue_Change(Index As Integer)
Dim new_value As Single

    If IgnoreChanges Then Exit Sub

    On Error Resume Next
    new_value = CSng(ItemValue(Index).Text)
    If Err.Number <> 0 Then new_value = 0
    TheModel.SetExpenseValue Me, Index, new_value
End Sub

' ************************************************
' Scroll vertically.
' ************************************************
Private Sub VBar_Scroll()
    InnerPict.Top = -VBar.Value
End Sub

' ************************************************
' Scroll vertically.
' ************************************************
Private Sub VBar_Change()
    InnerPict.Top = -VBar.Value
End Sub
