VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "StackCell"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' FCell.CLS
'
' Cell class for friend example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

' These values are available only to the friend
' class Stack.
Private m_NextCell As StackCell
Private m_Value As String

' ************************************************
' Return the next cell to friends only.
' ************************************************
Property Get NextCell(s As Stack) As StackCell
    ' If the friend class is not present, raise
    ' an error.
    If s Is Nothing Then _
        Err.Raise vbObjectError + 1, "StackCell", _
        "Friend object required."

    ' Return the property value.
    Set NextCell = m_NextCell
End Property
' ************************************************
' Return the Value to friends only.
' ************************************************
Property Get Value(s As Stack) As String
    ' If the friend class is not present, raise
    ' an error.
    If s Is Nothing Then _
        Err.Raise vbObjectError + 1, "StackCell", _
        "Friend object required."

    ' Return the property value.
    Value = m_Value
End Property
' ************************************************
' Set the Value for friends only.
' ************************************************
Property Let Value(s As Stack, New_Value As String)
    ' If the friend class is not present, raise
    ' an error.
    If s Is Nothing Then _
        Err.Raise vbObjectError + 1, "StackCell", _
        "Friend object required."

    ' Set the value.
    m_Value = New_Value
End Property
' ************************************************
' Set the next cell for friends only.
' ************************************************
Property Set NextCell(s As Stack, New_NextCell As StackCell)
    ' If the friend class is not present, raise
    ' an error.
    If s Is Nothing Then _
        Err.Raise vbObjectError + 1, "StackCell", _
        "Friend object required."

    ' Set the value.
    Set m_NextCell = New_NextCell
End Property
