VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Stack"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' FStack.CLS
'
' Stack class for friend example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Private TopSentinel As New StackCell

' ************************************************
' Return True if the stack is empty.
' ************************************************
Property Get IsEmpty() As Boolean
    IsEmpty = (TopSentinel.NextCell(Me) Is Nothing)
End Property

' ************************************************
' Add an item to the stack.
' ************************************************
Public Sub Push(ByVal Value As String)
Dim cell As New StackCell

    cell.Value(Me) = Value
    Set cell.NextCell(Me) = TopSentinel.NextCell(Me)
    Set TopSentinel.NextCell(Me) = cell
End Sub
' ************************************************
' Remove an item from the stack.
' ************************************************
Public Function Pop() As String
Dim cell As StackCell
    
    Set cell = TopSentinel.NextCell(Me)
    If cell Is Nothing Then Exit Function
    
    Pop = cell.Value(Me)
    Set TopSentinel.NextCell(Me) = cell.NextCell(Me)
End Function
' ************************************************
' Return a textual representation of the stack.
' ************************************************
Public Function TextRepresentation() As String
Dim txt As String
Dim cell As StackCell

    Set cell = TopSentinel.NextCell(Me)
    Do While Not (cell Is Nothing)
        txt = txt & cell.Value(Me) & vbCrLf
        Set cell = cell.NextCell(Me)
    Loop
    
    TextRepresentation = txt
End Function
