VERSION 4.00
Begin VB.Form GenericForm 
   Caption         =   "Generic"
   ClientHeight    =   1185
   ClientLeft      =   2025
   ClientTop       =   2085
   ClientWidth     =   4335
   Height          =   1875
   Left            =   1965
   LinkTopic       =   "Form1"
   ScaleHeight     =   1185
   ScaleWidth      =   4335
   Top             =   1455
   Width           =   4455
   Begin VB.Label SpecificLabel 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   3120
      TabIndex        =   3
      Top             =   600
      Width           =   855
   End
   Begin VB.Label GenericLabel 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   3120
      TabIndex        =   2
      Top             =   240
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Average time with specific object (ms):"
      Height          =   255
      Index           =   1
      Left            =   240
      TabIndex        =   1
      Top             =   600
      Width           =   2775
   End
   Begin VB.Label Label1 
      Caption         =   "Average time with generic object (ms):"
      Height          =   255
      Index           =   0
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   2775
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "GenericForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Generic.FRM
'
' Main form for generic object example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

' ************************************************
' Set values using a generic object.
' ************************************************
Private Sub TestGeneric()
Const REPS = 1000

Dim obj As Object
Dim i As Long
Dim start_time As Single
Dim stop_time As Single

    Set obj = New SpecificClass
    start_time = Timer
    For i = 1 To REPS
        obj.Value = i
    Next i
    stop_time = Timer
    GenericLabel.Caption = _
        Format$(1000 * (stop_time - start_time) / REPS, "0.0000")
End Sub
' ************************************************
' Set values using a specific object.
' ************************************************
Private Sub TestSpecific()
Const REPS = 1000000

Dim obj As SpecificClass
Dim i As Long
Dim start_time As Single
Dim stop_time As Single

    Set obj = New SpecificClass
    start_time = Timer
    For i = 1 To REPS
        obj.Value = i
    Next i
    stop_time = Timer
    SpecificLabel.Caption = _
        Format$(1000 * (stop_time - start_time) / REPS, "0.0000")
End Sub

Private Sub Form_Load()
    Show
    MousePointer = vbHourglass
    DoEvents
    
    TestGeneric
    DoEvents
    TestSpecific

    MousePointer = vbDefault
End Sub


Private Sub mnuFileExit_Click()
    Unload Me
End Sub
' ************************************************
' Present help about the program.
' ************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String

    txt = "This program demonstrates the performance difference between using generic and specific object declarations." & vbCrLf & vbCrLf
    txt = txt & "The generic object is declared as:" & vbCrLf
    txt = txt & "    Dim obj As Object" & vbCrLf & vbCrLf
    txt = txt & "The specific object is declared as:" & vbCrLf
    txt = txt & "    Dim obj As SpecificClass" & vbCrLf & vbCrLf
    txt = txt & "The second version is MUCH faster."

    MsgBox txt, vbOKOnly, "Help About ... Generic"
End Sub

