VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "BreadthFirstIterator"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' IterBrea.CLS
'
' Breadth first iterator class.
'
' For complete trees stored in an array, a breadth
' first traversal is simply a listing of the nodes
' in their array order.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Public TheTree As IterTree

Private CurrentIndex As Integer

' ************************************************
' Move to the first node.
' ************************************************
Public Sub MoveFirst()
    CurrentIndex = 0
End Sub
' ************************************************
' Move to the next node.
' ************************************************
Public Sub MoveNext()
    CurrentIndex = CurrentIndex + 1
End Sub

' ************************************************
' Return True if we have moved beyond the end
' of the tree.
' ************************************************
Property Get EndOfTree() As Boolean
    EndOfTree = (Not TheTree.InTree(CurrentIndex))
End Property
' ************************************************
' Return the current label control.
' ************************************************
Property Get CurrentCaption() As String
    If Not EndOfTree Then _
        CurrentCaption = _
            TheTree.NodeCaption(CurrentIndex)
End Property
