VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "PostorderIterator"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' IterPost.CLS
'
' Postorder iterator class.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Public TheTree As IterTree

Private Stack As Collection
' ************************************************
' Add nodes to Stack in postorder.
' ************************************************
Private Sub MakeStack(Index As Integer)
    If TheTree.InTree(2 * Index + 1) Then _
        MakeStack 2 * Index + 1
    If TheTree.InTree(2 * Index + 2) Then _
        MakeStack 2 * Index + 2
    Stack.Add Index
End Sub

' ************************************************
' Move to the first node.
' ************************************************
Public Sub MoveFirst()
    ' Make a list of the nodes in inorder.
    Set Stack = New Collection
    MakeStack 0
End Sub
' ************************************************
' Move to the next node.
' ************************************************
Public Sub MoveNext()
    Stack.Remove 1
End Sub

' ************************************************
' Return True if we have moved beyond the end
' of the tree.
' ************************************************
Property Get EndOfTree() As Boolean
    EndOfTree = (Stack.Count < 1)
End Property
' ************************************************
' Return the current label control.
' ************************************************
Property Get CurrentCaption() As String
    If Not EndOfTree Then _
        CurrentCaption = _
            TheTree.NodeCaption(Stack(1))
End Property
