VERSION 4.00
Begin VB.Form IterTreeForm 
   Appearance      =   0  'Flat
   Caption         =   "IterTree"
   ClientHeight    =   3750
   ClientLeft      =   2430
   ClientTop       =   1815
   ClientWidth     =   4830
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   4440
   Icon            =   "IterTree.frx":0000
   Left            =   2370
   LinkTopic       =   "Form1"
   ScaleHeight     =   3750
   ScaleWidth      =   4830
   Top             =   1185
   Width           =   4950
   Begin VB.TextBox ResultText 
      Height          =   615
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   1  'Horizontal
      TabIndex        =   7
      Top             =   3120
      Width           =   4815
   End
   Begin VB.CommandButton CmdBreadthFirst 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Breadth First"
      Height          =   375
      Left            =   0
      TabIndex        =   5
      Top             =   2640
      Width           =   1335
   End
   Begin VB.CommandButton CmdPostorder 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Postorder"
      Height          =   375
      Left            =   0
      TabIndex        =   4
      Top             =   2160
      Width           =   1335
   End
   Begin VB.CommandButton CmdPreorder 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Preorder"
      Height          =   375
      Left            =   0
      TabIndex        =   2
      Top             =   1200
      Width           =   1335
   End
   Begin VB.CommandButton CmdInorder 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Inorder"
      Height          =   375
      Left            =   0
      TabIndex        =   3
      Top             =   1680
      Width           =   1335
   End
   Begin VB.CommandButton CmdCreateTree 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Create Tree"
      Default         =   -1  'True
      Height          =   375
      Left            =   0
      TabIndex        =   1
      Top             =   360
      Width           =   1335
   End
   Begin VB.TextBox DepthText 
      Height          =   285
      Left            =   1080
      TabIndex        =   0
      Text            =   "3"
      Top             =   0
      Width           =   495
   End
   Begin VB.Label NodeLabel 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "0"
      Height          =   255
      Index           =   0
      Left            =   1440
      TabIndex        =   8
      Top             =   360
      Width           =   375
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "Tree Height"
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   0
      TabIndex        =   6
      Top             =   0
      Width           =   1095
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "IterTreeForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' IterTree.FRM
'
' Main form for tree traversal example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Private TheTree As New IterTree

' ************************************************
' Perform a breadth first traversal of the tree.
' ************************************************
Private Sub CmdBreadthFirst_Click()
Dim trav As New Traverser

    ' Use the factory method to create the iterator.
    Set trav.Iterator = TheTree.NewBreadthFirstIterator
    
    ' Traverse the tree.
    ResultText.Text = trav.Traverse
End Sub

' ************************************************
' Build a tree of the indicated depth.
' ************************************************
Private Sub CmdCreateTree_Click()
Dim depth As Integer

    On Error Resume Next
    depth = CInt(DepthText.Text)
    If Err <> 0 Then
        Beep
        MsgBox Error$
        DepthText.SetFocus
        Exit Sub
    End If
    If depth < 1 Or depth > 9 Then
        Beep
        Exit Sub
    End If

    TheTree.MakeTree depth
    If Err <> 0 Then
        Beep
        MsgBox Error$
        DepthText.SetFocus
        Exit Sub
    End If
End Sub

' ************************************************
' Perform an inorder traversal of the tree.
' ************************************************
Private Sub CmdInorder_Click()
Dim trav As New Traverser

    ' Use the factory method to create the iterator.
    Set trav.Iterator = TheTree.NewInorderIterator
    
    ' Traverse the tree.
    ResultText.Text = trav.Traverse
End Sub

' ************************************************
' Perform a postorder traversal of the tree.
' ************************************************
Private Sub CmdPostorder_Click()
Dim trav As New Traverser

    ' Use the factory method to create the iterator.
    Set trav.Iterator = TheTree.NewPostorderIterator
    
    ' Traverse the tree.
    ResultText.Text = trav.Traverse
End Sub

' ************************************************
' Perform a preorder traversal of the tree.
' ************************************************
Private Sub CmdPreorder_Click()
Dim trav As New Traverser

    ' Use the factory method to create the iterator.
    Set trav.Iterator = TheTree.NewPreorderIterator
    
    ' Traverse the tree.
    ResultText.Text = trav.Traverse
End Sub

Private Sub Form_Load()
    Set TheTree.TheForm = Me
    TheTree.MakeTree 1
End Sub

' *******************************************************
' Draw lines connecting the centers of each node with its
' children.
' *******************************************************
Private Sub Form_Paint()
    TheTree.DrawLines
End Sub

Private Sub Form_Resize()
    ResultText.Width = ScaleWidth
End Sub

Private Sub mnuFileExit_Click()
    Unload Me
End Sub

' ************************************************
' Display help for this program.
' ************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String
    
    txt = "This program demonstrates different traversal orders for a full, complete binary tree. It uses factory methods to generate iterator objects for the different traversals." & vbCrLf & vbCrLf
    txt = txt & "Enter the tree depth and click the Create Tree button to build the tree. Then click one of the traversal buttons to display the tree's nodes in its different traversal orders."
    
    MsgBox txt, vbOKOnly, "Help About ... InterTree"
End Sub

