Attribute VB_Name = "SerialStuff"
' ************************************************
' Serials.BAS
'
' Routines for building and interpreting
' serializations.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit
' ************************************************
' If txt is not "", return the first token name/
' value pair. Otherwise return the next pair.
' Return token_name = "" when there are no more
' tokens.
' ************************************************
Public Sub GetSerialization(txt As String, pos As Integer, token_name As String, token_value As String)
Dim open_pos As Integer
Dim num_open As Integer
Dim i As Integer
Dim txt_len As Integer
Dim ch As String

    txt_len = Len(txt)
    If pos >= txt_len Then
        token_name = ""
        Exit Sub
    End If

    open_pos = InStr(pos + 1, txt, "(")
    If open_pos = 0 Then
        token_name = ""
        Exit Sub
    End If
    token_name = Mid$(txt, pos + 1, open_pos - pos - 1)

    num_open = 1
    For i = open_pos + 1 To txt_len
        ch = Mid$(txt, i, 1)
        If ch = "(" Then
            num_open = num_open + 1
        ElseIf ch = ")" Then
            num_open = num_open - 1
            If num_open = 0 Then Exit For
        End If
    Next i
    token_value = Mid$(txt, open_pos + 1, i - open_pos - 1)
    
    If i > txt_len Then
        pos = txt_len
    Else
        pos = i
    End If
End Sub

