VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "EllipseCmd"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' ShapeE.CLS
'
' Command class for serialization example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Private m_X As Single
Private m_Y As Single
Private m_Radius As Single
Private m_Color As Long
Private m_Aspect As Single
Private m_Style As Integer

Private Const def_X = 0
Private Const def_Y = 0
Private Const def_Radius = 50
Private Const def_Color = vbBlack
Private Const def_Aspect = 1#
Private Const def_Style = vbFSSolid

' ************************************************
' Set default values for the command's properties.
' ************************************************
Private Sub SetDefaults()
    m_X = def_X
    m_Y = def_Y
    m_Radius = def_Radius
    m_Color = def_Color
    m_Aspect = def_Aspect
    m_Style = def_Style
End Sub

' ************************************************
' Initialize the command using a serialization.
' ************************************************
Property Let Serialization(txt As String)
Dim pos As Integer
Dim token_name As String
Dim token_value As String

    ' Set default values.
    SetDefaults

    ' Read values until there are no more.
    GetSerialization txt, pos, token_name, token_value
    Do While token_name <> ""
        SetValue token_name, token_value
        GetSerialization txt, pos, token_name, token_value
    Loop
End Property
' ************************************************
' Return the command's serialization.
' ************************************************
Property Get Serialization() As String
Dim txt As String

    If m_X <> def_X Then txt = txt & "X(" & Format$(m_X) & ")"
    If m_Y <> def_Y Then txt = txt & "Y(" & Format$(m_Y) & ")"
    If m_Radius <> def_Radius Then txt = txt & "Radius(" & Format$(m_Radius) & ")"
    If m_Color <> def_Color Then txt = txt & "Color(" & Format$(m_Color) & ")"
    If m_Aspect <> def_Aspect Then txt = txt & "Aspect(" & Format$(m_Aspect) & ")"
    If m_Style <> def_Style Then txt = txt & "Style(" & Format$(m_Style) & ")"

    Serialization = txt
End Property

' ************************************************
' Set a value.
' ************************************************
Private Sub SetValue(token_name As String, token_value As String)
    Select Case token_name
        Case "X"
            m_X = CSng(token_value)
        Case "Y"
            m_Y = CSng(token_value)
        Case "Radius"
            m_Radius = CSng(token_value)
        Case "Color"
            m_Color = CLng(token_value)
        Case "Aspect"
            m_Aspect = CSng(token_value)
        Case "Style"
            m_Style = CInt(token_value)
    End Select
End Sub

' ************************************************
' Execute the object's command.
' ************************************************
Public Sub Execute(pic As PictureBox)
    pic.FillStyle = m_Style
    pic.FillColor = m_Color
    pic.Circle (m_X, m_Y), m_Radius, m_Color, , , m_Aspect
End Sub

' ************************************************
' Set the object's data values.
' ************************************************
Public Sub SetValues(x1 As Single, y1 As Single, x2 As Single, y2 As Single, Color As Long, Style As Integer)
Dim dx As Single
Dim dy As Single

    m_X = (x1 + x2) / 2
    m_Y = (y1 + y2) / 2
    dx = Abs(x1 - x2)
    dy = Abs(y1 - y2)
    If dx > dy Then
        m_Radius = dx / 2
    Else
        m_Radius = dy / 2
    End If
    m_Aspect = dy / dx
    m_Color = Color
    m_Style = Style
End Sub

