VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "RectangleCmd"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' ShapeR.CLS
'
' Command class for serialization example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Private m_X1 As Single
Private m_X2 As Single
Private m_Y1 As Single
Private m_Y2 As Single
Private m_Color As Long
Private m_Style As Integer

Private Const def_X1 = 0
Private Const def_X2 = 0
Private Const def_Y1 = 0
Private Const def_Y2 = 0
Private Const def_Color = vbBlack
Private Const def_Style = vbFSSolid

' ************************************************
' Return the command's serialization.
' ************************************************
Property Get Serialization() As String
Dim txt As String

    If m_X1 <> def_X1 Then txt = txt & "X1(" & Format$(m_X1) & ")"
    If m_X2 <> def_X2 Then txt = txt & "X2(" & Format$(m_X2) & ")"
    If m_Y1 <> def_Y1 Then txt = txt & "Y1(" & Format$(m_Y1) & ")"
    If m_Y2 <> def_Y2 Then txt = txt & "Y2(" & Format$(m_Y2) & ")"
    If m_Color <> def_Color Then txt = txt & "Color(" & Format$(m_Color) & ")"
    If m_Style <> def_Style Then txt = txt & "Style(" & Format$(m_Style) & ")"

    Serialization = txt
End Property
' ************************************************
' Set default values for the command's properties.
' ************************************************
Private Sub SetDefaults()
    m_X1 = def_X1
    m_X2 = def_X2
    m_Y1 = def_Y1
    m_Y2 = def_Y2
    m_Color = def_Color
    m_Style = def_Style
End Sub
' ************************************************
' Set a value.
' ************************************************
Private Sub SetValue(token_name As String, token_value As String)
    Select Case token_name
        Case "X1"
            m_X1 = CSng(token_value)
        Case "X2"
            m_X2 = CSng(token_value)
        Case "Y1"
            m_Y1 = CSng(token_value)
        Case "Y2"
            m_Y2 = CSng(token_value)
        Case "Color"
            m_Color = CLng(token_value)
        Case "Style"
            m_Style = CInt(token_value)
    End Select
End Sub
' ************************************************
' Initialize the command using a serialization.
' ************************************************
Property Let Serialization(txt As String)
Dim pos As Integer
Dim token_name As String
Dim token_value As String

    ' Set default values.
    SetDefaults

    ' Read values until there are no more.
    GetSerialization txt, pos, token_name, token_value
    Do While token_name <> ""
        SetValue token_name, token_value
        GetSerialization txt, pos, token_name, token_value
    Loop
End Property
' ************************************************
' Set the object's data values.
' ************************************************
Public Sub SetValues(x1 As Single, y1 As Single, x2 As Single, y2 As Single, Color As Long, Style As Integer)
    m_X1 = x1
    m_Y1 = y1
    m_X2 = x2
    m_Y2 = y2
    m_Color = Color
    m_Style = Style
End Sub
' ************************************************
' Execute the object's command.
' ************************************************
Public Sub Execute(pic As PictureBox)
    pic.FillColor = m_Color
    pic.FillStyle = m_Style
    pic.Line (m_X1, m_Y1)-(m_X2, m_Y2), m_Color, B
End Sub
