Attribute VB_Name = "FakeCell"
' ************************************************
' FakeCell.FRM
'
' FakeCell data structure.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

' Special index value indicating end of list.
Const END_OF_LIST = -32767

' The cell data structure.
Type FakeCell
    Value As String
    NextCell As Integer
End Type

' The array of linked list cells.
' Cells(0) is the sentinel.
Global Cells(0 To 100) As FakeCell

' The list sentinel.
Global Sentinel As Integer

' Linked list of unused calls.
Global TopGarbage As Integer
' ************************************************
' Initialize the empty list.
' ************************************************
Public Sub InitializeList()
Dim i As Integer

    Sentinel = 0
    Cells(Sentinel).NextCell = END_OF_LIST
    
    ' Put all the other cells on a garbage list.
    For i = 1 To UBound(Cells) - 1
        Cells(i).NextCell = i + 1
    Next i
    Cells(UBound(Cells)).NextCell = END_OF_LIST
    TopGarbage = 1
End Sub

