VERSION 4.00
Begin VB.Form LinkedListForm 
   Appearance      =   0  'Flat
   Caption         =   "LnkList1"
   ClientHeight    =   5865
   ClientLeft      =   3015
   ClientTop       =   750
   ClientWidth     =   3015
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   6555
   Icon            =   "FakeList.frx":0000
   Left            =   2955
   ScaleHeight     =   5865
   ScaleWidth      =   3015
   Top             =   120
   Width           =   3135
   Begin VB.CommandButton CmdClearList 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Cancel          =   -1  'True
      Caption         =   "Clear List"
      Enabled         =   0   'False
      Height          =   495
      Left            =   120
      TabIndex        =   5
      Top             =   2040
      Width           =   1455
   End
   Begin VB.CommandButton CmdRemoveAfter 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Remove After"
      Enabled         =   0   'False
      Height          =   495
      Left            =   120
      TabIndex        =   4
      Top             =   1440
      Width           =   1455
   End
   Begin VB.CommandButton CmdAddAfter 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Add After"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   840
      Width           =   1455
   End
   Begin VB.TextBox NewItem 
      Height          =   315
      Left            =   120
      TabIndex        =   0
      Top             =   360
      Width           =   1455
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackStyle       =   0  'Transparent
      Caption         =   "New Item"
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   0
      Width           =   855
   End
   Begin VB.Label AllList 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Sentinel"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   0
      Left            =   1680
      TabIndex        =   3
      Top             =   0
      Width           =   1215
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "LinkedListForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' FakeList.FRM
'
' Main form for linked list with pointer faking.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Dim NumItems As Integer ' The number of items.

Dim SelectedIndex As Integer

' ************************************************
' Select an item.
' ************************************************
Private Sub SelectItem(ByVal Index As Integer)
    ' Deselect the previous item.
    If SelectedIndex >= 0 Then
        AllList(SelectedIndex).ForeColor = Label1.ForeColor
        AllList(SelectedIndex).BackColor = Label1.BackColor
    End If
    
    ' Select the new item.
    SelectedIndex = Index
    If SelectedIndex >= 0 Then
        AllList(SelectedIndex).ForeColor = Label1.BackColor
        AllList(SelectedIndex).BackColor = Label1.ForeColor
    End If
    
    CmdRemoveAfter.Enabled = _
        SelectedIndex < NumItems And _
        SelectedIndex >= 0
    CmdAddAfter.Enabled = _
        (Trim$(NewItem.Text) <> "") And _
        SelectedIndex >= 0
End Sub

' ************************************************
' Select this item.
' ************************************************
Private Sub AllList_Click(Index As Integer)
    SelectItem Index
End Sub

' ************************************************
' Add the new item to the list.
' ************************************************
Private Sub CmdAddAfter_Click()
Dim ptr As Integer
Dim position As Integer
Dim new_cell As Integer

    ' Find the insertion position.
    ptr = Sentinel
    position = SelectedIndex
    Do While position > 0
        position = position - 1
        ptr = Cells(ptr).NextCell
    Loop
    
    ' Get a new cell from the garbage list.
    new_cell = TopGarbage
    TopGarbage = Cells(TopGarbage).NextCell
    
    ' Insert the item.
    Cells(new_cell).Value = NewItem.Text
    Cells(new_cell).NextCell = Cells(ptr).NextCell
    Cells(ptr).NextCell = new_cell
    NumItems = NumItems + 1

    DisplayList
    SelectItem SelectedIndex + 1 ' Select the new item.
    NewItem.Text = ""
    NewItem.SetFocus
    CmdClearList.Enabled = True
End Sub

' ************************************************
' Clear the list.
' ************************************************
Private Sub CmdClearList_Click()
    InitializeList
    NumItems = 0
    
    SelectItem -1   ' Deselect any item.
    DisplayList
    NewItem.SetFocus
    CmdClearList.Enabled = False
End Sub

' ************************************************
' Remove the selected item from the list.
' ************************************************
Private Sub CmdRemoveAfter_Click()
Dim ptr As Integer
Dim target As Integer
Dim position As Integer

    If SelectedIndex < 0 Then Exit Sub
    
    ' Find the item.
    ptr = Sentinel
    position = SelectedIndex
    Do While position > 0
        position = position - 1
        ptr = Cells(ptr).NextCell
    Loop
    
    ' Skip the next item.
    target = Cells(ptr).NextCell
    Cells(ptr).NextCell = Cells(target).NextCell
    NumItems = NumItems - 1
    
    ' Add the removed cell to the garbage list.
    Cells(target).NextCell = TopGarbage
    TopGarbage = target
    
    SelectItem SelectedIndex ' Reselect the item.
    DisplayList
    CmdClearList.Enabled = NumItems > 0
    NewItem.SetFocus
End Sub

' ************************************************
' Display the list.
' ************************************************
Private Sub DisplayList()
Const YGAP = 20
Const XGAP = 120

Static MaxEntries As Long

Dim i As Integer
Dim ptr As Integer

    ' Create control array entries if needed
    For i = MaxEntries + 1 To NumItems
        Load AllList(i)
        AllList(i).Top = AllList(i - 1).Top + _
            AllList(i - 1).Height + YGAP
        If AllList(i).Top + AllList(i).Height > _
            ScaleHeight _
        Then
            AllList(i).Top = AllList(0).Top + _
                AllList(0).Height + YGAP
            AllList(i).Left = AllList(i - 1).Left + _
                AllList(i - 1).Width + XGAP
        Else
            AllList(i).Left = AllList(i - 1).Left
        End If
        AllList(i).BorderStyle = vbFixedSingle
        AllList(i).Alignment = vbLeftJustify
    Next i
    If MaxEntries < NumItems Then _
        MaxEntries = NumItems
    
    ' Display used items
    ptr = Cells(Sentinel).NextCell
    For i = 1 To NumItems
        AllList(i).Caption = Format$(i) & _
            ": " & Cells(ptr).Value
        AllList(i).Visible = True
        ptr = Cells(ptr).NextCell
    Next i

    ' Hide unneeded list entries
    For i = NumItems + 1 To MaxEntries
        AllList(i).Visible = False
    Next i
End Sub

Private Sub Form_Load()
    SelectedIndex = -1
    
    ' Initialize the list.
    InitializeList
End Sub

Private Sub mnuFileExit_Click()
    Unload Me
End Sub

' ************************************************
' Present help about this program.
' ************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String

    txt = txt & "This program demonstrates a linked list." & vbCrLf & vbCrLf
    txt = txt & "Enter a value and click on an item in the list (including the sentinel). Then click Add After to add the item after the one you selected." & vbCrLf & vbCrLf
    txt = txt & "Click an item in the list (including the sentinel) and click Remove After to remove the item after the one you selected." & vbCrLf & vbCrLf
    txt = txt & "Click the Clear List button to remove all items from the list."

    MsgBox txt, vbOKOnly, "Help About ... LnkList1"
End Sub

' *******************************************************
' Enable the Add button if the item is not blank
' and an item has been selected.
' *******************************************************
Private Sub NewItem_Change()
    CmdAddAfter.Enabled = _
        (Trim$(NewItem.Text) <> "") And _
        SelectedIndex >= 0
End Sub

