VERSION 4.00
Begin VB.Form GarbageListForm 
   Appearance      =   0  'Flat
   Caption         =   "Garbage"
   ClientHeight    =   5865
   ClientLeft      =   3015
   ClientTop       =   750
   ClientWidth     =   2790
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   6555
   Icon            =   "Garbage.frx":0000
   Left            =   2955
   ScaleHeight     =   5865
   ScaleWidth      =   2790
   Top             =   120
   Width           =   2910
   Begin VB.CommandButton CmdRemove 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Cancel          =   -1  'True
      Caption         =   "Remove"
      Enabled         =   0   'False
      Height          =   495
      Left            =   120
      TabIndex        =   4
      Top             =   1440
      Width           =   1215
   End
   Begin VB.CommandButton CmdAdd 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Add"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   840
      Width           =   1215
   End
   Begin VB.TextBox NewItem 
      Height          =   315
      Left            =   120
      TabIndex        =   0
      Top             =   360
      Width           =   1215
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackStyle       =   0  'Transparent
      Caption         =   "New Item"
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   0
      Width           =   855
   End
   Begin VB.Label AllList 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      Caption         =   "List"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   0
      Left            =   1440
      TabIndex        =   3
      Top             =   0
      Width           =   1215
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "GarbageListForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Garbage.FRM
'
' Main form for garbage list example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Dim List As New GarbageList

Dim SelectedIndex As Long

' ************************************************
' Select an item.
' ************************************************
Private Sub SelectItem(Index As Integer)
    ' Deselect the previous item.
    If SelectedIndex > 0 Then
        AllList(SelectedIndex).ForeColor = AllList(0).ForeColor
        AllList(SelectedIndex).BackColor = AllList(0).BackColor
    End If
    
    ' Select the new item.
    SelectedIndex = Index
    If SelectedIndex > 0 Then
        AllList(SelectedIndex).ForeColor = AllList(0).BackColor
        AllList(SelectedIndex).BackColor = AllList(0).ForeColor
        CmdRemove.Enabled = True
    End If
End Sub

' ************************************************
' Select this item.
' ************************************************
Private Sub AllList_Click(Index As Integer)
    If Index < 1 Then Exit Sub
    If IsNull(List.Item(Index)) Then Exit Sub
    SelectItem Index
End Sub

' ************************************************
' Add the new item to the list.
' ************************************************
Private Sub CmdAdd_Click()
    List.Add NewItem.Text
    DisplayList
    NewItem.Text = ""
    NewItem.SetFocus
End Sub

' ************************************************
' Remove the selected item from the list.
' ************************************************
Private Sub CmdRemove_Click()
    If SelectedIndex = 0 Then Exit Sub
    
    List.Remove SelectedIndex ' Remove the item.
    SelectItem 0              ' Deselect the item.
    CmdRemove.Enabled = False
    DisplayList
    NewItem.SetFocus
End Sub

' ************************************************
' Display the list.
' ************************************************
Private Sub DisplayList()
Const YGAP = 20
Const XGAP = 120

Static MaxEntries As Long

Dim i As Long
Dim value As Variant

    ' Create control array entries if needed
    For i = MaxEntries + 1 To List.ArraySize
        Load AllList(i)
        AllList(i).Top = AllList(i - 1).Top + _
            AllList(i - 1).Height + YGAP
        If AllList(i).Top + AllList(i).Height > _
            ScaleHeight _
        Then
            AllList(i).Top = AllList(0).Top + _
                AllList(0).Height + YGAP
            AllList(i).Left = AllList(i - 1).Left + _
                AllList(i - 1).Width + XGAP
        Else
            AllList(i).Left = AllList(i - 1).Left
        End If
        AllList(i).BorderStyle = vbFixedSingle
        AllList(i).Alignment = vbLeftJustify
    Next i
    If MaxEntries < List.ArraySize Then _
        MaxEntries = List.ArraySize
    
    ' Display used items
    For i = 1 To List.NumItems
        value = List.Item(i)
        If IsNull(value) Then
            AllList(i).Caption = Format$(i) & _
                ": <garbage>"
        Else
            AllList(i).Caption = Format$(i) & _
                ": " & List.Item(i)
        End If
        AllList(i).Visible = True
    Next i

    ' Display items
    For i = List.NumItems + 1 To List.ArraySize
        AllList(i).Caption = Format$(i) & _
            ": <unused>"
        AllList(i).Visible = True
    Next i

    ' Hide unneeded list entries
    For i = List.ArraySize + 1 To MaxEntries
        AllList(i).Visible = False
    Next i
End Sub


Private Sub mnuFileExit_Click()
    Unload Me
End Sub

' ************************************************
' Present help about this program.
' ************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String
Dim bullet As String

    bullet = Chr$(176)
    txt = txt & "This program demonstrates a list with garbage collection." & vbCrLf & vbCrLf
    txt = txt & "Enter a value and click Add to add an item to the end of the list. "
    txt = txt & "Click Remove to remove the last item from the list." & vbCrLf & vbCrLf
    txt = txt & "Whenever the list is resized, a message box appears to tell you:" & vbCrLf
    txt = txt & "    " & bullet & " How many items are currently in use" & vbCrLf
    txt = txt & "    " & bullet & " How many items are currently unused" & vbCrLf
    txt = txt & "    " & bullet & " The value ShrinkWhen" & vbCrLf & vbCrLf
    txt = txt & "The array will be resized if the number of items in use falls below this value ShrinkWhen." & vbCrLf

    MsgBox txt, vbOKOnly, "Help About ... Garbage"
End Sub

' *******************************************************
' Enable the Add button if the item is not blank.
' *******************************************************
Private Sub NewItem_Change()
    CmdAdd.Enabled = (Trim$(NewItem.Text) <> "")
End Sub

