VERSION 4.00
Begin VB.Form ArrayQueueForm 
   Appearance      =   0  'Flat
   Caption         =   "ArrayQ2"
   ClientHeight    =   4230
   ClientLeft      =   2640
   ClientTop       =   1545
   ClientWidth     =   3270
   FillColor       =   &H80000005&
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   4920
   Icon            =   "ArrayQ2.frx":0000
   Left            =   2580
   LinkTopic       =   "GarbageForm"
   ScaleHeight     =   4230
   ScaleWidth      =   3270
   Top             =   915
   Width           =   3390
   Begin VB.TextBox ArrayQueueText 
      Height          =   4215
      Left            =   1320
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   0
      Width           =   1935
   End
   Begin VB.CommandButton CmdEnter 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Enter"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   495
      Left            =   0
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   360
      Width           =   1215
   End
   Begin VB.CommandButton CmdLeave 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Cancel          =   -1  'True
      Caption         =   "Leave"
      Enabled         =   0   'False
      Height          =   495
      Left            =   0
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   960
      Width           =   1215
   End
   Begin VB.TextBox NewItem 
      Height          =   315
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1215
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "ArrayQueueForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' ArrayQ2.FRM
'
' Main form for array-based queue class.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Dim Queue As New ArrayQueue
' ************************************************
' Add a new item to the queue.
' ************************************************
Private Sub CmdEnter_Click()
    Queue.EnterQueue NewItem.Text
    NewItem.Text = ""
    SetButtons
    ArrayQueueText.Text = Queue.TextRepresentation
    NewItem.SetFocus
End Sub

' ************************************************
' Remove the top item from the queue.
' ************************************************
Private Sub CmdLeave_Click()
    NewItem.Text = Queue.LeaveQueue
    SetButtons
    ArrayQueueText.Text = Queue.TextRepresentation
End Sub

Private Sub mnuFileExit_Click()
    End
End Sub

' ************************************************
' Display help about this program.
' ************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String
Dim bullet As String

    bullet = Chr$(176)
    txt = txt & "This program demonstrates an array-based queue class." & vbCrLf & vbCrLf
    txt = txt & "Enter a string and click the Enter button to add a new item to the queue." & vbCrLf & vbCrLf
    txt = txt & "Click the Leave button to remove the top item from the queue." & vbCrLf & vbCrLf
    txt = txt & "Whenever the queue is resized, a message box appears to tell you:" & vbCrLf
    txt = txt & "    " & bullet & " How many items are currently in use" & vbCrLf
    txt = txt & "    " & bullet & " How many items are currently unused" & vbCrLf
    txt = txt & "    " & bullet & " The value AQ_ResizeWhen" & vbCrLf & vbCrLf
    txt = txt & "The array will be resized when the top of the list passes this value AQ_ResizeWhen." & vbCrLf & vbCrLf
    txt = txt & "Keep in mind that each time the queue is resized a temporary array is also resized to help reorganize the queue." & vbCrLf & vbCrLf
    txt = txt & "Also note that the queue will require resizing as items are added and removed even if the total number of items in the queue does not change much."

    MsgBox txt, vbOKOnly, "Help About ... ArrayQ2"
End Sub

' ************************************************
' The user has modified the new item text. Enable the
' correct buttons.
' ************************************************
Private Sub NewItem_Change()
    SetButtons
End Sub

' ************************************************
' Enable the correct buttons.
' ************************************************
Private Sub SetButtons()
    CmdEnter.Enabled = (Trim$(NewItem.Text) <> "")
    CmdLeave.Enabled = Not Queue.QueueEmpty
End Sub

