VERSION 4.00
Begin VB.Form CircleQueueForm 
   Appearance      =   0  'Flat
   Caption         =   "CircleQ"
   ClientHeight    =   4245
   ClientLeft      =   1230
   ClientTop       =   1470
   ClientWidth     =   7605
   FillColor       =   &H80000005&
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   4935
   Icon            =   "CircleQ.frx":0000
   Left            =   1170
   LinkTopic       =   "GarbageForm"
   ScaleHeight     =   4245
   ScaleWidth      =   7605
   Top             =   840
   Width           =   7725
   Begin VB.PictureBox QueuePicture 
      BorderStyle     =   0  'None
      Height          =   3975
      Left            =   3480
      ScaleHeight     =   3975
      ScaleWidth      =   3975
      TabIndex        =   4
      Top             =   120
      Width           =   3975
   End
   Begin VB.TextBox CirQueueText 
      Height          =   3975
      Left            =   1440
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   3
      Text            =   "CircleQ.frx":000C
      Top             =   120
      Width           =   1935
   End
   Begin VB.CommandButton CmdEnter 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Enter"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   495
      Left            =   120
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   480
      Width           =   1215
   End
   Begin VB.CommandButton CmdLeave 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Cancel          =   -1  'True
      Caption         =   "Leave"
      Enabled         =   0   'False
      Height          =   495
      Left            =   120
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   1080
      Width           =   1215
   End
   Begin VB.TextBox NewItem 
      Height          =   315
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "About This Program..."
      End
   End
End
Attribute VB_Name = "CircleQueueForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' CircleQ.FRM
'
' Main form for circular queue example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

' ************************************************
' Allow the user to type only ^C.
' ************************************************
Private Sub ArrayQueue_KeyPress(KeyAscii As Integer)
    If KeyAscii = 3 Then Exit Sub
    KeyAscii = 0
End Sub

' ************************************************
' Add a new item to the queue.
' ************************************************
Private Sub CmdEnter_Click()
    CQ_EnterQueue Trim$(NewItem.Text)
    NewItem.Text = ""
    NewItem.SetFocus
    SetButtons
    DisplayList
End Sub

' ************************************************
' Remove an item from the queue.
' ************************************************
Private Sub CmdLeave_Click()
Dim value As String

    CQ_LeaveQueue value
    NewItem.Text = value
    SetButtons
    DisplayList
End Sub

' ************************************************
' Display the queue.
' ************************************************
Private Sub DisplayList()
Dim txt As String
Dim i As Integer
    
    ' Display the queue "normally."
    txt = ""
    For i = 0 To CQ_NumInQueue - 1
        txt = txt & CQ_Queue((i + CQ_Front) Mod CQ_Size) & vbCrLf
    Next i
    CirQueueText.Text = txt

    ' Draw some circles.
    DrawCircleQueue
End Sub

' ************************************************
' Draw the queue in a circle.
' ************************************************
Private Sub DrawCircleQueue()
Const GAP = 60
Const two_PI = 2# * 3.14159
Dim x As Single
Dim y As Single
Dim r1 As Single
Dim r2 As Single
Dim r_value As Single
Dim r_front As Single
Dim r_back As Single
Dim theta As Single
Dim Dtheta As Single
Dim i As Integer
Dim txt As String
Dim pos As Integer

    QueuePicture.Cls

    ' Draw circles.
    r2 = (QueuePicture.Width - GAP) / 2#
    r1 = r2 * 0.7
    x = QueuePicture.Width / 2#
    y = QueuePicture.Height / 2#
    QueuePicture.Circle (x, y), r1
    QueuePicture.Circle (x, y), r2

    If CQ_Size < 1 Then Exit Sub
    
    ' Divide the circlular track into cells.
    Dtheta = two_PI / CQ_Size
    theta = 0
    For i = 1 To CQ_Size
        QueuePicture.Line (x + r1 * Cos(theta), y + r1 * Sin(theta))-(x + r2 * Cos(theta), y + r2 * Sin(theta))
        theta = theta + Dtheta
    Next i

    ' Mark the front and back positions.
    r_value = (r1 + r2) / 2
    r_front = r1 - 0.6 * QueuePicture.TextWidth("Front")
    r_back = r_front - 1.1 * QueuePicture.TextWidth("Back")
    theta = (CQ_Front + 0.5) * Dtheta
    QueuePicture.CurrentX = x + r_front * Cos(theta) - QueuePicture.TextWidth("Front") / 2
    QueuePicture.CurrentY = y + r_front * Sin(theta) - QueuePicture.TextHeight("Front") / 2
    QueuePicture.Print "Front"

    theta = (CQ_Back + 0.5) * Dtheta
    QueuePicture.CurrentX = x + r_back * Cos(theta) - QueuePicture.TextWidth("Back") / 2
    QueuePicture.CurrentY = y + r_back * Sin(theta) - QueuePicture.TextHeight("Back") / 2
    QueuePicture.Print "Back"

    ' Display the array entries
    pos = CQ_Front
    For i = 0 To CQ_NumInQueue - 1
        theta = (pos + 0.5) * Dtheta
        txt = Format$(CQ_Queue(pos))
        QueuePicture.CurrentX = x + r_value * Cos(theta) - QueuePicture.TextWidth(txt) / 2
        QueuePicture.CurrentY = y + r_value * Sin(theta) - QueuePicture.TextHeight(txt) / 2
        QueuePicture.Print txt
        pos = (pos + 1) Mod CQ_Size
    Next i
End Sub

Private Sub Form_Load()
    DisplayList
End Sub

Private Sub Form_Paint()
    DrawCircleQueue
End Sub

Private Sub mnuFileExit_Click()
    End
End Sub

' ************************************************
' Display help about this program.
' ************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String
Dim bullet As String

    bullet = Chr$(176)
    txt = "This program manages a circular queue." & vbCrLf & vbCrLf
    txt = txt & "Enter a string and click the Enter button to add a new item to the queue." & vbCrLf & vbCrLf
    txt = txt & "Click the Leave button to remove the top item from the queue." & vbCrLf & vbCrLf
    txt = txt & "Whenever the list is resized, a message box appears to tell you:" & vbCrLf
    txt = txt & "    " & bullet & " How many items are currently in use" & vbCrLf
    txt = txt & "    " & bullet & " How many items are currently unused" & vbCrLf
    txt = txt & "    " & bullet & " The value ShrinkWhen" & vbCrLf & vbCrLf
    txt = txt & "The array will be resized if the number of items in the queue falls below this value ShrinkWhen."

    MsgBox txt, vbOKOnly, "Help About ... CircleQ"
End Sub

' ************************************************
' The user has modified the new item text. Enable the
' correct buttons.
' ************************************************
Private Sub NewItem_Change()
    SetButtons
End Sub

' ************************************************
' Enable the correct buttons.
' ************************************************
Private Sub SetButtons()
    CmdEnter.Enabled = (Trim$(NewItem.Text) <> "")
    CmdLeave.Enabled = (CQ_NumInQueue > 0)
End Sub

