VERSION 4.00
Begin VB.Form DrawForm 
   Appearance      =   0  'Flat
   Caption         =   "DrawForm"
   ClientHeight    =   4020
   ClientLeft      =   1170
   ClientTop       =   1635
   ClientWidth     =   7365
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   4425
   Icon            =   "Poly.frx":0000
   Left            =   1110
   MDIChild        =   -1  'True
   ScaleHeight     =   4020
   ScaleWidth      =   7365
   Top             =   1290
   Width           =   7485
End
Attribute VB_Name = "DrawForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Poly.FRM
'
' Drawing form for linked list of linked lists
' example program.
'
' Note that the linked lists are automatically
' destroyed when the form unloads.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Dim FirstPolygon As PolygonCell ' Top of this form's polygon list.
Dim DrawingLine As Integer      ' Is the user in the middle of drawing?

Dim StartX As Single
Dim StartY As Single
Dim CurX As Single
Dim CurY As Single

' ************************************************
' Draw the polygons for this form.
' ************************************************
Private Sub DrawPicture()
Dim polycell As PolygonCell

    Set polycell = FirstPolygon
    Do While Not (polycell Is Nothing)
        DrawPolygon polycell
        Set polycell = polycell.NextPolygon
    Loop
End Sub

' ************************************************
' Draw this polygon.
' ************************************************
Private Sub DrawPolygon(polycell As PolygonCell)
Dim ptcell As PointCell

    Set ptcell = polycell.FirstPoint
    If ptcell Is Nothing Then Exit Sub
    
    CurrentX = ptcell.X
    CurrentY = ptcell.Y
    Set ptcell = ptcell.NextPoint
    Do While Not (ptcell Is Nothing)
        Line -(ptcell.X, ptcell.Y)
        Set ptcell = ptcell.NextPoint
    Loop
End Sub

' ************************************************
' The user has clicked the right mouse button to
' finish drawing a polygon. Finish it up.
' ************************************************
Private Sub FinishPolygon()
Dim ptcell As PointCell

    If Not DrawingLine Then Exit Sub
    RubberLine
    DrawingLine = False
    
    ' If the polygon has zero or one point,
    ' remove it.
    Set ptcell = FirstPolygon.FirstPoint
    If Not (ptcell Is Nothing) Then _
        Set ptcell = ptcell.NextPoint
    If ptcell Is Nothing Then _
        Set FirstPolygon = FirstPolygon.NextPolygon
End Sub

' ************************************************
' Finish the current polygon.
' ************************************************
Private Sub Form_DblClick()
    FinishPolygon
End Sub

' ************************************************
' Start drawing a new polygon.
' ************************************************
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim new_polygon As PolygonCell
Dim new_point As PointCell

    ' If it's a right button press and we are
    ' drawing a polygon, finish that polygon.
    If Button = vbRightButton And DrawingLine Then
        FinishPolygon
        Exit Sub
    End If
    If Button <> vbLeftButton Then Exit Sub
    
    ' Start or continue drawing a polygon.
    If DrawingLine Then
        ' Continue the polygon in progress.
        RubberLine
        Line (StartX, StartY)-(X, Y)
    Else
        ' Start a new polygon.
        Set new_polygon = New PolygonCell
        Set new_polygon.NextPolygon = FirstPolygon
        Set FirstPolygon = new_polygon
        DrawingLine = True
    End If
    
    ' Add a point to the polygon.
    Set new_point = New PointCell
    Set new_point.NextPoint = FirstPolygon.FirstPoint
    Set FirstPolygon.FirstPoint = new_point
    new_point.X = X
    new_point.Y = Y

    StartX = X
    StartY = Y
    CurX = X
    CurY = Y
    RubberLine
End Sub

' ************************************************
' Use rubberbanding to indicate the new point.
' ************************************************
Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Not DrawingLine Then Exit Sub
    
    RubberLine
    CurX = X
    CurY = Y
    RubberLine
End Sub

' ************************************************
' Redraw the picture.
' ************************************************
Private Sub Form_Paint()
    DrawPicture
End Sub

' *******************************************************
' Draw a rubber band line between (StartX, StartY) and
' (CurX, CurY). Since the line is drawn in INVERT mode,
' it will be erased if we draw it again in INVERT mode.
' *******************************************************
Private Sub RubberLine()
Const INVERT = 6

Dim draw_mode As Integer

    draw_mode = DrawMode
    DrawMode = INVERT
    Line (StartX, StartY)-(CurX, CurY)
    DrawMode = draw_mode
End Sub

