VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "TriangularArray"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Triang.CLS
'
' Triangular array class.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Private Rows As Integer
Private Values() As Variant
' ************************************************
' Initialize the array.
' ************************************************
Public Sub Initialize(num_rows As Integer)
    Rows = num_rows
    ReDim Values(0 To Rows * (Rows - 1) / 2)
End Sub
' ************************************************
' Return a value in the array.
' ************************************************
Property Get Value(r As Integer, c As Integer) As Variant
Dim X As Integer

    X = AtoB(r, c)
    If X < 0 Then
        Set Value = Nothing
    Else
        Value = Values(X)
    End If
End Property
' ************************************************
' Set a value in the array.
' ************************************************
Property Let Value(r As Integer, c As Integer, new_value As Variant)
Dim X As Integer

    X = AtoB(r, c)
    If X >= 0 Then Values(X) = new_value
End Property

' ************************************************
' Convert the I and J indexes in two-dimensional
' array A into the X index in one-dimensional
' array B for a triangular array that does not
' include the diagonal entries.
' ************************************************
Private Function AtoB(ByVal I As Integer, ByVal J As Integer) As Integer
Dim tmp As Integer

    If I = J Or I < 0 Or I >= Rows Or _
                J < 0 Or J >= Rows _
    Then
        AtoB = -1
        Exit Function
    ElseIf I < J Then
        tmp = I
        I = J
        J = tmp
    End If
    AtoB = I * (I - 1) / 2 + J
End Function
