Attribute VB_Name = "TriangStuff"
' ************************************************
' Triang2.BAS
'
' Routines for converting coordinates between
' triangular two-dimensional array A and
' one-dimensional array B.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************

Option Explicit

' ************************************************
' Convert the I and J indexes in two-dimensional
' array A into the X index in one-dimensional
' array B for a triangular array that does not
' include the diagonal entries.
' ************************************************
Sub AtoB(ByVal I As Integer, ByVal J As Integer, X As Integer)
Dim tmp As Integer

    If I < J Then    ' Switch I and J so I > J.
        tmp = I
        I = J
        J = tmp
    End If
    I = I + 1
    X = I * (I - 1) / 2 + J
End Sub

' ************************************************
' Convert the X index in one-dimensional array B
' into the I and J indexes in two-dimensional
' array A for a triangular array that includes
' the diagonal entries.
' ************************************************
Sub BtoA(ByVal X As Integer, I As Integer, J As Integer)
    I = Int((1 + Sqr(1 + 8 * X)) / 2)
    J = X - I * (I - 1) / 2
    I = I - 1
End Sub

