VERSION 4.00
Begin VB.Form SparseForm 
   Appearance      =   0  'Flat
   Caption         =   "Sparse"
   ClientHeight    =   3120
   ClientLeft      =   1035
   ClientTop       =   1830
   ClientWidth     =   6225
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   3810
   Icon            =   "VSparse.frx":0000
   Left            =   975
   LinkTopic       =   "Form1"
   ScaleHeight     =   3120
   ScaleWidth      =   6225
   Top             =   1200
   Width           =   6345
   Begin VB.CommandButton CmdSet 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Set"
      Height          =   495
      Left            =   960
      TabIndex        =   7
      Top             =   1200
      Width           =   735
   End
   Begin VB.CommandButton CmdGet 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Get"
      Height          =   495
      Left            =   120
      TabIndex        =   6
      Top             =   1200
      Width           =   735
   End
   Begin VB.TextBox ValueText 
      Height          =   285
      Left            =   840
      TabIndex        =   5
      Top             =   840
      Width           =   855
   End
   Begin VB.TextBox ColText 
      Height          =   285
      Left            =   840
      TabIndex        =   3
      Top             =   480
      Width           =   855
   End
   Begin VB.TextBox RowText 
      Height          =   285
      Left            =   840
      TabIndex        =   2
      Top             =   120
      Width           =   855
   End
   Begin VB.Label ArrayLabel 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Index           =   0
      Left            =   1800
      TabIndex        =   8
      Top             =   120
      Visible         =   0   'False
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Value"
      Height          =   255
      Index           =   2
      Left            =   120
      TabIndex        =   4
      Top             =   840
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "Column"
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "Row"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   615
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "SparseForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' VSparse.FRM
'
' Main form for very sparse array example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Dim the_array As New VerySparseArray
' *******************************************************
' The user has pressed the Get button. Get the current
' value of the indicated entry.
' *******************************************************
Private Sub CmdGet_Click()
Dim r As Integer
Dim c As Integer
Dim Value As Integer

    r = CInt(RowText.Text)
    c = CInt(ColText.Text)

    Value = the_array.Value(r, c)
    ValueText.Text = Format$(Value)
End Sub

' *******************************************************
' The user has pressed the Set button. Set the value of
' the indicated position.
' *******************************************************
Private Sub CmdSet_Click()
Dim r As Integer
Dim c As Integer
Dim Value As Integer

    r = CInt(RowText.Text)
    c = CInt(ColText.Text)
    Value = CInt(ValueText.Text)

    the_array.Value(r, c) = Value
    ValueText.Text = ""
    DisplayArray
End Sub


' *******************************************************
' Display the entries currently in the array.
' *******************************************************
Private Sub DisplayArray()
Const GAP = 40

Static MaxItems As Integer

Dim wid As Single
Dim hgt As Single
Dim x As Single
Dim y As Single
Dim r As Integer
Dim c As Integer
Dim i As Integer
Dim Value As Integer
Dim num_items As Integer
Dim row_hdr As HeaderCell
Dim col_hdr As HeaderCell
Dim cell As VerySparseArrayCell

    wid = ArrayLabel(0).Width + GAP
    hgt = ArrayLabel(0).Height + GAP

    ' Display column headers.
    x = ArrayLabel(0).Left + wid
    y = ArrayLabel(0).Top
    i = 1
    Set col_hdr = the_array.ColSentinel.NextHeader
    Do While Not (col_hdr Is Nothing)
        If i > MaxItems Then
            Load ArrayLabel(i)
            MaxItems = i
        End If
        ArrayLabel(i).Move x, y
        x = x + wid
        ArrayLabel(i).Caption = "Col" & _
            Str$(col_hdr.RowOrCol)
        i = i + 1
        Set col_hdr = col_hdr.NextHeader
    Loop    ' End displaying column headers.
    
    ' Display rows.
    y = y + hgt
    r = 1
    Set row_hdr = the_array.RowSentinel.NextHeader
    Do While Not (row_hdr Is Nothing)
        ' Label the row header.
        If i > MaxItems Then
            Load ArrayLabel(i)
            MaxItems = i
        End If
        ArrayLabel(i).Move ArrayLabel(0).Left, y
        ArrayLabel(i).Caption = "Row" & _
            Str$(row_hdr.RowOrCol)
        i = i + 1

        ' Display the row entries.
        Set col_hdr = the_array.ColSentinel.NextHeader
        c = 1
        Do While Not (col_hdr Is Nothing)
            Value = the_array.Value( _
                row_hdr.RowOrCol, col_hdr.RowOrCol)
            If Value <> the_array.NoValue Then
                x = ArrayLabel(0).Left + c * wid
                If i > MaxItems Then
                    Load ArrayLabel(i)
                    MaxItems = i
                End If
                ArrayLabel(i).Move x, y
                ArrayLabel(i).Caption = _
                    Format$(Value)
                i = i + 1
            End If
            Set col_hdr = col_hdr.NextHeader
            c = c + 1
        Loop    ' End displaying this row.
        
        Set row_hdr = row_hdr.NextHeader
        y = y + hgt
        r = r + 1
    Loop    ' End displaying rows.
    
    ' Make needed items visible.
    num_items = i - 1
    For i = 1 To num_items
        ArrayLabel(i).Visible = True
    Next i
    For i = num_items + 1 To MaxItems
        ArrayLabel(i).Visible = False
    Next i
End Sub

Private Sub mnuFileExit_Click()
    End
End Sub

' *******************************************************
' Present help about this program.
' *******************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String
    
    txt = "This program manages a sparse array." & vbCrLf & vbCrLf
    txt = txt & "Enter a row, column, and value, and click the Set button to set the value for that entry. If the position does not exist, the program creates it." & vbCrLf & vbCrLf
    txt = txt & "Enter a row and column, and click the Get button to retrieve the value for that entry. If the position does not exist, the program returns 0." & vbCrLf & vbCrLf
    txt = txt & "If you set the value of a position to 0, that position is automatically removed from the array."

    MsgBox txt, vbOKOnly, "Help About ... Sparse"
End Sub




