VERSION 4.00
Begin VB.Form FibonacciForm 
   Appearance      =   0  'Flat
   Caption         =   "Fibo"
   ClientHeight    =   3090
   ClientLeft      =   3030
   ClientTop       =   1560
   ClientWidth     =   2430
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   3780
   Icon            =   "Fibo.frx":0000
   Left            =   2970
   LinkTopic       =   "FibonacciForm"
   ScaleHeight     =   3090
   ScaleWidth      =   2430
   Top             =   930
   Width           =   2550
   Begin VB.CommandButton CmdGo 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   495
      Left            =   600
      TabIndex        =   2
      Top             =   2400
      Width           =   1215
   End
   Begin VB.TextBox NText 
      Height          =   285
      Left            =   720
      TabIndex        =   0
      Top             =   120
      Width           =   495
   End
   Begin VB.Label TimeLabel 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   1320
      TabIndex        =   9
      Top             =   1920
      Width           =   975
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "Ellapsed time"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   4
      Left            =   120
      TabIndex        =   10
      Top             =   1920
      Width           =   1215
   End
   Begin VB.Label OtherCasesLabel 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   720
      TabIndex        =   8
      Top             =   1320
      Width           =   1215
   End
   Begin VB.Label BaseCasesLabel 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   720
      TabIndex        =   7
      Top             =   960
      Width           =   1215
   End
   Begin VB.Label FibNLabel 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   720
      TabIndex        =   6
      Top             =   480
      Width           =   1215
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "H(N)"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   3
      Left            =   120
      TabIndex        =   5
      Top             =   1320
      Width           =   615
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "G(N)"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   2
      Left            =   120
      TabIndex        =   4
      Top             =   960
      Width           =   615
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "Fib(N)"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   3
      Top             =   480
      Width           =   615
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "N"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   255
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "FibonacciForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Fibo.FRM
'
' Recursive Fibonacci number example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Dim BaseCases As Double   ' # times we reach the base case.
Dim OtherCases As Double  ' # times we execute the function.

' *******************************************************
' Perform the calculation.
' *******************************************************
Private Sub CmdGo_Click()
Dim N As Integer
Dim FibN As Double
Dim status As Integer
Dim start_time As Double

    If Not IsNumeric(NText.Text) Then
        Beep
        Exit Sub
    End If

    BaseCases = 0
    OtherCases = 0
    FibNLabel.Caption = ""
    BaseCasesLabel.Caption = ""
    OtherCasesLabel.Caption = ""
    TimeLabel.Caption = ""
    MousePointer = vbHourglass
    DoEvents

    N = CInt(NText.Text)
    
    On Error Resume Next
    start_time = Timer
    FibN = Fib(N)
    status = Err
    TimeLabel.Caption = Format(Timer - start_time, "0.00")
    
    MousePointer = vbDefault
    
    If status = 0 Then
        FibNLabel.Caption = Format$(FibN)
        BaseCasesLabel.Caption = Format$(BaseCases)
        OtherCasesLabel.Caption = Format$(OtherCases)
    Else
        Beep
        MsgBox Error$(status), , "Error"
    End If
End Sub

' ************************************************
' Recursively compute the Fibonacci number.
' ************************************************
Private Function Fib(ByVal N As Integer) As Double
    If N <= 1 Then
        Fib = N
        BaseCases = BaseCases + 1
    Else
        Fib = Fib(N - 1) + Fib(N - 2)
        OtherCases = OtherCases + 1
    End If
End Function

Private Sub mnuFileExit_Click()
    End
End Sub

' *******************************************************
' Present help for this program.
' *******************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String
    
    txt = "This program computes Fibonacci numbers recursively." & vbCrLf & vbCrLf
    txt = txt & "Fibonacci numbers are defined recursively by:" & vbCrLf
    txt = txt & "    Fib(0) = 0" & vbCrLf
    txt = txt & "    Fib(1) = 1" & vbCrLf
    txt = txt & "    Fib(N) = Fib(N-1) + Fib(N-2)        for N > 1." & vbCrLf & vbCrLf
    txt = txt & "Enter a value and click the Go button to calculate the Fibonacci number." & vbCrLf & vbCrLf
    txt = txt & "G(N) is the number of times the recursion's base case is reached." & vbCrLf & vbCrLf
    txt = txt & "H(N) is the number of times the function recurses (does not reach the base case)."

    MsgBox txt, vbOKOnly, "Help About ... Fibo"
End Sub

