VERSION 4.00
Begin VB.Form FibonacciForm 
   Appearance      =   0  'Flat
   Caption         =   "Fibo3"
   ClientHeight    =   1560
   ClientLeft      =   3030
   ClientTop       =   1560
   ClientWidth     =   3225
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   2250
   Icon            =   "Fibo3.frx":0000
   Left            =   2970
   LinkTopic       =   "FibonacciForm"
   ScaleHeight     =   1560
   ScaleWidth      =   3225
   Top             =   930
   Width           =   3345
   Begin VB.CommandButton CmdGo 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   495
      Left            =   1080
      TabIndex        =   2
      Top             =   960
      Width           =   1215
   End
   Begin VB.TextBox NText 
      Height          =   285
      Left            =   720
      TabIndex        =   0
      Top             =   120
      Width           =   615
   End
   Begin VB.Label FibNLabel 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   720
      TabIndex        =   4
      Top             =   480
      Width           =   2415
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "Fib(N)"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   3
      Top             =   480
      Width           =   615
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "N"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   255
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "FibonacciForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Fibo3.FRM
'
' Recursive Fibonacci number with lookup table
' example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Const MAX_FIB = 1476   ' The largest value we will compute.

Dim FibValues(0 To MAX_FIB) As Double

' ************************************************
' Initialize the table of Fibonacci values.
' ************************************************
Private Sub InitializeFibValues()
Dim i As Integer

    FibValues(0) = 0
    FibValues(1) = 1
    For i = 2 To MAX_FIB
        FibValues(i) = FibValues(i - 1) + FibValues(i - 2)
    Next i
End Sub

' ************************************************
' Look the value up in the table.
' ************************************************
Private Function Fib(ByVal N As Integer) As Double
    Fib = FibValues(N)
End Function

' *******************************************************
' Perform the calculation.
' *******************************************************
Private Sub CmdGo_Click()
Dim N As Integer
Dim FibN As Double
Dim status As Integer

    If Not IsNumeric(NText.Text) Then
        Beep
        Exit Sub
    End If

    N = CInt(NText.Text)
    
    On Error Resume Next
    FibN = Fib(N)
    status = Err
    
    If status = 0 Then
        FibNLabel.Caption = Format$(FibN)
    Else
        Beep
        MsgBox Error$(status), , "Error"
    End If
End Sub


Private Sub Form_Load()
    ' Initialize the table of values.
    InitializeFibValues
End Sub

Private Sub mnuFileExit_Click()
    End
End Sub

' *******************************************************
' Present help for this program.
' *******************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String
    
    txt = "This program computes Fibonacci numbers non-recursively using a lookup table." & vbCrLf & vbCrLf
    txt = txt & "Fibonacci numbers are defined recursively by:" & vbCrLf
    txt = txt & "    Fib(0) = 0" & vbCrLf
    txt = txt & "    Fib(1) = 1" & vbCrLf
    txt = txt & "    Fib(N) = Fib(N-1) + Fib(N-2)        for N > 1." & vbCrLf & vbCrLf
    txt = txt & "Enter a value and click the Go button to calculate the Fibonacci number."

    MsgBox txt, vbOKOnly, "Help About ... Fibo3"
End Sub

