VERSION 4.00
Begin VB.Form GCDForm 
   Appearance      =   0  'Flat
   Caption         =   "GCD2"
   ClientHeight    =   2325
   ClientLeft      =   3060
   ClientTop       =   1860
   ClientWidth     =   3315
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   3015
   Icon            =   "GCD2.frx":0000
   Left            =   3000
   LinkTopic       =   "GCDForm"
   ScaleHeight     =   2325
   ScaleWidth      =   3315
   Top             =   1230
   Width           =   3435
   Begin VB.TextBox BText 
      Height          =   285
      Left            =   1440
      TabIndex        =   1
      Top             =   480
      Width           =   1215
   End
   Begin VB.CommandButton CmdGo 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   495
      Left            =   1080
      TabIndex        =   2
      Top             =   1680
      Width           =   1215
   End
   Begin VB.TextBox AText 
      Height          =   285
      Left            =   1440
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "B"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   1
      Left            =   1200
      TabIndex        =   4
      Top             =   480
      Width           =   255
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "A"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   0
      Left            =   1200
      TabIndex        =   6
      Top             =   120
      Width           =   255
   End
   Begin VB.Label GCDLabel 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   1440
      TabIndex        =   5
      Top             =   1080
      Width           =   1215
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "GCD(A, B)"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   2
      Left            =   480
      TabIndex        =   3
      Top             =   1080
      Width           =   975
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "GCDForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' GCD2.FRM
'
' Non-recursive GCD example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

' *******************************************************
' Start the computation.
' *******************************************************
Private Sub CmdGo_Click()
Dim A As Long
Dim B As Long
Dim result As Long

    GCDLabel.Caption = ""
    
    If Not IsNumeric(AText.Text) Then
        Beep
        AText.SetFocus
        Exit Sub
    End If
    If Not IsNumeric(BText.Text) Then
        Beep
        BText.SetFocus
        Exit Sub
    End If

    On Error Resume Next
    
    A = CLng(AText.Text)
    If Err <> 0 Then
        Beep
        MsgBox Error$
        AText.SetFocus
        Exit Sub
    End If

    B = CLng(BText.Text)
    If Err <> 0 Then
        Beep
        MsgBox Error$
        BText.SetFocus
        Exit Sub
    End If

    result = GCD(A, B)
    If Err <> 0 Then
        Beep
        MsgBox Error$, , "Error"
        Exit Sub
    End If
        
    GCDLabel.Caption = Format$(result)
End Sub


' ************************************************
' Recursively compute the GCD of to numbers.
' ************************************************
Private Function GCD(ByVal A As Double, ByVal B As Double) As Double
Dim B_Mod_A As Double

    B_Mod_A = B Mod A
    Do While B_Mod_A <> 0
        ' Prepare the arguments for the "recursion."
        B = A
        A = B_Mod_A
        B_Mod_A = B Mod A
    Loop
    GCD = A
End Function

Private Sub mnuFileExit_Click()
    End
End Sub

' *******************************************************
' Present help about this program.
' *******************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String
    
    txt = "This program computes the greatest common divisor of two numbers non-recursively." & vbCrLf & vbCrLf
    txt = txt & "Enter values for A and B and click the Go button to calculate GCD(A, B)."

    MsgBox txt, vbOKOnly, "Help About ... GCD2"
End Sub

