VERSION 4.00
Begin VB.Form HilbertForm 
   Appearance      =   0  'Flat
   Caption         =   "Hilbert2"
   ClientHeight    =   3900
   ClientLeft      =   1890
   ClientTop       =   1785
   ClientWidth     =   4845
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   4590
   Icon            =   "Hilbert2.frx":0000
   Left            =   1830
   LinkTopic       =   "Form1"
   ScaleHeight     =   3900
   ScaleWidth      =   4845
   Top             =   1155
   Width           =   4965
   Begin VB.PictureBox HilbertPicture 
      Appearance      =   0  'Flat
      BackColor       =   &H00FFFF00&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   3855
      Left            =   960
      ScaleHeight     =   3855
      ScaleWidth      =   3855
      TabIndex        =   3
      Top             =   0
      Width           =   3855
   End
   Begin VB.CommandButton CmdGo 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   2280
      Width           =   735
   End
   Begin VB.TextBox DepthText 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Top             =   360
      Width           =   495
   End
   Begin VB.Label TimeLabel 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   1800
      Width           =   735
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "Time"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   2
      Left            =   120
      TabIndex        =   4
      Top             =   1560
      Width           =   735
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "Depth"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   615
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "HilbertForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Hilbert2.FRM
'
' Non-recursive Hilbert curve example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Const STACK_SIZE = 20
Dim DepthStack(0 To STACK_SIZE)
Dim DxStack(0 To STACK_SIZE)
Dim DyStack(0 To STACK_SIZE)
Dim PCStack(0 To STACK_SIZE)
Dim TopOfStack As Integer

' *******************************************************
' Start drawing the curve.
' *******************************************************
Private Sub CmdGo_Click()
Dim start_time As Double
Dim Depth As Integer
Dim gaps As Single
Dim dist As Single
Dim margin As Single

    If Not IsNumeric(DepthText.Text) Then
        Beep
        Exit Sub
    End If

    Depth = CInt(DepthText.Text)
    If Depth < 1 Or Depth > 10 Then
        Beep
        Exit Sub
    End If
    
    MousePointer = vbHourglass

    ' See how long each line segment must be to fill the
    ' drawing area well.
    margin = 120
    gaps = (2 ^ Depth) - 1
    dist = (HilbertPicture.ScaleWidth - 2 * margin) / gaps

    HilbertPicture.Cls
    HilbertPicture.CurrentX = margin
    HilbertPicture.CurrentY = margin
    
    start_time = Timer
    Hilbert Depth, dist, 0
    TimeLabel.Caption = Format$(Timer - start_time, "0.00")

    MousePointer = vbDefault
End Sub


' *******************************************************
' Make the drawing area as big as possible for the new
' form size.
' *******************************************************
Private Sub Form_Resize()
Dim wid As Single
Dim hgt As Single

    ' Bail out if we're shrunk to an icon.
    If WindowState = 1 Then Exit Sub

    wid = ScaleWidth - HilbertPicture.Left - HilbertPicture.Top
    hgt = ScaleHeight - 2 * HilbertPicture.Top
    If hgt < wid Then wid = hgt
    HilbertPicture.Width = wid
    HilbertPicture.Height = wid
End Sub

' ************************************************
' Draw the Hilbert curve.
'
' Dx and Dy indicate the direction for the first
' part of the curve. In other words, if the curve
' starts at (x, y) it should finish at (X + Dx,
' y + Dy) after it has drawn the first third of
' the curve.
' ************************************************
Private Sub Hilbert(Depth As Integer, Dx As Single, Dy As Single)
Dim pc As Integer
Dim tmp As Single

    pc = 1
    Do
        Select Case pc
            Case 1
                If Depth > 1 Then   ' Recurse.
                    ' Save the current values.
                    SaveValues Depth, Dx, Dy, 2
                    ' Prepare for the recursion.
                    Depth = Depth - 1
                    tmp = Dx
                    Dx = Dy
                    Dy = tmp
                    pc = 1  ' Go to start of recursive call.
                Else        ' Base case.
                    ' We have recursed deeply enough.
                    ' Continue with code block 2.
                    pc = 2
                End If
            Case 2
                HilbertPicture.Line -Step(Dx, Dy)
                If Depth > 1 Then ' Recurse.
                    ' Save the current values.
                    SaveValues Depth, Dx, Dy, 3
                    ' Prepare for the recursion.
                    Depth = Depth - 1
                    ' Dx and Dy remain the same.
                    pc = 1  ' Go to start of recursive call.
                Else        ' Base case.
                    ' We have recursed deeply enough.
                    ' Continue with code block 3.
                    pc = 3
                End If
            Case 3
                HilbertPicture.Line -Step(Dy, Dx)
                If Depth > 1 Then ' Recurse.
                    ' Save the current values.
                    SaveValues Depth, Dx, Dy, 4
                    ' Prepare for the recursion.
                    Depth = Depth - 1
                    ' Dx and Dy remain the same.
                    pc = 1  ' Go to start of recursive call.
                Else        ' Base case.
                    ' We have recursed deeply enough.
                    ' Continue with code block 4.
                    pc = 4
                End If
            Case 4
                HilbertPicture.Line -Step(-Dx, -Dy)
                If Depth > 1 Then       ' Recurse.
                    ' Save the current values.
                    SaveValues Depth, Dx, Dy, 0
                    ' Prepare for the recursion.
                    Depth = Depth - 1
                    tmp = Dx
                    Dx = -Dy
                    Dy = -tmp
                    pc = 1  ' Go to start of recursive call.
                Else        ' Base case.
                    ' We have recursed deeply enough.
                    ' This is the end of this recursive call.
                    pc = 0
                End If
            Case 0  ' Return from recursion.
                If TopOfStack > 0 Then
                    RestoreValues Depth, Dx, Dy, pc
                Else
                    ' The stack is empty. We are done.
                    Exit Do
                End If
        End Select
    Loop
End Sub

' ************************************************
' Push values onto the stacks.
' ************************************************
Private Sub SaveValues(Depth As Integer, Dx As Single, Dy As Single, pc As Integer)
    TopOfStack = TopOfStack + 1
    DepthStack(TopOfStack) = Depth
    DxStack(TopOfStack) = Dx
    DyStack(TopOfStack) = Dy
    PCStack(TopOfStack) = pc
End Sub

' ************************************************
' Pop values off of the stacks.
' ************************************************
Sub RestoreValues(Depth As Integer, Dx As Single, Dy As Single, pc As Integer)
    Depth = DepthStack(TopOfStack)
    Dx = DxStack(TopOfStack)
    Dy = DyStack(TopOfStack)
    pc = PCStack(TopOfStack)
    TopOfStack = TopOfStack - 1
End Sub

Private Sub mnuFileExit_Click()
    End
End Sub

' *******************************************************
' Present help about this program.
' *******************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String
    
    txt = "This program draws Hilbert curves non-recursively." & vbCrLf & vbCrLf
    txt = txt & "Enter the maximum depth of ""recursion"" for the curve (start small) and click the Go button."

    MsgBox txt, vbOKOnly, "Help About ... Hilbert2"
End Sub

