VERSION 4.00
Begin VB.Form SirpinskiForm 
   Appearance      =   0  'Flat
   Caption         =   "Sierp"
   ClientHeight    =   4005
   ClientLeft      =   1890
   ClientTop       =   1785
   ClientWidth     =   4980
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   4695
   Icon            =   "Sierp.frx":0000
   Left            =   1830
   LinkTopic       =   "Form1"
   ScaleHeight     =   4005
   ScaleWidth      =   4980
   Top             =   1155
   Width           =   5100
   Begin VB.PictureBox SierpPicture 
      Appearance      =   0  'Flat
      BackColor       =   &H00FFFF00&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   3975
      Left            =   960
      ScaleHeight     =   3975
      ScaleWidth      =   3975
      TabIndex        =   3
      Top             =   0
      Width           =   3975
   End
   Begin VB.CommandButton CmdGo 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   2280
      Width           =   735
   End
   Begin VB.TextBox DepthText 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Top             =   360
      Width           =   495
   End
   Begin VB.Label TimeLabel 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   1800
      Width           =   735
   End
   Begin VB.Label LoopsLabel 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   1200
      Width           =   735
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "Loops"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   4
      Top             =   960
      Width           =   615
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "Depth"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   615
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "Time"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   2
      Left            =   120
      TabIndex        =   7
      Top             =   1560
      Width           =   615
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "SirpinskiForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Sierp.FRM
'
' Recursive Sierpinski curve example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
' A = top    = A + B, left,  D + A
' B = left   = B + C, down,  A + B
' C = bottom = C + D, right, B + C
' D = right  = D + A, up,    C + D
Option Explicit

Dim Loops As Double

' *******************************************************
' Start drawing the curve. This requires computing how
' long each line should be to fill the drawing area well.
' *******************************************************
Private Sub CmdGo_Click()
Dim Depth As Integer
Dim gaps As Single
Dim Dist As Single
Dim margin As Single
Dim start_time As Double

    LoopsLabel.Caption = ""
    TimeLabel.Caption = ""
    Loops = 0

    If Not IsNumeric(DepthText.Text) Then
        Beep
        Exit Sub
    End If

    Depth = CInt(DepthText.Text)
    If Depth < 1 Or Depth > 10 Then
        Beep
        Exit Sub
    End If
    
    ' Compute the Dx and Dy distances need to be when
    ' drawing lines so we fill the drawing area well.
    margin = 120
    gaps = 3 * 2 ^ Depth - 1
    Dist = (SierpPicture.ScaleWidth - 2 * margin) / gaps

    SierpPicture.Cls
    SierpPicture.CurrentX = margin
    SierpPicture.CurrentY = margin + Dist
    
    MousePointer = vbHourglass
    DoEvents
    start_time = Timer
    Sierpinski Depth, Dist
    TimeLabel.Caption = Format$(Timer - start_time, "0.00")
    MousePointer = vbDefault

    LoopsLabel.Caption = Format$(Loops)
End Sub

Private Sub Form_Resize()
Dim wid As Single
Dim hgt As Single

    ' Bail out if we're shrunk to an icon.
    If WindowState = 1 Then Exit Sub
    
    wid = ScaleWidth - SierpPicture.Left - SierpPicture.Top
    hgt = ScaleHeight - 2 * SierpPicture.Top
    If hgt < wid Then wid = hgt
    SierpPicture.Width = wid
    SierpPicture.Height = wid
End Sub

Private Sub mnuFileExit_Click()
    End
End Sub

' *******************************************************
' Display help for this program.
' *******************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String
    
    txt = "This program draws Sierpinski curves recursively." & vbCrLf & vbCrLf
    txt = txt & "Enter the maximum depth of recursion (start small) for the curve and click the Go button."

    MsgBox txt, vbOKOnly, "Help About ... Sierp"
End Sub

' ************************************************
' Draw a type A curve across the top.
' ************************************************
Private Sub SierpA(ByVal Depth As Integer, ByVal Dist As Single)
    Loops = Loops + 1

    If Depth = 1 Then
        SierpPicture.Line -Step(-Dist, Dist)
        SierpPicture.Line -Step(-Dist, 0)
        SierpPicture.Line -Step(-Dist, -Dist)
    Else
        SierpA Depth - 1, Dist
        SierpPicture.Line -Step(-Dist, Dist)
        SierpB Depth - 1, Dist
        SierpPicture.Line -Step(-Dist, 0)
        SierpD Depth - 1, Dist
        SierpPicture.Line -Step(-Dist, -Dist)
        SierpA Depth - 1, Dist
    End If
End Sub

' ************************************************
' Draw a type B curve down the left side.
' ************************************************
Private Sub SierpB(ByVal Depth As Integer, ByVal Dist As Single)
    Loops = Loops + 1

    If Depth = 1 Then
        SierpPicture.Line -Step(Dist, Dist)
        SierpPicture.Line -Step(0, Dist)
        SierpPicture.Line -Step(-Dist, Dist)
    Else
        SierpB Depth - 1, Dist
        SierpPicture.Line -Step(Dist, Dist)
        SierpC Depth - 1, Dist
        SierpPicture.Line -Step(0, Dist)
        SierpA Depth - 1, Dist
        SierpPicture.Line -Step(-Dist, Dist)
        SierpB Depth - 1, Dist
    End If
End Sub

' ************************************************
' Draw a type C curve across the bottom.
' ************************************************
Private Sub SierpC(ByVal Depth As Integer, ByVal Dist As Single)
    Loops = Loops + 1

    If Depth = 1 Then
        SierpPicture.Line -Step(Dist, -Dist)
        SierpPicture.Line -Step(Dist, 0)
        SierpPicture.Line -Step(Dist, Dist)
    Else
        SierpC Depth - 1, Dist
        SierpPicture.Line -Step(Dist, -Dist)
        SierpD Depth - 1, Dist
        SierpPicture.Line -Step(Dist, 0)
        SierpB Depth - 1, Dist
        SierpPicture.Line -Step(Dist, Dist)
        SierpC Depth - 1, Dist
    End If
End Sub

' ************************************************
' Draw a type D curve up the right side.
' ************************************************
Private Sub SierpD(ByVal Depth As Integer, ByVal Dist As Single)
    Loops = Loops + 1

    If Depth = 1 Then
        SierpPicture.Line -Step(-Dist, -Dist)
        SierpPicture.Line -Step(0, -Dist)
        SierpPicture.Line -Step(Dist, -Dist)
    Else
        SierpD Depth - 1, Dist
        SierpPicture.Line -Step(-Dist, -Dist)
        SierpA Depth - 1, Dist
        SierpPicture.Line -Step(0, -Dist)
        SierpC Depth - 1, Dist
        SierpPicture.Line -Step(Dist, -Dist)
        SierpD Depth - 1, Dist
    End If
End Sub

' ************************************************
' Draw and connect type B, C, D, and A curves to
' create the complete Sierpinski curve.
' ************************************************
Private Sub Sierpinski(ByVal Depth As Integer, ByVal Dist As Single)
    ' This is sort of the first call.
    Loops = Loops + 1

    SierpB Depth, Dist
    SierpPicture.Line -Step(Dist, Dist)
    SierpC Depth, Dist
    SierpPicture.Line -Step(Dist, -Dist)
    SierpD Depth, Dist
    SierpPicture.Line -Step(-Dist, -Dist)
    SierpA Depth, Dist
    SierpPicture.Line -Step(-Dist, Dist)
End Sub

