VERSION 4.00
Begin VB.Form SirpinskiForm 
   Appearance      =   0  'Flat
   Caption         =   "Sierp2"
   ClientHeight    =   4005
   ClientLeft      =   1890
   ClientTop       =   1785
   ClientWidth     =   4980
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   4695
   Icon            =   "Sierp2.frx":0000
   Left            =   1830
   LinkTopic       =   "Form1"
   ScaleHeight     =   4005
   ScaleWidth      =   4980
   Top             =   1155
   Width           =   5100
   Begin VB.PictureBox SierpPicture 
      Appearance      =   0  'Flat
      BackColor       =   &H00FFFF00&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   3975
      Left            =   960
      ScaleHeight     =   3975
      ScaleWidth      =   3975
      TabIndex        =   3
      Top             =   0
      Width           =   3975
   End
   Begin VB.CommandButton CmdGo 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   2280
      Width           =   735
   End
   Begin VB.TextBox DepthText 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Top             =   360
      Width           =   495
   End
   Begin VB.Label TimeLabel 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   1800
      Width           =   735
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "Depth"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   615
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "Time"
      ForeColor       =   &H80000008&
      Height          =   255
      Index           =   2
      Left            =   120
      TabIndex        =   5
      Top             =   1560
      Width           =   615
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "SirpinskiForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Sierp2.FRM
'
' Non-recursive Sierpinski curve example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Dim Dist As Single

Const STACK_SIZE = 20
Dim DepthStack(0 To STACK_SIZE)
Dim PCStack(0 To STACK_SIZE)
Dim TopOfStack As Integer

' ************************************************
' Pop values off of the stacks.
' ************************************************
Sub RestoreValues(Depth As Integer, pc As Integer)
    Depth = DepthStack(TopOfStack)
    pc = PCStack(TopOfStack)
    TopOfStack = TopOfStack - 1
End Sub
' ************************************************
' Push values onto the stacks.
' ************************************************
Private Sub SaveValues(Depth As Integer, pc As Integer)
    TopOfStack = TopOfStack + 1
    DepthStack(TopOfStack) = Depth
    PCStack(TopOfStack) = pc
End Sub

' *******************************************************
' Start drawing the curve. This requires computing how
' long each line should be to fill the drawing area well.
' *******************************************************
Private Sub CmdGo_Click()
Dim Depth As Integer
Dim gaps As Single
Dim margin As Single
Dim start_time As Double

    TimeLabel.Caption = ""

    If Not IsNumeric(DepthText.Text) Then
        Beep
        Exit Sub
    End If

    Depth = CInt(DepthText.Text)
    If Depth < 1 Or Depth > 10 Then
        Beep
        Exit Sub
    End If
    
    ' Compute the Dx and Dy distances need to be when
    ' drawing lines so we fill the drawing area well.
    margin = 120
    gaps = 3 * 2 ^ Depth - 1
    Dist = (SierpPicture.ScaleWidth - 2 * margin) / gaps

    SierpPicture.Cls
    SierpPicture.CurrentX = margin
    SierpPicture.CurrentY = margin + Dist
    
    MousePointer = vbHourglass
    DoEvents
    start_time = Timer
    Sierpinski Depth
    TimeLabel.Caption = Format$(Timer - start_time, "0.00")
    MousePointer = vbDefault
End Sub

Private Sub Form_Resize()
Dim wid As Single
Dim hgt As Single

    ' Bail out if we're shrunk to an icon.
    If WindowState = 1 Then Exit Sub
    
    wid = ScaleWidth - SierpPicture.Left - SierpPicture.Top
    hgt = ScaleHeight - 2 * SierpPicture.Top
    If hgt < wid Then wid = hgt
    SierpPicture.Width = wid
    SierpPicture.Height = wid
End Sub

Private Sub mnuFileExit_Click()
    End
End Sub

' *******************************************************
' Display help for this program.
' *******************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String
    
    txt = "This program draws Sierpinski curves non-recursively." & vbCrLf & vbCrLf
    txt = txt & "Enter the maximum depth of ""recursion"" (start small) for the curve and click the Go button."

    MsgBox txt, vbOKOnly, "Help About ... Sierp2"
End Sub

' ************************************************
' Draw a Sierpinski sub-curve.
' ************************************************
Private Sub SierpAll(Depth As Integer, pc As Integer)
    Do
        Select Case pc
            ' **********
            ' * SierpA *
            ' **********
            Case 11
                If Depth <= 1 Then
                    SierpPicture.Line -Step(-Dist, Dist)
                    SierpPicture.Line -Step(-Dist, 0)
                    SierpPicture.Line -Step(-Dist, -Dist)
                    pc = 0
                Else
                    SaveValues Depth, 12    ' Run SierpA
                    Depth = Depth - 1
                    pc = 11
                End If
            Case 12
                SierpPicture.Line -Step(-Dist, Dist)
                SaveValues Depth, 13        ' Run SierpB
                Depth = Depth - 1
                pc = 21
            Case 13
                SierpPicture.Line -Step(-Dist, 0)
                SaveValues Depth, 14        ' Run SierpD
                Depth = Depth - 1
                pc = 41
            Case 14
                SierpPicture.Line -Step(-Dist, -Dist)
                SaveValues Depth, 0         ' Run SierpA
                Depth = Depth - 1
                pc = 11
            ' **********
            ' * SierpB *
            ' **********
            Case 21
                If Depth <= 1 Then
                    SierpPicture.Line -Step(Dist, Dist)
                    SierpPicture.Line -Step(0, Dist)
                    SierpPicture.Line -Step(-Dist, Dist)
                    pc = 0
                Else
                    SaveValues Depth, 22    ' Run SierpB
                    Depth = Depth - 1
                    pc = 21
                End If
            Case 22
                SierpPicture.Line -Step(Dist, Dist)
                SaveValues Depth, 23        ' Run SierpC
                Depth = Depth - 1
                pc = 31
            Case 23
                SierpPicture.Line -Step(0, Dist)
                SaveValues Depth, 24        ' Run SierpA
                Depth = Depth - 1
                pc = 11
            Case 24
                SierpPicture.Line -Step(-Dist, Dist)
                SaveValues Depth, 0        ' Run SierpB
                Depth = Depth - 1
                pc = 21
            ' **********
            ' * SierpC *
            ' **********
            Case 31
                If Depth <= 1 Then
                    SierpPicture.Line -Step(Dist, -Dist)
                    SierpPicture.Line -Step(Dist, 0)
                    SierpPicture.Line -Step(Dist, Dist)
                    pc = 0
                Else
                    SaveValues Depth, 32    ' Run SierpC
                    Depth = Depth - 1
                    pc = 31
                End If
            Case 32
                SierpPicture.Line -Step(Dist, -Dist)
                SaveValues Depth, 33        ' Run SierpD
                Depth = Depth - 1
                pc = 41
            Case 33
                SierpPicture.Line -Step(Dist, 0)
                SaveValues Depth, 34        ' Run SierpB
                Depth = Depth - 1
                pc = 21
            Case 34
                SierpPicture.Line -Step(Dist, Dist)
                SaveValues Depth, 0         ' Run SierpC
                Depth = Depth - 1
                pc = 31
            ' **********
            ' * SierpD *
            ' **********
            Case 41
                If Depth <= 1 Then
                    SierpPicture.Line -Step(-Dist, -Dist)
                    SierpPicture.Line -Step(0, -Dist)
                    SierpPicture.Line -Step(Dist, -Dist)
                    pc = 0
                Else
                    SaveValues Depth, 42    ' Run SierpD
                    Depth = Depth - 1
                    pc = 41
                End If
            Case 42
                SierpPicture.Line -Step(-Dist, -Dist)
                SaveValues Depth, 43        ' Run SierpA
                Depth = Depth - 1
                pc = 11
            Case 43
                SierpPicture.Line -Step(0, -Dist)
                SaveValues Depth, 44        ' Run SierpC
                Depth = Depth - 1
                pc = 31
            Case 44
                SierpPicture.Line -Step(Dist, -Dist)
                SaveValues Depth, 0         ' Run SierpD
                Depth = Depth - 1
                pc = 41
            ' *****************
            ' * End recursion *
            ' *****************
            Case 0
                If TopOfStack <= 0 Then Exit Do
                RestoreValues Depth, pc
        End Select
    Loop
End Sub




' ************************************************
' Draw and connect type B, C, D, and A curves to
' create the complete Sierpinski curve.
' ************************************************
Private Sub Sierpinski(ByVal Depth As Integer)
    SierpAll Depth, 21
    SierpPicture.Line -Step(Dist, Dist)
    SierpAll Depth, 31
    SierpPicture.Line -Step(Dist, -Dist)
    SierpAll Depth, 41
    SierpPicture.Line -Step(-Dist, -Dist)
    SierpAll Depth, 11
    SierpPicture.Line -Step(-Dist, Dist)
End Sub

