VERSION 4.00
Begin VB.Form BinaryForm 
   Appearance      =   0  'Flat
   Caption         =   "Binary"
   ClientHeight    =   3990
   ClientLeft      =   2220
   ClientTop       =   1920
   ClientWidth     =   4095
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   4680
   Icon            =   "Binary.frx":0000
   Left            =   2160
   LinkTopic       =   "Form1"
   ScaleHeight     =   3990
   ScaleWidth      =   4095
   Top             =   1290
   Width           =   4215
   Begin VB.CommandButton CmdAddRight 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Add Right"
      Enabled         =   0   'False
      Height          =   495
      Left            =   1440
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton CmdRemove 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Remove"
      Enabled         =   0   'False
      Height          =   495
      Left            =   2760
      TabIndex        =   2
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton CmdAddLeft 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Add Left"
      Enabled         =   0   'False
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label NodeLabel 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "0"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   3
      Top             =   720
      Visible         =   0   'False
      Width           =   375
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "BinaryForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Binary.FRM
'
' Main form for binary tree example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Const XGAP = 60
Const YGAP = 120

Dim Wid As Single
Dim Hgt As Single

' The root of the tree.
Dim Root As BinaryNode

' The currently selected node.
Dim SelectedNode As BinaryNode

' Index of last NodeLabel control loaded.
Dim MaxBox As Integer
' ************************************************
' Add a new left child to the selected node.
' ************************************************
Private Sub CmdAddLeft_Click()
Dim new_node As New BinaryNode
    
    MaxBox = MaxBox + 1
    Load NodeLabel(MaxBox)
    With NodeLabel(MaxBox)
        .Caption = Format$(MaxBox)
        .BackColor = BackColor
        .ForeColor = ForeColor
    End With
    Set new_node.Box = NodeLabel(MaxBox)
    
    Set SelectedNode.LeftChild = new_node
    
    SelectNode Nothing
    DisplayTree
End Sub

' ************************************************
' Add a new right child to the selected node.
' ************************************************
Private Sub CmdAddRight_Click()
Dim new_node As New BinaryNode
    
    MaxBox = MaxBox + 1
    Load NodeLabel(MaxBox)
    With NodeLabel(MaxBox)
        .Caption = Format$(MaxBox)
        .BackColor = BackColor
        .ForeColor = ForeColor
    End With
    Set new_node.Box = NodeLabel(MaxBox)
    
    Set SelectedNode.RightChild = new_node
    
    SelectNode Nothing
    DisplayTree
End Sub

' ************************************************
' Rmove the selected node and its descendants.
' ************************************************
Private Sub CmdRemove_Click()
    If Not (SelectedNode Is Nothing) Then _
        Root.DeleteDescendant SelectedNode

    SelectNode Nothing
    DisplayTree
End Sub

' ************************************************
' Display the node at the indicated y value. Start
' the descendants of the node at xmin. Return the
' maximum x position used by this node through the
' parameter xmin.
' ************************************************
Private Sub DisplayNode(node As BinaryNode, xmin As Single, ByVal y As Single)
Dim x1 As Single
Dim y1 As Single
Dim child As BinaryNode

    If node Is Nothing Then Exit Sub

    ' First display the children
    y1 = y + Hgt + YGAP
    x1 = xmin
    Set child = node.LeftChild
    If child Is Nothing Then
        x1 = x1 + Wid
    Else
        DisplayNode child, x1, y1
    End If

    Set child = node.RightChild
    If child Is Nothing Then
        If Not (node.LeftChild Is Nothing) _
            Then x1 = x1 + Wid + XGAP
    Else
        x1 = x1 + XGAP
        DisplayNode child, x1, y1
    End If

    ' Now display this node
    node.Box.Move (xmin + x1) / 2 - Wid / 2, y
    node.Box.Visible = True
    xmin = x1
End Sub

' ************************************************
' Display the entire tree by displaying the root
' node.
' ************************************************
Private Sub DisplayTree()
Dim xmin As Single

    xmin = CmdAddLeft.Left
    DisplayNode Root, xmin, NodeLabel(0).Top
    Refresh
End Sub

' ************************************************
' Draw lines between the center of each node and
' the centers of the node's children.
' ************************************************
Private Sub DrawLines(node As BinaryNode)
Dim x As Single
Dim y As Single
Dim child As BinaryNode

    If node Is Nothing Then Exit Sub
    
    x = node.Box.Left + node.Box.Width / 2
    y = node.Box.Top + node.Box.Height / 2
    
    DrawLines node.LeftChild
    DrawLines node.RightChild

    ' Draw lines to children
    Set child = node.LeftChild
    If Not (child Is Nothing) Then _
        Line (x, y)- _
            (child.Box.Left + child.Box.Width / 2, _
             child.Box.Top + child.Box.Height / 2)
    
    Set child = node.RightChild
    If Not (child Is Nothing) Then _
        Line (x, y)-( _
            child.Box.Left + child.Box.Width / 2, _
            child.Box.Top + child.Box.Height / 2)
End Sub

Private Sub Form_Load()
    Wid = NodeLabel(0).Width
    Hgt = NodeLabel(0).Height
    
    ' Create the root node.
    Set Root = New BinaryNode
    Load NodeLabel(1)
    Set Root.Box = NodeLabel(1)
    NodeLabel(1).Caption = "1"
    MaxBox = 1
    
    DisplayTree
End Sub

' *******************************************************
' Draw lines between the nodes.
' *******************************************************
Private Sub Form_Paint()
    DrawLines Root
End Sub

' ************************************************
' Redirect control box unload to mnuExit.
' ************************************************
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Set SelectedNode = Nothing
    Set Root = Nothing
    Unload Me
End Sub

Private Sub mnuFileExit_Click()
    Set SelectedNode = Nothing
    Set Root = Nothing
    Unload Me
End Sub

' *******************************************************
' Present help about this program.
' *******************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String
    
    txt = "This program allows you to manipulate a binary tree." & vbCrLf & vbCrLf
    txt = txt & "Select a node in the tree and the appropriate buttons will become enabled." & vbCrLf & vbCrLf
    txt = txt & "If you remove a node, all of its descendants will be removed as well."

    MsgBox txt, vbOKOnly, "Help About ... Binary"
End Sub

' *******************************************************
' Select the node the user clicked on.
' *******************************************************
Private Sub NodeLabel_Click(Index As Integer)
    SelectNode Root.FindNode(NodeLabel(Index))
End Sub

' ************************************************
' Highlight this node.
' ************************************************
Private Sub SelectNode(node As BinaryNode)
    If Not (SelectedNode Is Nothing) Then
        SelectedNode.Box.BackColor = BackColor
        SelectedNode.Box.ForeColor = ForeColor
    End If

    Set SelectedNode = node
    
    If SelectedNode Is Nothing Then
        CmdRemove.Enabled = False
        CmdAddLeft.Enabled = False
        CmdAddRight.Enabled = False
    Else
        SelectedNode.Box.BackColor = ForeColor
        SelectedNode.Box.ForeColor = BackColor
        CmdRemove.Enabled = _
            Not ((SelectedNode Is Nothing) Or _
                 (SelectedNode Is Root))
        CmdAddLeft.Enabled = (SelectedNode.LeftChild Is Nothing)
        CmdAddRight.Enabled = (SelectedNode.RightChild Is Nothing)
    End If
End Sub

