VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "NAryNode"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' NAryNode.CLS
'
' Node class for N-ary tree.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Public Children As New Collection

Public Box As Label
' ************************************************
' Delete the descendant node. Return True if the
' node is deleted.
' ************************************************
Public Function DeleteDescendant(target As NAryNode) As Boolean
Dim i As Integer
Dim child As NAryNode

    ' See if it's one of our children.
    For i = 1 To Children.Count
        If Children.Item(i) Is target Then
            Children.Remove i
            DeleteDescendant = True
            Exit Function
        End If
    Next i
    
    ' It's not one of our children. Recursively
    ' check the descendants.
    For Each child In Children
        If child.DeleteDescendant(target) Then
            DeleteDescendant = True
            Exit Function
        End If
    Next child
End Function
' ************************************************
' Find the node that corresponds to the Label.
' ************************************************
Public Function FindNode(ctl As Label) As NAryNode
Dim node As NAryNode
Dim child As NAryNode

    ' See if we are the one.
    If ctl = Box Then
        Set FindNode = Me
        Exit Function
    End If
    
    ' See if a child can find it.
    For Each child In Children
        Set node = child.FindNode(ctl)
        If Not (node Is Nothing) Then
            Set FindNode = node
            Exit Function
        End If
    Next child
    
    Set FindNode = Nothing
End Function

' ************************************************
' Unload the node's label control.
' ************************************************
Private Sub Class_Terminate()
    Unload Box
End Sub


