VERSION 4.00
Begin VB.Form TraverseForm 
   Appearance      =   0  'Flat
   Caption         =   "Trav1"
   ClientHeight    =   3750
   ClientLeft      =   2430
   ClientTop       =   1815
   ClientWidth     =   4830
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   4440
   Icon            =   "Trav1.frx":0000
   Left            =   2370
   LinkTopic       =   "Form1"
   ScaleHeight     =   3750
   ScaleWidth      =   4830
   Top             =   1185
   Width           =   4950
   Begin VB.TextBox ResultText 
      Height          =   615
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   1  'Horizontal
      TabIndex        =   7
      Top             =   3120
      Width           =   4815
   End
   Begin VB.CommandButton CmdBreadthFirst 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Breadth First"
      Height          =   375
      Left            =   0
      TabIndex        =   5
      Top             =   2640
      Width           =   1335
   End
   Begin VB.CommandButton CmdPostorder 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Postorder"
      Height          =   375
      Left            =   0
      TabIndex        =   4
      Top             =   2160
      Width           =   1335
   End
   Begin VB.CommandButton CmdPreorder 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Preorder"
      Height          =   375
      Left            =   0
      TabIndex        =   2
      Top             =   1200
      Width           =   1335
   End
   Begin VB.CommandButton CmdInorder 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Inorder"
      Height          =   375
      Left            =   0
      TabIndex        =   3
      Top             =   1680
      Width           =   1335
   End
   Begin VB.CommandButton CmdCreateTree 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Create Tree"
      Default         =   -1  'True
      Height          =   375
      Left            =   0
      TabIndex        =   1
      Top             =   360
      Width           =   1335
   End
   Begin VB.TextBox DepthText 
      Height          =   285
      Left            =   1080
      TabIndex        =   0
      Text            =   "3"
      Top             =   0
      Width           =   495
   End
   Begin VB.Label NodeLabel 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "0"
      Height          =   255
      Index           =   0
      Left            =   1440
      TabIndex        =   8
      Top             =   360
      Width           =   375
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      Caption         =   "Tree Height"
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   0
      TabIndex        =   6
      Top             =   0
      Width           =   1095
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "TraverseForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Trav1.FRM
'
' Main form for tree traversal example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Dim NumNodes As Integer
Dim Nodes() As Label

' ************************************************
' Perform a breadth first traversal of the tree.
'
' For complete trees stored in an array, this is
' simply a listing of the nodes in their array
' order. This is handy for this type of tree but
' generally much harder for other types of trees.
' ************************************************
Private Function BreadthFirstTraverse(node As Integer) As String
Dim txt As String
Dim i As Integer

    txt = ""
    For i = NumNodes - 1 To 0 Step -1
        txt = Str$(Nodes(i).Caption) & txt
    Next i
    BreadthFirstTraverse = txt
End Function

' ************************************************
' Perform a breadth first traversal of the tree.
' ************************************************
Private Sub CmdBreadthFirst_Click()
    ResultText.Text = BreadthFirstTraverse(0)
End Sub

' ************************************************
' Build a tree of the indicated depth.
' ************************************************
Private Sub CmdCreateTree_Click()
Dim depth As Integer

    On Error Resume Next
    depth = CInt(DepthText.Text)
    If Err <> 0 Then
        Beep
        MsgBox Error$
        DepthText.SetFocus
        Exit Sub
    End If
    If depth < 1 Or depth > 9 Then
        Beep
        Exit Sub
    End If

    MakeTree depth
    If Err <> 0 Then
        Beep
        MsgBox Error$
        DepthText.SetFocus
        Exit Sub
    End If
End Sub

' ************************************************
' Perform an inorder traversal of the tree.
' ************************************************
Private Sub CmdInorder_Click()
    ResultText.Text = InorderTraverse(0)
End Sub

' ************************************************
' Perform a postorder traversal of the tree.
' ************************************************
Private Sub CmdPostorder_Click()
    ResultText.Text = PostorderTraverse(0)
End Sub

' ************************************************
' Perform a preorder traversal of the tree.
' ************************************************
Private Sub CmdPreorder_Click()
    ResultText.Text = PreorderTraverse(0)
End Sub

' ************************************************
' Draw lines connecting the centers of each node
' with its children.
' ************************************************
Private Sub DrawLines()
Dim node As Integer
Dim x1 As Single
Dim y1 As Single
Dim x2 As Single
Dim y2 As Single

    ' Quit if there's nothing to draw.
    If NumNodes < 1 Then Exit Sub

    Cls
    For node = 0 To NumNodes \ 2 - 1
        x1 = NodeLabel(node).Left + NodeLabel(node).Width / 2
        y1 = NodeLabel(node).Top + NodeLabel(node).Height / 2
        
        x2 = NodeLabel(2 * node + 1).Left + NodeLabel(2 * node + 1).Width / 2
        y2 = NodeLabel(2 * node + 1).Top + NodeLabel(2 * node + 1).Height / 2
        Line (x1, y1)-(x2, y2)
        
        x2 = NodeLabel(2 * node + 2).Left + NodeLabel(2 * node + 2).Width / 2
        y2 = NodeLabel(2 * node + 2).Top + NodeLabel(2 * node + 2).Height / 2
        Line (x1, y1)-(x2, y2)
    Next node
End Sub


Private Sub Form_Load()
    MakeTree 1
End Sub

' *******************************************************
' Draw lines connecting the centers of each node with its
' children.
' *******************************************************
Private Sub Form_Paint()
    DrawLines
End Sub

' ************************************************
' Perform an inorder traversal of the tree.
' ************************************************
Private Function InorderTraverse(node As Integer) As String
Dim txt As String

    txt = ""
    If 2 * node + 1 < NumNodes Then txt = txt & InorderTraverse(2 * node + 1)
    txt = txt & Str$(Nodes(node).Caption)
    If 2 * node + 2 < NumNodes Then txt = txt & InorderTraverse(2 * node + 2)
    InorderTraverse = txt
End Function

' ************************************************
' Build a full, complete tree of the given depth.
' ************************************************
Private Sub MakeTree(depth As Integer)
Const GAP = 60

Static MaxNode As Integer

Dim wid As Single
Dim hgt As Single
Dim x As Single
Dim y As Single
Dim i As Integer

    ' Compute the number of nodes in the tree
    NumNodes = 1
    For i = 1 To depth
        NumNodes = NumNodes * 2
    Next i
    NumNodes = NumNodes - 1
    ReDim Nodes(0 To NumNodes - 1)

    ' Create the needed controls
    For i = MaxNode + 1 To NumNodes - 1
        Load NodeLabel(i)
    Next i
    If MaxNode < NumNodes - 1 Then MaxNode = NumNodes - 1
    
    For i = 0 To NumNodes - 1
        NodeLabel(i).Visible = True
    Next i
    For i = NumNodes To MaxNode
        NodeLabel(i).Visible = False
    Next i
    
    ' Arrange the controls
    wid = NodeLabel(0).Width
    hgt = NodeLabel(0).Height
    y = (hgt + GAP) * (depth) + GAP
    x = CmdCreateTree.Left + _
        CmdCreateTree.Width + GAP
    For i = (NumNodes - 1) / 2 To NumNodes - 1
        Set Nodes(i) = NodeLabel(i)
        NodeLabel(i).Caption = Format$(i)
        NodeLabel(i).Move x, y
        x = x + wid + GAP
    Next i

    For i = (NumNodes - 3) / 2 To 0 Step -1
        Set Nodes(i) = NodeLabel(i)
        NodeLabel(i).Caption = Format$(i)
        x = (Nodes(2 * i + 1).Left + Nodes(2 * i + 2).Left) / 2
        y = Nodes(2 * i + 1).Top - hgt - GAP
        NodeLabel(i).Move x, y
    Next i
End Sub

Private Sub Form_Resize()
    ResultText.Width = ScaleWidth
End Sub

Private Sub mnuFileExit_Click()
    Unload Me
End Sub

' ************************************************
' Display help for this program.
' ************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String
    
    txt = "This program demonstrates different traversal orders for a full, complete binary tree." & vbCrLf & vbCrLf
    txt = txt & "Enter the tree depth and click the Create Tree button to build the tree. Then click one of the traversal buttons to display the tree's nodes in its different traversal orders."
    
    MsgBox txt, vbOKOnly, "Help About ... Trav1"
End Sub

' ************************************************
' Perform a postorder traversal of the tree.
' ************************************************
Private Function PostorderTraverse(node As Integer) As String
Dim txt As String

    txt = ""
    If 2 * node + 1 < NumNodes Then txt = txt & PostorderTraverse(2 * node + 1)
    If 2 * node + 2 < NumNodes Then txt = txt & PostorderTraverse(2 * node + 2)
    txt = txt & Str$(Nodes(node).Caption)
    PostorderTraverse = txt
End Function

' ************************************************
' Perform a preorder traversal of the tree.
' ************************************************
Private Function PreorderTraverse(node As Integer) As String
Dim txt As String

    txt = ""
    txt = txt & " " & Nodes(node).Caption
    If 2 * node + 1 < NumNodes Then txt = txt & PreorderTraverse(2 * node + 1)
    If 2 * node + 2 < NumNodes Then txt = txt & PreorderTraverse(2 * node + 2)
    PreorderTraverse = txt
End Function

