VERSION 4.00
Begin VB.Form Trav2Form 
   Appearance      =   0  'Flat
   Caption         =   "Trav2"
   ClientHeight    =   3990
   ClientLeft      =   2220
   ClientTop       =   1920
   ClientWidth     =   4965
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   4680
   Icon            =   "Trav2.frx":0000
   Left            =   2160
   LinkTopic       =   "Form1"
   ScaleHeight     =   3990
   ScaleWidth      =   4965
   Top             =   1290
   Width           =   5085
   Begin VB.CommandButton CmdPostorder 
      Caption         =   "Postorder"
      Height          =   375
      Left            =   0
      TabIndex        =   4
      Top             =   2280
      Width           =   1335
   End
   Begin VB.CommandButton CmdInorder 
      Caption         =   "Inorder"
      Height          =   375
      Left            =   0
      TabIndex        =   3
      Top             =   1800
      Width           =   1335
   End
   Begin VB.CommandButton CmdPreorder 
      Caption         =   "Preorder"
      Height          =   375
      Left            =   0
      TabIndex        =   2
      Top             =   1320
      Width           =   1335
   End
   Begin VB.TextBox ResultText 
      Height          =   615
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   1  'Horizontal
      TabIndex        =   6
      Text            =   "Trav2.frx":000C
      Top             =   3360
      Width           =   4935
   End
   Begin VB.CommandButton CmdBreadthFirst 
      Caption         =   "Breadth First"
      Height          =   375
      Left            =   0
      TabIndex        =   5
      Top             =   2760
      Width           =   1335
   End
   Begin VB.CommandButton CmdRemove 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Remove"
      Enabled         =   0   'False
      Height          =   375
      Left            =   0
      TabIndex        =   1
      Top             =   480
      Width           =   1335
   End
   Begin VB.CommandButton CmdAddChild 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Add Child"
      Enabled         =   0   'False
      Height          =   375
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1335
   End
   Begin VB.Label NodeLabel 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "0"
      Height          =   255
      Index           =   0
      Left            =   1440
      TabIndex        =   7
      Top             =   0
      Visible         =   0   'False
      Width           =   375
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "Trav2Form"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Trav2.FRM
'
' Main form for N-ary tree traversal example
' program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Const XGAP = 60
Const YGAP = 120

Dim Wid As Single
Dim Hgt As Single

' The root of the tree.
Dim Root As Trav2Node

' The currently selected node.
Dim SelectedNode As Trav2Node

' Index of last NodeLabel control loaded.
Dim MaxBox As Integer
' ************************************************
' Add this node's subtree to the string in
' inorder.
' ************************************************
Private Sub Inorder(node As Trav2Node, txt As String)
Dim mid As Integer
Dim i As Integer

    ' Visit the first half of the children.
    mid = (node.Children.Count + 1) \ 2
    For i = 1 To mid
        Inorder node.Children.Item(i), txt
    Next i

    ' Visit this node.
    txt = txt & node.Box.Caption & " "
    
    ' Visit the second half of the children.
    For i = mid + 1 To node.Children.Count
        Inorder node.Children.Item(i), txt
    Next i
End Sub
' ************************************************
' Add this node's subtree to the string in
' preorder.
' ************************************************
Private Sub Preorder(node As Trav2Node, txt As String)
Dim child As Trav2Node

    ' Visit this node.
    txt = txt & node.Box.Caption & " "
    
    ' Visit the children.
    For Each child In node.Children
        Preorder child, txt
    Next child
End Sub
' ************************************************
' Add this node's subtree to the string in
' postorder.
' ************************************************
Private Sub Postorder(node As Trav2Node, txt As String)
Dim child As Trav2Node

    ' Visit the children.
    For Each child In node.Children
        Postorder child, txt
    Next child

    ' Visit this node.
    txt = txt & node.Box.Caption & " "
End Sub

' ************************************************
' Add a new child to the selected node.
' ************************************************
Private Sub CmdAddChild_Click()
Dim new_node As New Trav2Node
    
    MaxBox = MaxBox + 1
    Load NodeLabel(MaxBox)
    With NodeLabel(MaxBox)
        .Caption = Format$(MaxBox)
        .BackColor = BackColor
        .ForeColor = ForeColor
    End With
    Set new_node.Box = NodeLabel(MaxBox)
    
    SelectedNode.Children.Add new_node
    
    SelectNode Nothing
    DisplayTree
    ResultText.Text = ""
End Sub

' ************************************************
' List the nodes in breadth first order.
' ************************************************
Private Sub CmdBreadthFirst_Click()
Dim txt As String
Dim queue As New Collection ' Collection-based queue.
Dim node As Trav2Node
Dim child As Trav2Node

    ' Start with the root in the queue.
    queue.Add Root

    ' Repeatedly process the top item in
    ' the queue until the queue is empty.
    Do While queue.Count > 0
        Set node = queue.Item(1)
        queue.Remove 1

        ' Visit the node
        txt = txt & node.Box.Caption & " "

        ' Add the node's children to the queue.
        For Each child In node.Children
            queue.Add child
        Next child
    Loop
    
    ResultText.Text = txt
End Sub

' ************************************************
' List the nodes in inorder.
' ************************************************
Private Sub CmdInorder_Click()
Dim txt As String

    Inorder Root, txt
    ResultText.Text = txt
End Sub
' ************************************************
' List the nodes in postorder.
' ************************************************
Private Sub CmdPostorder_Click()
Dim txt As String

    Postorder Root, txt
    ResultText.Text = txt
End Sub


' ************************************************
' List the nodes in preorder.
' ************************************************
Private Sub CmdPreorder_Click()
Dim txt As String

    Preorder Root, txt
    ResultText.Text = txt
End Sub


' *******************************************************
' Rmove the selected node and its descendants.
' *******************************************************
Private Sub CmdRemove_Click()
    If Not (SelectedNode Is Nothing) Then _
        Root.DeleteDescendant SelectedNode

    SelectNode Nothing
    DisplayTree
    ResultText.Text = ""
End Sub

' ************************************************
' Display the node at the indicated y value. Start
' the descendants of the node at xmin. Return the
' maximum x position used by this node through the
' parameter xmin.
' ************************************************
Private Sub DisplayNode(node As Trav2Node, xmin As Single, ByVal y As Single)
Dim x1 As Single
Dim y1 As Single
Dim child As Trav2Node

    If node Is Nothing Then Exit Sub

    ' First display the children
    y1 = y + Hgt + YGAP
    x1 = xmin
    
    If node.Children.Count < 1 Then
        x1 = x1 + Wid
    Else
        For Each child In node.Children
            DisplayNode child, x1, y1
            x1 = x1 + XGAP
        Next child
        x1 = x1 - XGAP
    End If
    
    ' Now display this node
    node.Box.Move (xmin + x1) / 2 - Wid / 2, y
    node.Box.Visible = True
    xmin = x1
End Sub

' ************************************************
' Display the entire tree by displaying the root
' node.
' ************************************************
Private Sub DisplayTree()
Dim xmin As Single

    xmin = CmdAddChild.Left + CmdAddChild.Width + 60
    DisplayNode Root, xmin, 0
    Refresh
End Sub

' ************************************************
' Draw lines between the center of each node and
' the centers of the node's children.
' ************************************************
Private Sub DrawLines(node As Trav2Node)
Dim x As Single
Dim y As Single
Dim child As Trav2Node

    If node Is Nothing Then Exit Sub
    
    x = node.Box.Left + node.Box.Width / 2
    y = node.Box.Top + node.Box.Height / 2
    
    ' Draw lines to children
    For Each child In node.Children
        DrawLines child
        Line (x, y)- _
            (child.Box.Left + child.Box.Width / 2, _
             child.Box.Top + child.Box.Height / 2)
    Next child
End Sub

Private Sub Form_Load()
    Wid = NodeLabel(0).Width
    Hgt = NodeLabel(0).Height
    
    ' Create the root node.
    Set Root = New Trav2Node
    Load NodeLabel(1)
    Set Root.Box = NodeLabel(1)
    NodeLabel(1).Caption = "1"
    MaxBox = 1
    
    DisplayTree
End Sub

' *******************************************************
' Draw lines between the nodes.
' *******************************************************
Private Sub Form_Paint()
    DrawLines Root
End Sub

' ************************************************
' Redirect control box unload to mnuExit.
' ************************************************
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Set SelectedNode = Nothing
    Set Root = Nothing
    Unload Me
End Sub

Private Sub Form_Resize()
    ResultText.Width = ScaleWidth
End Sub

Private Sub mnuFileExit_Click()
    Set SelectedNode = Nothing
    Set Root = Nothing
    Unload Me
End Sub

' *******************************************************
' Present help about this program.
' *******************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String
    
    txt = "This program demonstrates different traversal orders for an N-ary tree." & vbCrLf & vbCrLf
    txt = txt & "Add and remove nodes. Then click a traversal button to see different tree traversals."

    MsgBox txt, vbOKOnly, "Help About ... Trav2"
End Sub

' *******************************************************
' Select the node the user clicked on.
' *******************************************************
Private Sub NodeLabel_Click(Index As Integer)
    SelectNode Root.FindNode(NodeLabel(Index))
End Sub

' ************************************************
' Highlight this node.
' ************************************************
Private Sub SelectNode(node As Trav2Node)
    If Not (SelectedNode Is Nothing) Then
        SelectedNode.Box.BackColor = BackColor
        SelectedNode.Box.ForeColor = ForeColor
    End If

    Set SelectedNode = node
    
    If SelectedNode Is Nothing Then
        CmdRemove.Enabled = False
        CmdAddChild.Enabled = False
    Else
        SelectedNode.Box.BackColor = ForeColor
        SelectedNode.Box.ForeColor = BackColor
        CmdRemove.Enabled = _
            Not ((SelectedNode Is Nothing) Or _
                 (SelectedNode Is Root))
        CmdAddChild.Enabled = True
    End If
End Sub

