VERSION 4.00
Begin VB.Form TreesortForm 
   Appearance      =   0  'Flat
   Caption         =   "Treesort"
   ClientHeight    =   3990
   ClientLeft      =   2220
   ClientTop       =   1920
   ClientWidth     =   4095
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   4680
   Icon            =   "Treesort.frx":0000
   Left            =   2160
   LinkTopic       =   "Form1"
   ScaleHeight     =   3990
   ScaleWidth      =   4095
   Top             =   1290
   Width           =   4215
   Begin VB.CommandButton CmdAdd 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Add"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   495
      Left            =   1200
      TabIndex        =   4
      Top             =   0
      Width           =   1215
   End
   Begin VB.TextBox ValueText 
      Height          =   285
      Left            =   600
      TabIndex        =   3
      Top             =   120
      Width           =   495
   End
   Begin VB.CommandButton CmdRemove 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Cancel          =   -1  'True
      Caption         =   "Remove"
      Enabled         =   0   'False
      Height          =   495
      Left            =   2520
      TabIndex        =   0
      Top             =   0
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Value"
      Height          =   255
      Left            =   0
      TabIndex        =   2
      Top             =   120
      Width           =   495
   End
   Begin VB.Label NodeLabel 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "0"
      Height          =   255
      Index           =   0
      Left            =   0
      TabIndex        =   1
      Top             =   600
      Visible         =   0   'False
      Width           =   375
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "TreesortForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Treesort.FRM
'
' Main form for sorted tree example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Const XGAP = 60
Const YGAP = 120

Dim Wid As Single
Dim Hgt As Single

' The root of the tree.
Dim Root As SortNode

' Index of last NodeLabel control loaded.
Dim MaxBox As Integer


' ************************************************
' Add a new node to the tree.
' ************************************************
Private Sub InsertItem(node As SortNode, new_value As Integer)
Dim child As SortNode

    If node Is Nothing Then
        ' We have reached a leaf.
        ' Insert the item here.
        Set node = New SortNode
        node.Value = new_value
        MaxBox = MaxBox + 1
        Load NodeLabel(MaxBox)
        Set node.Box = NodeLabel(MaxBox)
        With NodeLabel(MaxBox)
            .Caption = Format$(new_value)
            .Visible = True
        End With
    ElseIf new_value <= node.Value Then
        ' Branch left.
        Set child = node.LeftChild
        InsertItem child, new_value
        Set node.LeftChild = child
    Else
        ' Branch right.
        Set child = node.RightChild
        InsertItem child, new_value
        Set node.RightChild = child
    End If
End Sub
' ************************************************
' Remove an item from the tree.
' ************************************************
Private Sub DeleteItem(node As SortNode, target_value As Integer)
Dim target As SortNode
Dim child As SortNode

    ' If we did not find the item, say so.
    If node Is Nothing Then
        Beep
        MsgBox "Item " & Format$(target_value) & _
            " is not in the tree."
        Exit Sub
    End If

    If target_value < node.Value Then
        ' Continue down left subtree.
        Set child = node.LeftChild
        DeleteItem child, target_value
        Set node.LeftChild = child
    ElseIf target_value > node.Value Then
        ' Continue down right subtree.
        Set child = node.RightChild
        DeleteItem child, target_value
        Set node.RightChild = child
    Else
        ' This is the target.
        Set target = node
        If target.LeftChild Is Nothing Then
            ' Replace target with its right child.
            Set node = node.RightChild
        ElseIf target.RightChild Is Nothing Then
            ' Replace target with its left child.
            Set node = node.LeftChild
        Else
            ' Call ReplaceRightmost to replace
            ' target with the rightmost node
            ' to its left.
            Set child = node.LeftChild
            ReplaceRightmost node, child
            Set node.LeftChild = child
        End If
    End If
End Sub

' ************************************************
' Replace target with the rightmost item below
' repl.
' ************************************************
Private Sub ReplaceRightmost(target As SortNode, repl As SortNode)
Dim old_repl As SortNode
Dim child As SortNode

    If Not (repl.RightChild Is Nothing) Then
        ' Move farther down to the right.
        Set child = repl.RightChild
        ReplaceRightmost target, child
        Set repl.RightChild = child
    Else
        ' We've reached the bottom.
        ' Remember what node repl is.
        Set old_repl = repl
        
        ' Replace repl with its left child.
        Set repl = repl.LeftChild
        
        ' Replace the target with repl.
        Set old_repl.LeftChild = target.LeftChild
        Set old_repl.RightChild = target.RightChild
        Set target = old_repl
    End If
End Sub
' ************************************************
' Add a node.
' ************************************************
Private Sub CmdAdd_Click()
Dim new_value As Integer

    new_value = CInt(ValueText.Text)
    InsertItem Root, new_value

    DisplayTree
    ValueText.Text = ""
    ValueText.SetFocus
End Sub
' ************************************************
' Rmove the indicated node.
' ************************************************
Private Sub CmdRemove_Click()
Dim target_value As Integer

    target_value = CInt(ValueText.Text)
    DeleteItem Root, target_value
    
    DisplayTree
    ValueText.Text = ""
    ValueText.SetFocus
End Sub

' ************************************************
' Display the node at the indicated y value. Start
' the descendants of the node at xmin. Return the
' maximum x position used by this node through the
' parameter xmin.
' ************************************************
Private Sub DisplayNode(node As SortNode, xmin As Single, ByVal y As Single)
Dim x1 As Single
Dim y1 As Single
Dim child As SortNode

    If node Is Nothing Then Exit Sub

    ' First display the children
    y1 = y + Hgt + YGAP
    x1 = xmin
    Set child = node.LeftChild
    If child Is Nothing Then
        x1 = x1 + Wid
    Else
        DisplayNode child, x1, y1
    End If

    Set child = node.RightChild
    If child Is Nothing Then
        If Not (node.LeftChild Is Nothing) _
            Then x1 = x1 + Wid + XGAP
    Else
        x1 = x1 + XGAP
        DisplayNode child, x1, y1
    End If

    ' Now display this node
    node.Box.Move (xmin + x1) / 2 - Wid / 2, y
    node.Box.Visible = True
    xmin = x1
End Sub

' ************************************************
' Display the entire tree by displaying the root
' node.
' ************************************************
Private Sub DisplayTree()
Dim xmin As Single

    xmin = 0
    DisplayNode Root, xmin, NodeLabel(0).Top
    Refresh
End Sub

' ************************************************
' Draw lines between the center of each node and
' the centers of the node's children.
' ************************************************
Private Sub DrawLines(node As SortNode)
Dim x As Single
Dim y As Single
Dim child As SortNode

    If node Is Nothing Then Exit Sub
    
    x = node.Box.Left + node.Box.Width / 2
    y = node.Box.Top + node.Box.Height / 2
    
    DrawLines node.LeftChild
    DrawLines node.RightChild

    ' Draw lines to children
    Set child = node.LeftChild
    If Not (child Is Nothing) Then _
        Line (x, y)- _
            (child.Box.Left + child.Box.Width / 2, _
             child.Box.Top + child.Box.Height / 2)
    
    Set child = node.RightChild
    If Not (child Is Nothing) Then _
        Line (x, y)-( _
            child.Box.Left + child.Box.Width / 2, _
            child.Box.Top + child.Box.Height / 2)
End Sub

Private Sub Form_Load()
    Wid = NodeLabel(0).Width
    Hgt = NodeLabel(0).Height
    
    DisplayTree
End Sub

' *******************************************************
' Draw lines between the nodes.
' *******************************************************
Private Sub Form_Paint()
    DrawLines Root
End Sub

' ************************************************
' Redirect control box unload to mnuExit.
' ************************************************
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Set Root = Nothing
    Unload Me
End Sub

Private Sub mnuFileExit_Click()
    Set Root = Nothing
    Unload Me
End Sub

' *******************************************************
' Present help about this program.
' *******************************************************
Private Sub mnuHelpAbout_Click()
Dim txt As String
    
    txt = "This program allows you to manipulate a sorted binary tree." & vbCrLf & vbCrLf
    txt = txt & "Enter a number and click the Add button to add an item to the tree." & vbCrLf & vbCrLf
    txt = txt & "Enter a number and click the Remove button to remove an item from the tree."
    
    MsgBox txt, vbOKOnly, "Help About ... Treesort"
End Sub

Private Sub ValueText_Change()
    CmdAdd.Enabled = (ValueText.Text <> "")
    CmdRemove.Enabled = CmdAdd.Enabled
End Sub


