VERSION 4.00
Begin VB.Form TreeForm 
   Appearance      =   0  'Flat
   Caption         =   "AVL"
   ClientHeight    =   3990
   ClientLeft      =   1320
   ClientTop       =   1725
   ClientWidth     =   7365
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   4680
   Icon            =   "AVL.frx":0000
   Left            =   1260
   LinkTopic       =   "Form1"
   ScaleHeight     =   3990
   ScaleWidth      =   7365
   Top             =   1095
   Width           =   7485
   Begin VB.CommandButton CmdAdd 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Add"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   375
      Left            =   840
      TabIndex        =   1
      Top             =   120
      Width           =   855
   End
   Begin VB.CommandButton CmdRemove 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Cancel          =   -1  'True
      Caption         =   "Remove"
      Enabled         =   0   'False
      Height          =   375
      Left            =   1800
      TabIndex        =   2
      Top             =   120
      Width           =   855
   End
   Begin VB.TextBox ItemText 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   615
   End
   Begin VB.Label NodeLabel 
      BorderStyle     =   1  'Fixed Single
      Caption         =   "0"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   3
      Top             =   600
      Visible         =   0   'False
      Width           =   615
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "TreeForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' AVL.FRM
'
' Main form for AVL tree example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Const XGAP = 60
Const YGAP = 120

Dim Wid As Single
Dim Hgt As Single

Dim Root As AVLNode

Dim MaxLabel As Integer
' ************************************************
' Add a node to the tree.
' ************************************************
Private Sub CmdAdd_Click()
Dim txt As String
Dim has_grown As Boolean
Dim node As New AVLNode

    txt = Trim$(ItemText.Text)
    If txt = "" Then
        Beep
        Exit Sub
    End If
    ItemText.Text = ""

    ' Create a new label for display.
    MaxLabel = MaxLabel + 1
    Load NodeLabel(MaxLabel)
    Set node.Box = NodeLabel(MaxLabel)
    node.Box.Caption = txt
    node.Box.Visible = True

    ' If this is the first item, put it in the root
    If Root Is Nothing Then
        Set Root = node
    Else
        ' Add the new item.
        InsertItem node, Root, txt, has_grown
    End If
    
    DisplayTree
End Sub

' ************************************************
' Remove a node from the tree.
' ************************************************
Private Sub CmdRemove_Click()
Dim txt As String
Dim shrunk As Boolean
    
    txt = Trim$(ItemText.Text)
    If txt = "" Then
        Beep
        Exit Sub
    End If
    ItemText.Text = ""

    DeleteItem Root, txt, shrunk
    
    DisplayTree
End Sub

' ************************************************
' Display the node at the indicated y value. Start
' the decendants of the node at xmin. Return the
' maximum x position used by this node through
' the parameter xmin.
' ************************************************
Private Sub DisplayNode(node As AVLNode, xmin As Single, ByVal y As Single)
Dim x1 As Single
Dim y1 As Single
Dim child As AVLNode

    If node Is Nothing Then Exit Sub

    ' First display the children.
    y1 = y + Hgt + YGAP
    x1 = xmin
    Set child = node.LeftChild
    If Not (child Is Nothing) Then
        DisplayNode child, x1, y1
    Else
        x1 = x1 + Wid
    End If

    Set child = node.RightChild
    If Not (child Is Nothing) Then
        x1 = x1 + XGAP
        DisplayNode child, x1, y1
    Else
        If Not (node.LeftChild Is Nothing) _
            Then x1 = x1 + Wid + XGAP
    End If

    ' Display the node.
    node.Box.Move (xmin + x1) / 2 - Wid / 2, y
    node.Box.Visible = True
    xmin = x1
End Sub

' ************************************************
' Display the tree by displaying the root node.
' ************************************************
Private Sub DisplayTree()
Dim xmin As Single

    If Root Is Nothing Then Exit Sub
    xmin = NodeLabel(0).Left
    DisplayNode Root, xmin, NodeLabel(0).Top
    Refresh
End Sub

' ************************************************
' Draw lines connecting the nodes.
' ************************************************
Private Sub DrawLines(node As AVLNode)
Dim x As Single
Dim y As Single
Dim child As AVLNode

    If node Is Nothing Then Exit Sub
    
    x = node.Box.Left + node.Box.Width / 2
    y = node.Box.Top + node.Box.Height / 2
    
    DrawLines node.LeftChild
    DrawLines node.RightChild

    ' Draw lines to children
    Set child = node.LeftChild
    If Not (child Is Nothing) Then
        Line (x, y)-(child.Box.Left + child.Box.Width / 2, child.Box.Top + child.Box.Height / 2)
    End If
    
    Set child = node.RightChild
    If Not (child Is Nothing) Then
        Line (x, y)-(child.Box.Left + child.Box.Width / 2, child.Box.Top + child.Box.Height / 2)
    End If
End Sub

Private Sub Form_Load()
    Wid = NodeLabel(0).Width
    Hgt = NodeLabel(0).Height
    
    DisplayTree
End Sub

Private Sub Form_Paint()
    If Root Is Nothing Then Exit Sub
    DrawLines Root
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Set Root = Nothing
End Sub

Private Sub ItemText_Change()
    If Trim$(ItemText.Text) <> "" Then
        CmdAdd.Enabled = True
        CmdRemove.Enabled = Not (Root Is Nothing)
    Else
        CmdAdd.Enabled = False
        CmdRemove.Enabled = False
    End If
End Sub

Private Sub ItemText_KeyPress(KeyAscii As Integer)
Const KEY_BACK = &H8
Const KEY_DELETE = &H2E
    
    If KeyAscii = KEY_DELETE Or KeyAscii = KEY_BACK Then Exit Sub

    KeyAscii = Asc(UCase(Chr$(KeyAscii)))
    If (KeyAscii < Asc("A") Or KeyAscii > Asc("Z")) And (KeyAscii < Asc("0") Or KeyAscii > Asc("9")) Then KeyAscii = 0
End Sub

Private Sub mnuFileExit_Click()
    Set Root = Nothing
    Unload Me
End Sub

Private Sub mnuHelpAbout_Click()
Dim txt As String
    
    txt = "This program allows you to manage an AVL tree." & vbCrLf & vbCrLf
    txt = txt & "Enter a string and click the Add button to add the item to the tree." & vbCrLf & vbCrLf
    txt = txt & "Enter a string and click the Remove button to remove the item from the tree."
    
    MsgBox txt, vbOKOnly, "Help About ... AVL"
End Sub

