VERSION 4.00
Begin VB.Form BTreeForm 
   Appearance      =   0  'Flat
   Caption         =   "Btree"
   ClientHeight    =   4005
   ClientLeft      =   2535
   ClientTop       =   975
   ClientWidth     =   4470
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   4695
   Icon            =   "Btree.frx":0000
   Left            =   2475
   LinkTopic       =   "Form1"
   ScaleHeight     =   4005
   ScaleWidth      =   4470
   Top             =   345
   Width           =   4590
   Begin VB.TextBox TreeText 
      BackColor       =   &H8000000F&
      Height          =   3975
      Left            =   960
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   0
      Width           =   3495
   End
   Begin VB.CommandButton CmdAdd 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Add"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   375
      Left            =   0
      TabIndex        =   1
      Top             =   360
      Width           =   855
   End
   Begin VB.CommandButton CmdRemove 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Cancel          =   -1  'True
      Caption         =   "Remove"
      Enabled         =   0   'False
      Height          =   375
      Left            =   0
      TabIndex        =   2
      Top             =   840
      Width           =   855
   End
   Begin VB.TextBox ItemText 
      Height          =   285
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   855
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About This Program..."
      End
   End
End
Attribute VB_Name = "BTreeForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' ************************************************
' Btree.FRM
'
' Main form for B-tree example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Private Root As BtreeNode
' ************************************************
' Add an item to the tree.
' ************************************************
Private Sub CmdAdd_Click()
Dim txt As String

    txt = Trim$(ItemText.Text)
    If txt = "" Then
        Beep
        Exit Sub
    End If
    ItemText.Text = ""

    InsertItem Root, txt
    
    DisplayTree
End Sub

' ************************************************
' Remove an item from the tree.
' ************************************************
Private Sub CmdRemove_Click()
Dim txt As String
Dim too_small As Integer
    
    txt = Trim$(ItemText.Text)
    If txt = "" Then
        Beep
        Exit Sub
    End If
    ItemText.Text = ""

    DeleteItem Root, txt

    DisplayTree
End Sub

' ************************************************
' Display a node.
' ************************************************
Private Sub DisplayNode(txt As String, node As BtreeNode, spaces As Single)
Dim i As Integer

    If node Is Nothing Then Exit Sub

    DisplayNode txt, node.Child(0), spaces + 2
    
    For i = 1 To node.NumKeys
        txt = txt & Space$(spaces) & node.Key(i) & vbCrLf
        DisplayNode txt, node.Child(i), spaces + 2
    Next i
End Sub

' ************************************************
' Display the tree by displaying the root.
' ************************************************
Private Sub DisplayTree()
Dim txt As String

    txt = ""
    DisplayNode txt, Root, 0
    TreeText.Text = txt
    Refresh
End Sub

Private Sub Form_Load()
    DisplayTree
End Sub

' ************************************************
' Make the result text area as large as possible.
' ************************************************
Private Sub Form_Resize()
Dim wid As Single

    wid = ScaleWidth - TreeText.Left
    If wid < 240 Then wid = 240
    TreeText.Move TreeText.Left, 0, wid, ScaleHeight
End Sub

Private Sub ItemText_Change()
    If Trim$(ItemText.Text) <> "" Then
        CmdAdd.Enabled = True
        CmdRemove.Enabled = Not (Root Is Nothing)
    Else
        CmdAdd.Enabled = False
        CmdRemove.Enabled = False
    End If
End Sub

Private Sub ItemText_KeyPress(KeyAscii As Integer)
Const KEY_BACK = &H8
Const KEY_DELETE = &H2E
    
    If KeyAscii = KEY_DELETE Or KeyAscii = KEY_BACK Then Exit Sub

    KeyAscii = Asc(UCase(Chr$(KeyAscii)))
    If (KeyAscii < Asc("A") Or KeyAscii > Asc("Z")) And (KeyAscii < Asc("0") Or KeyAscii > Asc("9")) Then KeyAscii = 0
End Sub

Private Sub mnuFileExit_Click()
    Unload Me
End Sub

Private Sub mnuHelpAbout_Click()
Dim txt As String
    
    txt = "This program allows you to managed a B-tree." & vbCrLf & vbCrLf
    txt = txt & "Enter a string and click the Add button to add the item to the tree." & vbCrLf & vbCrLf
    txt = txt & "Enter a string and click the Remove button to remove the item from the tree."
    
    MsgBox txt, vbOKOnly, "Help About ... Btree"
End Sub

