Attribute VB_Name = "StringEncodings"
' ************************************************
' Encode.BAS
'
' Code for encoded string sorting example program.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

Global Const STRING_BASE = 27
Global Const ASC_A = 65        ' ASCII code for "A"

Global Const DBL_strlen = 10
Global Const LONG_strlen = 6
Global Const INT_strlen = 3

' ************************************************
' Turn a double string encoding back into a
' string.
' ************************************************
Function DblToString(ByVal value As Double) As String
Dim strlen As Integer
Dim i As Integer
Dim txt As String
Dim power As Integer
Dim ch As Integer
Dim new_value As Double

    txt = ""
    Do While value > 0
        new_value = Int(value / STRING_BASE)
        ch = value - new_value * STRING_BASE
        If ch <> 0 Then txt = Chr$(ch + ASC_A - 1) + txt
        value = new_value
    Loop
    DblToString = txt
End Function

' ************************************************
' Convert a string into a double encoding.
'
' full_len gives the full length of the string.
' For example, "AX" as a three character string
' would have full_len = 3.
' ************************************************
Function StringToDbl(txt As String, full_len As Integer)
Dim strlen As Integer
Dim i As Integer
Dim value As Double
Dim ch As String * 1
    
    strlen = Len(txt)
    If strlen > full_len Then strlen = full_len
    
    value = 0#
    For i = 1 To strlen
        ch = Mid$(txt, i, 1)
        value = value * STRING_BASE + Asc(ch) - ASC_A + 1
    Next i

    For i = strlen + 1 To full_len
        value = value * STRING_BASE
    Next i

    StringToDbl = value
End Function

