Attribute VB_Name = "BubblesortStuff"
' ************************************************
' FBubble.BAS
'
' Source code for bubblesort using MemCopy.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

' ************************************************
' Bubblesort with:
'   - Alternating upward and downward passes
'   - Holding bubbled item in a temporary
'       variable
'   - Updating min and max to narrow the search
'       range
' ************************************************
Public Sub Bubblesort(List() As Long, ByVal min As Long, ByVal max As Long)
Dim last_swap As Long
Dim i As Long
Dim j As Long
Dim tmp As Long
    
    ' Repeat until we are done.
    Do While min < max
        ' Bubble up.
        last_swap = min - 1
        ' For i = min + 1 To max
        i = min + 1
        Do While i <= max
            ' Find a bubble.
            If List(i - 1) > List(i) Then
                tmp = List(i - 1)
                ' See where this item belongs.
                For j = i + 1 To max
                    If tmp <= List(j) Then Exit For
                Next j
                j = j - 1
                ' List(i - 1) belongs in position j.
                MemCopy List(i - 1), List(i), _
                    Len(tmp) * (j - i + 1)
                List(j) = tmp
                last_swap = j
                i = j + 1
            Else
                i = i + 1
            End If
        Loop
        ' Update max.
        max = last_swap - 1
        
        ' Bubble down.
        last_swap = max + 1
        ' For i = max - 1 To min Step -1
        i = max - 1
        Do While i >= min
            ' Find a bubble.
            If List(i + 1) < List(i) Then
                tmp = List(i + 1)
                ' See where this item belongs.
                For j = i - 1 To min Step -1
                    If tmp >= List(j) Then Exit For
                Next j
                j = j + 1
                ' List(i + 1) belongs in position j.
                MemCopy List(j + 1), List(j), _
                    Len(tmp) * (i - j + 1)
                List(j) = tmp
                last_swap = j
                i = j - 1
            Else
                i = i - 1
            End If
        Loop
        ' Update min.
        min = last_swap + 1
    Loop
End Sub

