Attribute VB_Name = "MergesortStuff"
' ************************************************
' FMerge.BAS
'
' Source code for mergesort using MemCopy.
' ************************************************
' Copyright (C) 1997 John Wiley & Sons, Inc.
' All rights reserved. See additional copyright
' information in RIGHTS.TXT.
' ************************************************
Option Explicit

' ************************************************
' Mergesort with:
'   - Stops recursion when there are fewer than
'       CutOff items in the list. Finishes with
'       SelectionSort.
' ************************************************
Public Sub Mergesort(List() As Long, Scratch() As Long, ByVal min As Long, ByVal max As Long)
Dim middle As Long
Dim i1 As Long
Dim i2 As Long
Dim i3 As Long

    ' If the list has no more than CutOff elements,
    ' finish it off with SelectionSort.
    If max - min < CutOff Then
        Selectionsort List(), min, max
        Exit Sub
    End If
    
    ' Recursively sort the sublists.
    middle = max \ 2 + min \ 2
    Mergesort List(), Scratch(), min, middle
    Mergesort List(), Scratch(), middle + 1, max

    ' Merge the sorted lists.
    i1 = min        ' Index in list 1
    i2 = middle + 1 ' Index in list 2
    i3 = min        ' Index in merged list
    Do While i1 <= middle And i2 <= max
        If List(i1) <= List(i2) Then
            Scratch(i3) = List(i1)
            i1 = i1 + 1
        Else
            Scratch(i3) = List(i2)
            i2 = i2 + 1
        End If
        i3 = i3 + 1
    Loop

    ' Empty out whichever list is not already empty.
    Do While i1 <= middle
        Scratch(i3) = List(i1)
        i1 = i1 + 1
        i3 = i3 + 1
    Loop
    Do While i2 <= max
        Scratch(i3) = List(i2)
        i2 = i2 + 1
        i3 = i3 + 1
    Loop

    ' Move the merged list back into list.
    MemCopy List(min), Scratch(min), _
        Len(i1) * (max - min + 1)
End Sub

